Package: IHWpaper
Title: Reproduce figures in IHW paper
Version: 1.40.0
Authors@R: person("Nikos", "Ignatiadis", email =
        "nikos.ignatiadis01@gmail.com", role = c("aut", "cre"))
Description: This package conveniently wraps all functions needed to
        reproduce the figures in the IHW paper (https://www.nature.com/articles/nmeth.3885) and the data 
        analysis in https://rss.onlinelibrary.wiley.com/doi/10.1111/rssb.12411,
        cf. the arXiv preprint (http://arxiv.org/abs/1701.05179). Thus
        it is a companion package to the Bioconductor IHW package.
Depends: R (>= 3.3), IHW
License: Artistic-2.0
LinkingTo: Rcpp
Imports: Rcpp, stats, splines, methods, utils, DESeq2,
        SummarizedExperiment, fdrtool, genefilter, qvalue, Biobase,
        BiocGenerics, BiocParallel, dplyr, grid, ggplot2, cowplot
VignetteBuilder: knitr
biocViews: ReproducibleResearch, ExperimentData, RNASeqData,
        ExpressionData
RoxygenNote: 7.1.2
Suggests: testthat, RColorBrewer, wesanderson, scales, gridExtra,
        BiocStyle, knitr, rmarkdown, airway, locfdr, tidyr, latex2exp
NeedsCompilation: yes
Author: Nikos Ignatiadis [aut, cre]
Maintainer: Nikos Ignatiadis <nikos.ignatiadis01@gmail.com>
git_url: https://git.bioconductor.org/packages/IHWpaper
git_branch: RELEASE_3_23
git_last_commit: 8a1ff48
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-05-05
Packaged: 2026-05-05 15:29:12 UTC; biocbuild

# IHWpaper

This is a package which reproduces all IHW paper figures (as well as some additional figures for presentations etc.). The package is available on [Bioconductor](http://bioconductor.org/packages/release/data/experiment/html/IHWpaper.html).


# Installing the package and reproducing all simulations

You can install the package as follows:

```{r}
# install FDRreg (at specific version used for simulations here)
install_github(repo= "jgscott/FDRreg", subdir="R_pkg/", ref = "a63cebae6faecb1fb0ebee634195296f39faa11b")
# Use Bioconductor to install IHWpaper
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("IHWpaper")
```

Afterwards you can view the pre-built vignettes or rebuild them yourself.

Notice that the vignettes load binary .Rds files which are stored in `inst/real_data_examples/result_files`
and `inst/simulations_benchmarks/result_files`. These have been generated by longer lasting jobs, the code for which can be found in `inst/real_data_examples` and `inst/simulation_benchmarks`.

*IHWpaper/inst/extdata/real_data/bottomly_eset.RData
From Recount project (http://bowtie-bio.sourceforge.net/recount/)

*IHWpaper/inst/extdata/real_data/hammer_eset.RData
From Recount project (http://bowtie-bio.sourceforge.net/recount/)

*IHWpaper/inst/extdata/real_data/science_signaling.csv
Proteomics example, Csv extracted from "2002548TableS1.xlsx" table in supplementary materials for:
Hyperplexing: A Method for Higher-Order Multiplexed Quantitative Proteomics Provides 
a Map of the Dynamic Response to Rapamycin in Yeast
Noah Dephoure and Steven P. Gygi*
(http://stke.sciencemag.org/content/5/217)

*IHWpaper/inst/extdata/real_data/hqtl_pvalue_filtered.Rds
For the hQTL example, here only p-values <= 0.005 are retained and the columns
pvalue, dist and group  (pvalue for the snp-peak pair, distance of that pair
and stratum into which it was categorized based on distance). The original number
of hypotheses in each stratum are stored in the attribute "m_groups".


```r
#full data-frame with all hypotheses (a few GB), not made available here

hqtl <- readRDS("qtls_chrom_21.Rds")

my_breaks <- c(-1,
               seq(from=10000,to=290000, by=10000) , 
               seq(from=300000, to=0.9*10^6, by=100000),
               seq(from=10^6, to=50*10^6, by=10^7))

hqtl <- mutate(hqtl, group=cut(dist, my_breaks))

m_groups <- table(hqtl$group)

hqtl_filt <- filter(hqtl, pvalue <= 5*10^(-3)) %>%
             select(pvalue, dist, group)

attr(hqtl_filt, "m_groups") <- m_groups
attr(hqtl_filt, "breaks") <- my_breaks


saveRDS(hqtl_filt, file="hqtl_pvalue_filtered.Rds")
```

## ----warning=FALSE, message=FALSE---------------------------------------------
library(dplyr)
library(IHW)
library(fdrtool)
library(ggplot2)
library(cowplot)
theme_set(theme_cowplot())
library(tidyr)
library(scales)
library(latex2exp)

## -----------------------------------------------------------------------------
file_loc <- system.file("extdata","real_data", "hqtl_chrom1_chrom2", package = "IHWpaper")

## -----------------------------------------------------------------------------
chr1_df <- readRDS(file.path(file_loc, "chr1_subset.Rds"))
chr2_df <- readRDS(file.path(file_loc, "chr2_subset.Rds"))

## -----------------------------------------------------------------------------
pval_threshold <- 10^(-4)

## -----------------------------------------------------------------------------
snp_chr1 <- readRDS(file.path(file_loc, "snppos_chr1.Rds"))
snp_chr2 <-  readRDS(file.path(file_loc, "snppos_chr2.Rds"))

all_peaks <- readRDS(file.path(file_loc, "peak_locations.Rds"))
peaks_chr1 <- dplyr::filter(all_peaks, chr=="chr1")
peaks_chr2 <- dplyr::filter(all_peaks, chr=="chr2")

## -----------------------------------------------------------------------------
chr1_df <- left_join(chr1_df, select(snp_chr1, snp, pos), by=(c("SNP"="snp"))) %>%
       left_join(peaks_chr1, by=(c("gene"="id"))) %>%
       mutate( dist = pmin( abs(pos-start), abs(pos-end)))

chr2_df <- left_join(chr2_df, select(snp_chr2, snp, pos), by=(c("SNP"="snp"))) %>%
       left_join(peaks_chr2, by=(c("gene"="id"))) %>%
       mutate( dist = pmin( abs(pos-start), abs(pos-end)))

## -----------------------------------------------------------------------------
my_breaks <- c(-1, 
                 seq(from=10000,to=290000, by=10000) , 
                 seq(from=300000, to=0.9*10^6, by=100000),
                 seq(from=10^6, to=25.1*10^7, by=10^7))
myf1 <- cut(chr1_df$dist, my_breaks)
myf2 <- cut(chr2_df$dist, my_breaks)

## ----eval=FALSE---------------------------------------------------------------
# cnt = 0
# ms <- rep(0, length(levels(myf1)))
# pb = txtProgressBar(min = 0, max = nrow(peaks_chr1), initial = 0)
# 
# for (i in 1:nrow(peaks_chr1)){
#   setTxtProgressBar(pb,i)
#   start_pos <- peaks_chr1$start[i]
#   end_pos <- peaks_chr1$end[i]
#   dist_vec <- pmin( abs(snp_chr1$pos - start_pos), abs(snp_chr1$pos - end_pos) )
#   ms <- ms + table(cut(dist_vec, my_breaks))
# }
# 
# saveRDS( ms, file = "m_groups_chr1.Rds" )
# 
# 
# cnt = 0
# ms_chr2 <- table(myf2)*0
# pb = txtProgressBar(min = 0, max = nrow(peaks_chr2), initial = 0)
# 
# for (i in 1:nrow(peaks_chr2)){
#   setTxtProgressBar(pb,i)
#   start_pos <- peaks_chr1$start[i]
#   end_pos <- peaks_chr1$end[i]
#   dist_vec <- pmin( abs(snp_chr2$pos - start_pos), abs(snp_chr2$pos - end_pos) )
#   ms_chr2 <- ms_chr2 + table(cut(dist_vec, my_breaks))
# }
# 
# saveRDS( ms_chr2, file = "m_groups_chr2.Rds" )

## -----------------------------------------------------------------------------
ms_chr1 <- readRDS(file.path(file_loc, "m_groups_chr1.Rds"))
ms_chr2 <- readRDS(file.path(file_loc, "m_groups_chr2.Rds"))

## -----------------------------------------------------------------------------
chr1_chr2_df <- rbind(chr1_df, chr2_df)
chr1_chr2_groups <- as.factor(c(myf1,myf2))
folds_vec <- as.factor(c(rep(1, nrow(chr1_df)), rep(2, nrow(chr2_df))))
m_groups <- cbind(ms_chr1, ms_chr2)

## -----------------------------------------------------------------------------
m <- sum(m_groups) #total number of hypotheses
m

## -----------------------------------------------------------------------------
beyonce_colors <- c("#b72da0", "#7c5bd2", "#0097ed","#00c6c3",
                   "#9cd78a", "#f7f7a7", "#ebab5f", "#e24344",
                   "#04738d")#,"#d8cdc9")
beyonce_colors[6] <- c("#dbcb09") # thicker yellow
pretty_colors <- beyonce_colors[c(2,1,3:5)]

## -----------------------------------------------------------------------------
qs <- c(0.025, 0.05)
cutoffs <- c(0, quantile(chr1_chr2_df$dist,qs), Inf)
cov_scatter_gg <- ggplot(chr1_chr2_df, aes(x=rank(dist)/nrow(chr1_chr2_df),
                                           y=-log10(pvalue))) +
     geom_bin2d(bins=150, drop=TRUE) + #  geom_point(alpha=0.2, col=pretty_colors[1]) +
     geom_vline(xintercept=qs, linetype="dashed") + 
     ylab(expression(paste(-log[10],"(p-value)"))) +
     xlab(expression(paste("Quantile of distance"))) + 
     scale_fill_gradientn(trans="log10", colors=alpha(pretty_colors[1], c(0.2,1)))
cov_scatter_gg

## ----eval=FALSE---------------------------------------------------------------
# ggsave(cov_scatter_gg, filename="cov_scatter_gg.pdf", width=4,height=3)

## -----------------------------------------------------------------------------
chr1_chr2_df$cutoff_groups <- cut(chr1_chr2_df$dist, cutoffs)
table(chr1_chr2_df$cutoff_groups)

## -----------------------------------------------------------------------------
gg_marginal_hist <- ggplot(chr1_chr2_df, aes(x=pvalue*10^4)) + 
         geom_histogram(aes(y=..density..), alpha=0.5, binwidth=0.05, boundary = 0, colour="black",fill=pretty_colors[1]) +
          scale_x_continuous(expand = c(0.02, 0), breaks=c(0,0.5,1)) + 
          scale_y_continuous(expand = c(0.02, 0), limits=c(0,2.5)) + 
          ylab(expression(paste("Density")))+
          xlab(TeX("p-value ($\\times 10^{-4}$)")) 
gg_marginal_hist

## ----eval=FALSE---------------------------------------------------------------
# ggsave(gg_marginal_hist, filename="gg_marginal_hist.pdf", width=4,height=3)

## -----------------------------------------------------------------------------
gg_stratified_hist <- ggplot(chr1_chr2_df, aes(x=pvalue*10^4)) + 
         geom_histogram(aes(y=..density..), alpha=0.5, binwidth=0.05, boundary = 0, colour="black",fill=pretty_colors[1]) +
          scale_x_continuous(expand = c(0.02, 0), breaks=c(0,0.5,1)) + 
          scale_y_continuous(expand = c(0.02, 0), limits=c(0,11)) + 
          ylab("Density")+
          xlab(TeX("p-value ($\\times 10^{-4}$)")) +
          facet_grid(~cutoff_groups) + 
          theme(strip.background = element_blank(), strip.text.y = element_blank()) + 
          theme(panel.spacing = unit(2, "lines"))
gg_stratified_hist      

## ----eval=FALSE---------------------------------------------------------------
# ggsave(gg_stratified_hist, filename="gg_stratified_hist.pdf", width=7,height=3)

## -----------------------------------------------------------------------------
alpha <- .01/(log(m)+1)

## -----------------------------------------------------------------------------
ihw_chr1_chr2 <- ihw(chr1_chr2_df$pvalue, chr1_chr2_groups, alpha, folds=folds_vec,
                     m_groups=m_groups, lambdas=2000)

## -----------------------------------------------------------------------------
sum(p.adjust(chr1_chr2_df$pvalue, n = m, method="BH") <= alpha)

## -----------------------------------------------------------------------------
rejections(ihw_chr1_chr2)

## -----------------------------------------------------------------------------
alpha_bh <- 0.01
ihw_chr1_chr2_bh <- ihw(chr1_chr2_df$pvalue, chr1_chr2_groups, alpha_bh,
                        folds=folds_vec, m_groups=m_groups, lambdas=2000)

## -----------------------------------------------------------------------------
sum(p.adjust(chr1_chr2_df$pvalue, n = m, method="BH") <= alpha_bh)

## -----------------------------------------------------------------------------
rejections(ihw_chr1_chr2_bh)

## -----------------------------------------------------------------------------
idx <- which(rejected_hypotheses(ihw_chr1_chr2) & (p.adjust(chr1_chr2_df$pvalue, n = m, method="BH") > alpha) &
                (covariates(ihw_chr1_chr2)==3) & (ihw_chr1_chr2@df$fold == 1))
idx_max <- which.max(pvalues(ihw_chr1_chr2)[idx])

ihw_chr1_chr2@df[idx[idx_max],]

## -----------------------------------------------------------------------------
chr1_df[idx[idx_max],]

## -----------------------------------------------------------------------------
idx <- which( !rejected_hypotheses(ihw_chr1_chr2) & (p.adjust(chr1_chr2_df$pvalue, n = m, method="BH") > alpha) &
                (covariates(ihw_chr1_chr2)==15) & (ihw_chr1_chr2@df$fold == 1))
idx_max <- which.max(pvalues(ihw_chr1_chr2)[idx])

ihw_chr1_chr2@df[idx[idx_max],]

## -----------------------------------------------------------------------------
chr1_df[idx[idx_max],]

## -----------------------------------------------------------------------------
idx <- which( rejected_hypotheses(ihw_chr1_chr2) & (p.adjust(chr1_chr2_df$pvalue, n = m, method="BH") <= alpha) &
                (covariates(ihw_chr1_chr2)==3) & (ihw_chr1_chr2@df$fold == 2))

## -----------------------------------------------------------------------------
ihw_chr1_chr2@df[idx[9],]

## -----------------------------------------------------------------------------
chr2_df[idx[9]-nrow(chr1_df),]

## -----------------------------------------------------------------------------
idx <- which( rejected_hypotheses(ihw_chr1_chr2) & (p.adjust(chr1_chr2_df$pvalue, n = m, method="BH") > alpha) &
                (covariates(ihw_chr1_chr2)==1) & (ihw_chr1_chr2@df$fold == 2))
idx_max <- which.max(pvalues(ihw_chr1_chr2)[idx])

ihw_chr1_chr2@df[idx[idx_max],]

## -----------------------------------------------------------------------------
chr2_df[idx[idx_max]-nrow(chr1_df),]

## -----------------------------------------------------------------------------
t_bh <- get_bh_threshold(chr1_chr2_df$pvalue, alpha, mtests = m)
t_bh

## -----------------------------------------------------------------------------
get_local_fdr <- function(fold, group){
  idx <- (chr1_chr2_groups == group) & (folds_vec == fold)
  pvals <- sort(chr1_chr2_df$pvalue[idx])
  m_true <-  m_groups[group,fold]
  gren <- IHW:::presorted_grenander(pvals, m_true)
  myt <- thresholds(ihw_chr1_chr2, levels_only=TRUE)[group,fold]
  id_ihw_myt <- which(myt < gren$x.knots)[1]
  local_fdr_ihw <- ifelse(myt == 0, 0, 1/gren$slope.knots[id_ihw_myt-1])
  
  
  id_bh_thresh <- which(t_bh < gren$x.knots)[1]
  local_fdr_bh <- 1/gren$slope.knots[id_bh_thresh-1]
  
  pi0 <- (m_true - length(pvals))/(1-10^(-4))/m_true
  data.frame(fold=fold, group=group, pi0=pi0, t_ihw=myt, 
             local_fdr_ihw =  local_fdr_ihw, 
             local_fdr_bh = local_fdr_bh)
}

## -----------------------------------------------------------------------------
fold_groups <- expand.grid(1:62, 1:2)

## ----eval=FALSE---------------------------------------------------------------
# lfdrs <- bind_rows(mapply(get_local_fdr, fold_groups[[2]], fold_groups[[1]], SIMPLIFY = FALSE))
# saveRDS(lfdrs,file="hqtl_estimated_lfdrs.Rds")

## -----------------------------------------------------------------------------
lfdrs <-  readRDS(file.path(file_loc, "hqtl_estimated_lfdrs.Rds"))

## -----------------------------------------------------------------------------
lfdrs <- mutate(lfdrs, Chromosome=paste0("chr", fold), stratum=group, t_bh=t_bh)

## -----------------------------------------------------------------------------
breaks <-   my_breaks/10^3
breaks <- breaks[-1]
break_min <- 3000/10^3
breaks_left <- c(break_min,breaks[-length(breaks)])
stratum <- 1:62
step_df_weight <- data.frame(stratum=stratum, chr2=weights(ihw_chr1_chr2,levels_only=TRUE)[,1], 
                                       chr1=weights(ihw_chr1_chr2, levels_only=TRUE)[,2] ) %>%
           gather(Chromosome, weight , -stratum)

step_df_threshold <- data.frame(stratum=stratum,
                                chr2=thresholds(ihw_chr1_chr2,levels_only=TRUE)[,2], 
                                chr1=thresholds(ihw_chr1_chr2, levels_only=TRUE)[,1] ) %>%
           gather(Chromosome, threshold , -stratum)

step_df <- left_join(step_df_weight, step_df_threshold) %>% left_join(lfdrs)

step_df <- step_df %>% mutate(break_left = breaks_left[stratum],
                 break_right = breaks[stratum],
                 break_ratio = break_right/break_left,
                 break_left_init = break_left,
                 break_right_init = break_right,
                 break_left =break_left * break_ratio^.2,
                 break_right = break_right *break_ratio^(-.2))

stratum_fun <- function(df, colname="weight"){
  stratum <- df$stratum
  weight <- df[[colname]]
  stratum_left <- stratum[stratum != length(stratum)]
  weight_left  <- weight[stratum_left]
  break_left <- df$break_right[stratum_left]
  stratum_right <- stratum[stratum != 1]
  weight_right <- weight[stratum_right]
  break_right <- df$break_left[stratum_right]
  data.frame(stratum_left= stratum_left, weight_left= weight_left, 
             stratum_right = stratum_right, weight_right = weight_right,
             break_left = break_left, break_right = break_right)
}




connecting_df_weights <- step_df %>% group_by(Chromosome) %>% 
                  do(stratum_fun(.)) %>%
                  mutate(dashed = factor(ifelse(abs(weight_left - weight_right) > 0.5 , TRUE, FALSE),
                         levels=c(FALSE,TRUE)))

weights_panel <- ggplot(step_df, aes(x=break_left, xend=break_right,y=weight, yend=weight, col=Chromosome)) +
                geom_segment(size=0.8)+                
                geom_segment(data= connecting_df_weights, aes(x=break_left, xend=break_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                             size=0.8)+
                scale_x_log10(breaks=c(10^4, 10^5,10^6,10^7,10^8), 
                              labels = trans_format("log10", math_format(10^.x))) +
                xlab("Genomic distance (bp)")+
                ylab("Weight")+
                theme(legend.position=c(0.8,0.6)) +
                theme(plot.margin = unit(c(2, 1.5, 1, 2.5), "lines"))+
                theme(axis.title = element_text(face="bold" ))+
                scale_color_manual(values=pretty_colors)+
                guides(linetype=FALSE)

weights_panel


## -----------------------------------------------------------------------------
weights_panel_1 <- ggplot(filter(step_df, Chromosome == "chr1"), aes(x=break_left, xend=break_right,y=weight, yend=weight, col=Chromosome)) +
                geom_segment(size=0.8,lineend="round")+                
                geom_segment(data= filter(connecting_df_weights, Chromosome=="chr1"), aes(x=break_left, xend=break_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                             size=0.8,lineend="round")+
                scale_x_log10(breaks=c(10, 10^2,10^3,10^4), 
                              labels = trans_format("log10", math_format(10^.x))) +
                scale_y_continuous(breaks=c(0,1000,2000))+
                xlab(expression(paste("Distance (kbp)")))+
                ylab(expression(paste("Weight")))+
                theme(legend.position="none") +
                theme(plot.margin = unit(c(2, 1.5, 1, 2.5), "lines"))+
                theme(axis.title = element_text(face="bold" ))+
                scale_color_manual(values=pretty_colors)+
                guides(linetype=FALSE)

weights_panel_1

## ----eval=FALSE---------------------------------------------------------------
# ggsave(weights_panel_1, filename="chr1_weights.pdf", width=3.5,height=2.5)

## -----------------------------------------------------------------------------
weights_panel_2 <- ggplot(filter(step_df, Chromosome == "chr2"), aes(x=break_left, xend=break_right,y=weight, yend=weight, col=Chromosome)) +
                geom_segment(size=0.8, lineend="round")+                
                geom_segment(data= filter(connecting_df_weights, Chromosome=="chr2"), aes(x=break_left, xend=break_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                             size=0.8, lineend="round")+
                scale_x_log10(breaks=c(10, 10^2,10^3,10^4), 
                              labels = trans_format("log10", math_format(10^.x))) +
                scale_y_continuous(breaks=c(0,1000,2000))+
                xlab(expression(paste("Distance (kbp)")))+
                ylab(expression(paste("Weight")))+
                theme(legend.position="none") +
                theme(plot.margin = unit(c(2, 1.5, 1, 2.5), "lines"))+
                theme(axis.title = element_text(face="bold" ))+
                scale_color_manual(values=pretty_colors)+
                guides(linetype=FALSE)

weights_panel_2

## ----eval=FALSE---------------------------------------------------------------
# ggsave(weights_panel_2, filename="chr2_weights.pdf", width=3.5,height=2.5)

## -----------------------------------------------------------------------------
connecting_df_thresholds_ihw <- step_df %>% group_by(Chromosome) %>% 
                  do(stratum_fun(., colname="t_ihw")) %>%
                  mutate(dashed = FALSE)#factor(ifelse(abs(weight_left - weight_right) > 10^{-7} , TRUE, FALSE),
                        # levels=c(FALSE,TRUE)))

thresholds_ihw_panel <- ggplot(step_df, aes(x=break_left, xend=break_right,y=t_ihw*10^6, yend=t_ihw*10^6, col=Chromosome)) +
                geom_segment(size=0.8, lineend="round")+                
                geom_segment(data= connecting_df_thresholds_ihw, aes(x=break_left, xend=break_right, 
                                                y=weight_left*10^6, yend=weight_right*10^6, 
                                                linetype=dashed),
                             size=0.8, lineend="round")+
                scale_x_log10(breaks=c(10, 10^2,10^3,10^4), 
                              labels = trans_format("log10", math_format(10^.x))) +
                scale_y_continuous(limits=c(0,1.8), breaks=c(0,1))+
                xlab(expression(paste("Distance (kbp)")))+
                ylab(expression(paste("IHW s(x) (",10^-6,")")))+
                theme(legend.position=c(0.6,0.7), legend.title = element_blank()) +
                theme(plot.margin = unit(c(2, 1.5, 1, 2.5), "lines"))+
                theme(axis.title = element_text(face="bold" ))+
                scale_color_manual(values=pretty_colors)+
                guides(linetype=FALSE)

thresholds_ihw_panel

## ----eval=FALSE---------------------------------------------------------------
# ggsave(thresholds_ihw_panel, filename="ihw_by_threshold.pdf", width=3.5,height=2.5)

## -----------------------------------------------------------------------------
connecting_df_thresholds_bh <- step_df %>% group_by(Chromosome) %>% 
                  do(stratum_fun(., colname="t_bh")) %>%
                  mutate(dashed = FALSE)#factor(ifelse(abs(weight_left - weight_right) > 10^{-11} , TRUE, TRUE),
                         #levels=c(FALSE,TRUE)))

scientific_10 = function(x) {ifelse(x==0, "0", parse(text=gsub("[+]", "", gsub("e", " %*% 10^", scientific_format()(x)))))} 
thresholds_bh_panel <- ggplot(step_df, aes(x=break_left, xend=break_right,y=10^10*t_bh, yend=10^10*t_bh, col=Chromosome)) +
                geom_segment(size=0.8)+                
                geom_segment(data= connecting_df_thresholds_bh, aes(x=break_left, xend=break_right, 
                                                y=weight_left*10^10, yend=weight_right*10^10, 
                                                linetype=dashed),
                             size=0.8)+
                scale_x_log10(breaks=c(10, 10^2,10^3,10^4), 
                              labels = trans_format("log10", math_format(10^.x))) +
                scale_y_continuous(limits=c(0,5), breaks=c(0,2,4))+
                xlab(expression(paste("Distance (kbp)")))+
                ylab(expression(paste("BY s(x) (",10^-10,")")))+
                theme(legend.position=c(0.6,0.7), legend.title = element_blank()) +
                theme(plot.margin = unit(c(2, 1.5, 1, 2.5), "lines"))+
                theme(axis.title = element_text(face="bold" ))+
                scale_color_manual(values=pretty_colors)+
                guides(linetype=FALSE)

thresholds_bh_panel

## -----------------------------------------------------------------------------
ggsave(thresholds_bh_panel, filename="by_threshold.pdf", width=3.5,height=2.5)

## -----------------------------------------------------------------------------
connecting_df_lfdr_ihw <- step_df %>% group_by(Chromosome) %>% 
                  do(stratum_fun(., colname="local_fdr_ihw")) %>%
                  mutate(dashed = FALSE)

lfdr_ihw_panel <- ggplot(step_df, aes(x=break_left, xend=break_right,y=10^1*local_fdr_ihw, yend=10^1*local_fdr_ihw, col=Chromosome)) +
                geom_segment(size=0.8, lineend="round")+                
                geom_segment(data= connecting_df_lfdr_ihw, aes(x=break_left, xend=break_right, 
                                                y=10^1*weight_left, yend=10^1*weight_right, 
                                                linetype=dashed),
                             size=0.8,lineend="round")+
                scale_x_log10(breaks=c(10, 10^2,10^3,10^4), 
                              labels = trans_format("log10", math_format(10^.x))) +
                xlab(expression(paste("Distance (kbp)")))+
                ylab(expression(paste("IHW fdr(s(x) | x)")))+
                theme(legend.position=c(0.6,0.7), legend.title = element_blank()) +
                theme(plot.margin = unit(c(2, 1.5, 1, 2.5), "lines"))+
                theme(axis.title = element_text(face="bold" ))+
                scale_color_manual(values=pretty_colors)+
                guides(linetype=FALSE)

lfdr_ihw_panel

## ----eval=FALSE---------------------------------------------------------------
# ggsave(lfdr_ihw_panel, filename="ihw_by_fdr.pdf", width=3.5,height=2.5)

## -----------------------------------------------------------------------------
connecting_df_lfdr_bh <- step_df %>% group_by(Chromosome) %>% 
                  do(stratum_fun(., colname="local_fdr_bh")) %>%
                  mutate(dashed = FALSE)#factor(ifelse(abs(weight_left - weight_right) > 0.5*10^(-6) , TRUE, FALSE),
                        # levels=c(FALSE,TRUE)))

lfdr_bh_panel <- ggplot(step_df, aes(x=break_left, xend=break_right,y=local_fdr_bh, yend=local_fdr_bh, col=Chromosome)) +
                geom_segment(size=0.8, lineend="round")+                
                geom_segment(data= connecting_df_lfdr_bh, aes(x=break_left, xend=break_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                             size=0.8, lineend="round")+
                scale_x_log10(breaks=c(10, 10^2,10^3,10^4), 
                              labels = trans_format("log10", math_format(10^.x))) +
                scale_y_log10( labels = trans_format("log10", math_format(10^.x)))+
                xlab(expression(paste("Distance (kbp)")))+
                ylab(expression(paste("BY fdr(s(x) | x)")))+
                theme(legend.position=c(0.6,0.4), legend.title = element_blank()) +
                theme(plot.margin = unit(c(2, 1.5, 1, 2.5), "lines"))+
                theme(axis.title = element_text(face="bold" ))+
                scale_color_manual(values=pretty_colors)+
                guides(linetype=FALSE)

lfdr_bh_panel

## ----eval=FALSE---------------------------------------------------------------
# ggsave(lfdr_bh_panel, filename="by_fdr.pdf", width=3.5,height=2.5)

## ----warning=F, message=F-----------------------------------------------------
library("IHW")
library("IHWpaper")
library("ggplot2")
library("dplyr")
library("wesanderson")

## ----warning=F----------------------------------------------------------------
sim <- du_ttest_sim(80000, 0.9, 2, seed=1)
ddhf_res <- ddhf(sim$pvalue, sim$filterstat, .1)
ws <- ifelse(sim$filterst <= ddhf_res$cutoff_value, 0, 1)
ws <- ws/sum(ws)*length(sim$pvalue)

## -----------------------------------------------------------------------------
total_regularization_lambda <- max(ws)-min(ws)
total_regularization_lambda

## ----warning=F----------------------------------------------------------------
ihw_res <- ihw(sim$pvalue, sim$filterstat, .1, lambdas = total_regularization_lambda, nfolds=1L,  nbins=20)

## ----fig.width=5, fig.height=5, warning=F-------------------------------------
df <- rbind( data.frame(covariate = sim$filterstat, weight= ws, method="filtering"),
             data.frame(covariate = sim$filterstat, weight= weights(ihw_res, levels_only=FALSE), 
                        method=paste0("IHW; \nlambda=",format(total_regularization_lambda,digits=2))))
weights_filter_plot <- ggplot(df, aes(x=covariate, y=weight, col=method)) + geom_step(size=1.65)+
                      scale_colour_manual(values=wes_palette("Cavalcanti1")[c(1,2)]) +
                      theme_classic(16)
weights_filter_plot

## ----eval=FALSE---------------------------------------------------------------
# pdf("smoothed_threshold.pdf", width=5, height=5)
# weights_filter_plot
# dev.off()

## ----message=F, warning=F-----------------------------------------------------
ihw_res2 <- ihw(sim$pvalue, sim$filterstat, .1, lambdas=seq(0,10,length=20), nfolds=1L, nfolds_internal = 5L, nbins=20, quiet=TRUE)

## ----message=F, warning=F-----------------------------------------------------
regularization_term(ihw_res2)

## ----fig.width=5, fig.height=5, warning=F-------------------------------------
df <- rbind(df,
            data.frame(covariate = sim$filterstat, weight= weights(ihw_res2, levels_only=FALSE),  
                       method=paste0("IHW; \nlambda=",
                                     format(regularization_term(ihw_res2) ,digits=2))))
            
weights_filter_plot <- ggplot(df, aes(x=covariate, y=weight, col=method)) + geom_step(size=1.65)+
                      scale_colour_manual(values=wes_palette("Cavalcanti1")[c(1,2,3)]) +
                      theme_classic(16)

weights_filter_plot

## ----warning=F----------------------------------------------------------------
group_by(df, method) %>% summarize(mean_weight = mean(weight))

## ----warning=FALSE, message=FALSE---------------------------------------------
library("ggplot2")
library("cowplot")

## -----------------------------------------------------------------------------
set.seed(1)

m <- 10000
binwidth <- 0.025

# generic function to add some properties to gg histograms
gg_hist_aesthetic <-  function(gg_obj, ylim_max=650) {
    gg_obj + 
             scale_x_continuous(expand = c(0.02, 0)) + 
             scale_y_continuous(expand = c(0.02, 0), limits=c(0,ylim_max)) + 
             xlab("p-value")+
             ylab("Counts")+
             theme(axis.title = element_text(face="bold",size=rel(0.1)) )
}

## -----------------------------------------------------------------------------
pv_unif <- data.frame(pvalue=runif(m))
gg_unif <- ggplot(pv_unif, aes(x=pvalue)) + 
            geom_histogram(binwidth = binwidth, boundary = 0, colour="lightgrey", fill="#939598") +
            geom_hline(yintercept=m*binwidth, size=2, col="darkblue")
gg_unif <- gg_hist_aesthetic(gg_unif)
 

gg_unif

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=gg_unif, file="stratified_histograms_unif.pdf", width=4, height=3)

## -----------------------------------------------------------------------------
pv_beta_1 <- data.frame(pvalue=c(runif(9000), rbeta(1000,0.5,7)))

gg_beta_1 <- ggplot(pv_beta_1, aes(x=pvalue)) + 
              geom_histogram(binwidth = binwidth, boundary = 0, colour="lightgrey", fill="#939598") +
              geom_hline(yintercept=9000*binwidth, size=1.3, col="darkblue")
gg_beta_1 <- gg_hist_aesthetic(gg_beta_1)
gg_beta_1

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=gg_beta_1, file="stratified_histograms_beta1.pdf", width=4, height=3)

## -----------------------------------------------------------------------------
pv_beta_2 <- data.frame(pvalue=c(runif(5500), rbeta(4500,1,4)))

gg_beta_2 <- ggplot(pv_beta_2, aes(x=pvalue)) + 
              geom_histogram(binwidth = binwidth, boundary = 0, colour="lightgrey", fill="#939598") +
              geom_hline(yintercept=5500*binwidth, size=1.3, col="darkblue")
gg_beta_2 <- gg_hist_aesthetic(gg_beta_2)
gg_beta_2

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=gg_beta_2, file="stratified_histograms_beta2.pdf", width=4, height=3)

## ----fig.width=12, fig.height=4-----------------------------------------------
gg_stratified <- plot_grid(gg_unif, gg_beta_1, gg_beta_2,
                         nrow=1,
                         labels=c("a)", "b)", "c)"))
gg_stratified

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=gg_stratified, file="stratified_histograms.pdf", width=12, height=4)

## -----------------------------------------------------------------------------
set.seed(1)

m <- 10000
binwidth <- 0.05
grey <- "grey41"
# generic function to add some properties to gg histograms
gg_hist_aesthetic <-  function(gg_obj, ylim_max=6) {
    gg_obj + 
             aes(y=..density..)+
             scale_x_continuous(expand = c(0.02, 0), breaks=c(0,0.5,1)) + 
             scale_y_continuous(expand = c(0.02, 0), limits=c(0,ylim_max)) + 
             xlab("p-value")+
             ylab("Density")+
             theme(axis.title = element_text(face="bold",size=rel(0.7)))
}

## -----------------------------------------------------------------------------
pv_unif <- data.frame(pvalue=runif(m))
gg_unif <- ggplot(pv_unif, aes(x=pvalue)) + 
            geom_histogram(binwidth = binwidth, boundary = 0, colour=grey, fill="lightgrey")
gg_unif <- gg_hist_aesthetic(gg_unif)
 

gg_unif

## -----------------------------------------------------------------------------
pv_beta_a <- data.frame(pvalue=c(runif(9000), rbeta(1000,0.5,4)))

gg_beta_a <- ggplot(pv_beta_a, aes(x=pvalue)) + 
              geom_histogram(binwidth = binwidth, boundary = 0, colour=grey, fill="lightgrey")
gg_beta_a <- gg_hist_aesthetic(gg_beta_a)
gg_beta_a

## -----------------------------------------------------------------------------
pv_beta_b <- data.frame(pvalue=c(runif(8000), rbeta(2000,0.5,11)))

gg_beta_b <- ggplot(pv_beta_b, aes(x=pvalue)) + 
              geom_histogram(binwidth = binwidth, boundary = 0, colour=grey, fill="lightgrey")

gg_beta_b <- gg_hist_aesthetic(gg_beta_b, ylim_max=5.5)
gg_beta_b

## -----------------------------------------------------------------------------
pv_all <- rbind(pv_unif, pv_beta_b, pv_beta_a) 
gg_all <- ggplot(pv_all, aes(x=pvalue)) + 
              geom_histogram(binwidth = binwidth, boundary = 0, colour=grey, fill="lightgrey")
gg_all <- gg_hist_aesthetic(gg_all)
gg_all

## ----fig.width=6, fig.height=2------------------------------------------------
gg_stratified <- plot_grid(gg_all, gg_beta_b, gg_beta_a, gg_unif,
                         nrow=1,
                         labels=c("a)", "b)", "c)","d)"))
gg_stratified

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=gg_stratified, file="stratified_histograms.pdf", width=6, height=2)

### general wrapper

#' Benchmarking wrapper: Given a multiple testing method, convert it so that it takes
#'   a simulation object (see simulation function) and a nominal level alpha
#'   as inputs
#'
#' @param mt_method Multiple testing method (e.g. a function such as gbh or ddhf)
#' @param nbins Integer, number of equally sized bins into which to stratify hypotheses
#'
#' @return A new multiple testing function which has an
#'           interface of the form f(sim_data_frame, alpha)
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      sim_df$group <- groups_by_filter(sim_df$filterstat, 20)
#'      obj <- tst_gbh(sim_df$pvalue, sim_df$group, .1)
#'      sum(rejected_hypotheses(obj))
#'
#'      tst_gbh_continuous <- continuous_wrap(tst_gbh)
#'      obj2 <- tst_gbh_continuous(sim_df, .1)
#'      sum(rejected_hypotheses(obj2))
#'
#' @export
continuous_wrap <- function(mt_method, nbins=20){
  print(attr(mt_method,"fdr_method"))
  if (attr(mt_method, "testing covariate") == "simple"){

    f <- function(sim, alpha){
      mt_method(sim$pvalue, alpha)
    }
    attr(f, "fdr_method") <- attr(mt_method, "fdr_method")

  } else if (attr(mt_method, "testing covariate") == "stratified"){

    f <- function(sim, alpha){
      groups <- groups_by_filter(sim$filterstat, nbins)
      mt_method(sim$pvalue, groups, alpha)
    }
    attr(f, "fdr_method") <- paste(attr(mt_method, "fdr_method"), nbins, "bins")

  } else if (attr(mt_method, "testing covariate") == "continuous"){
    f <- function(sim, alpha){
      mt_method(sim$pvalue, sim$filterstat, alpha)
    }

    attr(f, "fdr_method") <- attr(mt_method, "fdr_method")

  } else {
    stop("unknown covariate handling")
  }

  attr(f, "fdr_pars") <- attr(mt_method, "fdr_pars")
  f
}



#' scott_fdrreg: Wrapper for FDR regression (https://github.com/jgscott/FDRreg)
#'
#'
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param filterstat   Factor to which different hypotheses belong
#' @param alpha    Significance level at which to apply method
#' @param df       Degrees of freedom for B-slines
#' @param lambda Ridge regularization parameter
#'
#' @return FDRreg multiple testing object
#'
#' @references  James G. Scott, Ryan C. Kelly, Matthew A. Smith, Pengcheng Zhou, and Robert E. Kass. 
#'         "False discovery rate regression: application to neural synchrony detection in primary visual cortex." 
#'         Journal of the American Statistical Association (2015).
#' @importFrom splines bs
#' @importFrom stats model.matrix qnorm
#' @importFrom utils packageVersion
scott_fdrreg <- function(unadj_p, filterstat, alpha, df=3, lambda=0.01){
	# no automated way to choose function space over which we optimize
	# so we just use bs(df=3) as done in their analysis
	# also no automated way of choosing ridge regularization parameter

  if (! packageVersion("FDRreg") %in% c("0.2.1","0.2")){
     stop(paste("Benchmarks were run against version 0.2 of FDRreg",
                "available on github via:",
                "devtools::install_github(repo= 'jgscott/FDRreg', subdir='R_pkg/', ref = 'a63cebae6faecb1fb0ebee634195296f39faa11b')"
                ))
  }
	b <- bs(filterstat, df=df)
	Xs <- model.matrix( ~  b - 1)


	fdrreg_res <- FDRreg(qnorm(unadj_p), Xs, control=list(lambda = 0.01))

  # modification to make this method applicable to p-values
  # FDRreg tests in a two-sided way, this means that we might get rejections
  # due to the right tail (high p-values) which have a z-score > 0 !
  # for this reason, just set local-fdr to 1 or equivalently the posterior prob to 0

  posterior_probs <- ifelse(unadj_p <= 0.5, fdrreg_res$postprob, 1)

	FDR <- getFDR(fdrreg_res$postprob)$FDR

  obj <- list(adj_p = FDR,
              pi0_continuous = fdrreg_res$priorprob, pi0=fdrreg_res$p0,
              method="FDRreg", alpha=alpha)
  class(obj) <- "FDRreg"
	obj
}

attr(scott_fdrreg, "testing covariate") <- "continuous"
attr(scott_fdrreg, "fdr_method")        <- "FDRreg"

#' @importFrom IHW rejected_hypotheses
rejected_hypotheses.FDRreg <- function(object, alpha= object$alpha){
	object$adj_p <= alpha
}

setOldClass("FDRreg")
setMethod("rejected_hypotheses", signature("FDRreg"), rejected_hypotheses.FDRreg)


#' ddhf: Greedy independent filtering
#'
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param filterstat   Factor to which different hypotheses belong
#' @param alpha    Significance level at which to apply method
#'
#' @return DDHF multiple testing object
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      obj <- ddhf(sim_df$pvalue, sim_df$filterstat, .1)
#'      sum(rejected_hypotheses(obj))
#'
#' @export
#' @importFrom Rcpp evalCpp
#' @importFrom Rcpp sourceCpp
#' @useDynLib IHWpaper, .registration=TRUE
ddhf <- function(unadj_p, filterstat, alpha){
  sortedp <- sort(unadj_p)
  ranksp <- rank(unadj_p, ties.method="first")
  filterorder <- order(filterstat)
  filterrank <- rank(filterstat)

  sortedp_filterorder <- ranksp[filterorder]
  rjs <- ddhf_order(sortedp, sortedp_filterorder, alpha)
  j <- which.max(rjs)[1]

  m <- length(unadj_p)
  adj_p <- rep(1, m)
  adj_p[filterrank >= j] <- p.adjust(unadj_p[filterrank >= j], method="BH")

  ddhf_obj <- list(adj_p = adj_p, rejections = max(rjs),
                   cutoff_quantile=j/m,
                   cutoff_value = filterstat[filterorder][j],
                   alpha=alpha)
  class(ddhf_obj) <- "DDHF"
  ddhf_obj
}
attr(ddhf, "testing covariate") <- "continuous" 
attr(ddhf, "fdr_method")        <- "Greedy Indep. Filt."     
# actually greedy independent filtering does not need continuous covariates,
# it is sufficient if covariates can be ordered!

rejected_hypotheses.DDHF <- function(object, alpha= object$alpha){
	object$adj_p <= alpha
}

setOldClass("DDHF")
setMethod("rejected_hypotheses", signature("DDHF"), rejected_hypotheses.DDHF)

## -----------------------------------------------------------------------------
library("ggplot2")
library("dplyr")
library("wesanderson")
library("grid")
library("gridExtra")
library("IHW")

## -----------------------------------------------------------------------------
simpleSimulation <- function(m,m1,betaA,betaB){
    pvalue <- runif(m)
    H <- rep(0,m)
    alternatives <- sample(1:m,m1)
    
    pvalue[alternatives] <- rbeta(m1,betaA,betaB)
    H[alternatives] <-1
 
    simDf <- data.frame(pvalue = pvalue, group=runif(m), filterstat = runif(m), H=H)
    return(simDf)
}

set.seed(1)
sim <- simpleSimulation(1000, 700, 0.3, 8)
sim$rank <- rank(sim$pvalue)

histogram_plot <- ggplot(sim, aes(x=pvalue)) + 
                    geom_histogram(binwidth=0.1, fill = wes_palette("Chevalier1")[4]) + 
                    xlab("p-value") + 
                    theme_bw()
                        
bh_threshold <- get_bh_threshold(sim$pvalue, .1)

bh_plot <- ggplot(sim, aes(x=rank, y=pvalue)) +
  geom_step(col=wes_palette("Chevalier1")[4]) + 
  ylim(c(0,0.2)) +
  geom_abline(intercept=0, slope= 0.1/1000, col = wes_palette("Chevalier1")[2]) +
  geom_hline(yintercept=bh_threshold, linetype=2) + 
  annotate("text",x=250, y=0.065, label="BH testing") + 
  geom_hline(yintercept = 0.1, linetype=2) + 
  annotate("text",x=250, y=0.11, label="uncorrected testing") + 
  geom_hline(yintercept = 0.1/1000, linetype=2) +
  annotate("text",x=850, y=0.1/1000+0.01, label="Bonferroni testing") + 
  ylab("p-value") + xlab("rank of p-value") +
  theme_bw() + scale_colour_manual(values=wes_palette("Chevalier1")[c(3,4)]) 


## ----fig.width=11, fig.height=5-----------------------------------------------
grid.arrange(histogram_plot, bh_plot, nrow=1)

## ----eval=FALSE---------------------------------------------------------------
# pdf(file="bh_explanation.pdf", width=11, height=5)
# grid.arrange(histogram_plot, bh_plot, nrow=1)
# dev.off()

## -----------------------------------------------------------------------------
set.seed(1)
sim <- simpleSimulation(10000, 2000, 0.3, 8)
sim$rank <- rank(sim$pvalue)

histogram_plot <- ggplot(sim, aes(x=pvalue)) + 
                    geom_histogram(binwidth=0.1, fill = wes_palette("Chevalier1")[4]) + 
                    xlab("p-value") + 
                    theme_bw(14)
                        

bh_threshold <- get_bh_threshold(sim$pvalue, .1)

bh_plot <- ggplot(sim, aes(x=rank, y=pvalue)) +
  geom_step(col=wes_palette("Chevalier1")[4], size=1.2) + 
  scale_x_continuous(limits=c(0,2000),expand = c(0, 0))+
  scale_y_continuous(limit=c(0,0.06), expand=c(0,0)) +
  geom_abline(intercept=0, slope= 0.1/10000, col = wes_palette("Chevalier1")[2], size=1.2) +
  annotate("text",x=500, y=1.3*bh_threshold, label="BH rejection threshold") + 
  geom_hline(yintercept=bh_threshold, linetype=2, size=1.2) + 
  ylab("p-value") + xlab("rank of p-value") +
  theme_bw() + scale_colour_manual(values=wes_palette("Chevalier1")[c(3,4)])

## ----fig.width=11, fig.height=5-----------------------------------------------
grid.arrange(histogram_plot, bh_plot, nrow=1)

## ----eval=FALSE---------------------------------------------------------------
# pdf(file="bh_explanation_high_pi0.pdf", width=11, height=5)
# grid.arrange(histogram_plot, bh_plot, nrow=1)
# dev.off()

#' t-test simulation: Simulate rowwise t-tests
#'
#' @param m Integer, total number of hypotheses 
#' @param pi0 Numeric, proportion of null hypotheses
#' @param effect_size Numeric, the alternative hypotheses will be 
#       distributed according to N(effect_size, 1), while nulls according to N(0,1).
#' @param n_samples Integer, number of samples for t-test, i.e.
#'      the comparison will be n_samples/2 vs n_samples/2
#' @param uninformative_filter Boolean, if TRUE will generate uniformly distributed filter statistic
#'     Otherwise will use the pooled standard deviations
#' @param seed Integer, Random seed to be used for simulation 
#'        (default: NULL, i.e. RNG state will be used as is)
#'
#' @return A data frame containing all information about the simulation experiment
#'
#' @examples sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'
#' @export
#' @importFrom stats pchisq rnorm
#' @importFrom genefilter rowSds rowttests
du_ttest_sim <- function(m, pi0, effect_size, n_samples=10, uninformative_filter=FALSE, seed=NULL){
  if (!is.null(seed)) set.seed(seed)
  m0 <- ceiling(m*pi0)
  false_nulls <- sample(1:m, m-m0)
  z_table <- matrix(rnorm(n_samples*m), ncol=n_samples)
  z_table[false_nulls,(n_samples/2+1):n_samples] <- matrix(rnorm(n_samples/2*(m-m0), effect_size), ncol=n_samples/2)
  H <- rep(0,m)
  H[false_nulls] <- 1
  ttests <- rowttests(z_table, factor(rep(1:2,each=n_samples/2)))
  sds <- rowSds(z_table)
  filter_pvalue <- 1-pchisq((n_samples-1)*sds^2,n_samples-1)
  if (uninformative_filter){
    filterstats <- runif(m)
  } else {
    filterstats <- sds
  }

  simDf <- data.frame(H=H, pvalue= ttests$p.value, sd= sds, filterstat=filterstats, 
    filter_pvalue=filter_pvalue)
  simDf
}

#' @describeIn du_ttest_sim Creates a closure function for a given seed
#' @export
du_ttest_sim_fun <- function(m, pi0, effect_size, n_samples=10, uninformative_filter=FALSE){
  f <- function(seed) du_ttest_sim(m, pi0, effect_size, n_samples=n_samples, uninformative_filter=uninformative_filter, seed=seed)
  attr(f, "sim_method") <- "t-test"
  attr(f, "sim_pars") <- paste0("pi0:",pi0, ", effect size:", effect_size)
  attr(f, "m") <- m
  f
}

#' Null simulation: Generate uniformly distributed p-values and covariates
#'
#' @param m Integer, total number of hypotheses
#' @param seed Integer, Random seed to be used for simulation 
#'        (default: NULL, i.e. RNG state will be used as is)
#'
#' @return A data frame containing all information about the simulation experiment
#'
#' @examples sim_df <- null_sim(20000)
#'
#' @export
null_sim <- function(m, seed=NULL){
  if (!is.null(seed)) set.seed(seed)

  sim_df <- data.frame(pvalue = runif(m), filterstat = runif(m), H=0)
  return(sim_df)
}

#' @describeIn null_sim Creates a closure function for a given seed
#' @export
null_sim_fun <- function(m){
  f <- function(seed) null_sim(m=m, seed=seed)
  attr(f, "sim_method") <- "only nulls"
  attr(f, "sim_pars") <- paste0("")
  attr(f, "m") <- m
  f
}

#' Normal simulation: Covariate is effect size under alternative
#'
#' @param m Integer, total number of hypotheses 
#' @param pi0 Numeric, proportion of null hypotheses
#' @param xi_min,xi_max  Numeric, covariates are drawn as uniform on xi_min, xi_max
#' @param seed Integer, Random seed to be used for simulation 
#'        (default: NULL, i.e. RNG state will be used as is)
#'
#' @return A data frame containing all information about the simulation experiment
#'
#' @examples sim_df <- wasserman_normal_sim(20000,0.9, 1, 5)
#'
#' @export
#' @importFrom stats rbinom runif rnorm pnorm
wasserman_normal_sim <- function(m, pi0, xi_min, xi_max, seed=NULL){
    if (!is.null(seed)) set.seed(seed)

    X   <- runif(m, min=xi_min, max=xi_max)
    H   <- rbinom(m,1,1-pi0)
    Z   <- rnorm(m, H*X)
    pvalue <- 1-pnorm(Z)
    simDf <- data.frame(pvalue=pvalue, filterstat=X,H=H, Z=Z)
}

#' @describeIn wasserman_normal_sim Creates a closure function for a given seed
#' @export
wasserman_normal_sim_fun <- function(m, pi0, xi_min, xi_max){
  f <- function(seed) wasserman_normal_sim(m, pi0, xi_min, xi_max, seed=seed)
  attr(f, "sim_method") <- "wasserman sim"
  attr(f, "sim_pars") <- paste0("pi0:",pi0, ", xi_max:", xi_max)
  attr(f, "m") <- m
  f
}



# Z_i correlated + PRDS
# Uninformative covariate


#' Normal PRDS simulation: Covariate is effect size under alternative, there are latent factors
#'      driving PRDS correlations among hypotheses
#'
#' @param m Integer, total number of hypotheses 
#' @param pi0 Numeric, proportion of null hypotheses
#' @param rho Numeric, correlation between z-scores of hypotheses driven by same latent factor
#' @param latent_factors Integer, number of latent factors driving the correlations
#' @param xi_min,xi_max  Numeric, covariates are drawn as uniform on xi_min, xi_max
#' @param seed Integer, Random seed to be used for simulation 
#'        (default: NULL, i.e. RNG state will be used as is)
#'
#' @return A data frame containing all information about the simulation experiment
#'
#' @examples sim_df <- wasserman_normal_prds_sim(20000,0.9, rho=0.1)
#'
#' @export
wasserman_normal_prds_sim <- function(m, pi0, rho=0.0, latent_factors=1, xi_min=0, xi_max=2.5, seed=NULL){
    if (!is.null(seed)) set.seed(seed)
    latent_idx <- sample(1:latent_factors, m, replace=TRUE)
    latent_Z <- rnorm(latent_factors)
    X   <- runif(m, min=xi_min, max=xi_max)
    H   <- rbinom(m,1,1-pi0)
    Z   <- sqrt(1-rho)*rnorm(m) + rho*latent_Z[latent_idx] + H*X
    pvalue <- 1-pnorm(Z)
    simDf <- data.frame(pvalue=pvalue, filterstat=X,H=H, Z=Z, latent_idx=latent_idx)
}

#' @describeIn wasserman_normal_prds_sim Creates a closure function for a given seed
#' @export
wasserman_normal_prds_sim_fun <- function(m, pi0, rho=0.0, latent_factors=1, xi_min=0, xi_max=2.5){
  f <- function(seed) wasserman_normal_prds_sim(m, pi0, rho=rho, latent_factors=latent_factors, 
                    xi_min=xi_min, xi_max=xi_max, seed=seed)
  attr(f, "sim_method") <- "wasserman normal prds sim"
  attr(f, "sim_pars") <- paste0("pi0:",pi0, ", xi_max:", xi_max, 
                                ", rho:", rho,
                                ", latent_factors:",latent_factors)
  attr(f, "m") <- m
  f
}

# TODO: Allow both covariate effects + dependence effects..
# pi0 not group dependent for now?
dependence_by_groups_sim <- function(m, pi0, rho=0.0, latent_factors=1,
                                     xi_min=0, xi_max=2.5, seed=NULL){
  if (!is.null(seed)) set.seed(seed)

  group_idx <- 1:latent_factors
  mgroups <- rep(floor(m/latent_factors), latent_factors)
  mgroups[1] <- mgroups[1] + m - sum(mgroups)

  xi_min_range <- xi_min + (0:(latent_factors-1))*(xi_max-xi_min)/latent_factors
  xi_max_range <- c(xi_min_range[-1], xi_max)

  sim_df <- bind_rows(mapply(wasserman_normal_prds_sim,
                             mgroups, pi0, rho, 1, xi_min_range,
                             xi_max_range,
                             SIMPLIFY=FALSE))
  sim_df$X <- sim_df$filterstat
  sim_df$filterstat <- unlist(mapply(function(idx, m) rep(idx,m), 
                                     group_idx, mgroups,
                                     SIMPLIFY=FALSE ))
  sim_df <- sim_df[sample(m,m),]
  sim_df
}

context("simulation_check")


# Exemplary simulation with low number of Monte Carlo replicates


#----------------- General benchmark settings -------------------------------#
alphas <- 0.1
nreps <- 2 # number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000
eff_sizes <- seq(1, 2.5, length=2)
sim_funs  <- lapply(eff_sizes, function(x) du_ttest_sim_fun(ms, 0.95, x, uninformative_filter = FALSE))

#------------- Methods to be benchmarked ------------------------------------#
continuous_methods_list <- list(bh,
                                lsl_gbh,
                                tst_gbh,
                                stratified_bh,
                                clfdr,
                                ddhf,
                                ihw_5fold,
                                ihw_bonf_5fold_reg,
                                bonf,
                                storey_qvalue)


fdr_methods <- lapply(continuous_methods_list, continuous_wrap)


#-----------------------------------------------------------------------------

eval_table <- run_evals(sim_funs, fdr_methods, nreps, alphas, BiocParallel = FALSE)
eval_table <- dplyr::mutate(eval_table,
                     eff_size = sapply(strsplit(sim_pars, "effect size:"), function(x) as.numeric(x[2])))

testthat::expect_equal(eval_table$nsuccessful, rep(nreps, nrow(eval_table)))

## ----warning=F, message=F-----------------------------------------------------
library("IHWpaper")
library("fdrtool")
library("ggplot2")
library("cowplot")
theme_set(theme_cowplot())

## -----------------------------------------------------------------------------
sim <- du_ttest_sim(100, 0.5, 2.5 ,seed=100)

sorted_pvalues <- sort(sim$pvalue)
n  <- length(sorted_pvalues)
unique_pvalues <- unique(sorted_pvalues)
ecdf_values <- cumsum(tabulate(match(sorted_pvalues, unique_pvalues)))/n

df_ecdf <- data.frame(x=unique_pvalues,y=ecdf_values)
gren <- IHW:::presorted_grenander(sorted_pvalues)
df_gren <- data.frame(x=gren$x.knots, y=gren$y.knots)

## -----------------------------------------------------------------------------
ggplot(df_ecdf, aes(x=x, y=y)) + geom_step(direction="hv",size=1.3) +
                  scale_x_continuous(expand=c(0,0),lim=c(0,1))+
                  scale_y_continuous(expand=c(0,0))+
                  xlab("p-value") +
                  ylab("Distribution")

## ----eval=FALSE---------------------------------------------------------------
# ggsave(filename="ecdf_plot.pdf", width=7,height=7)

## -----------------------------------------------------------------------------
ggplot(df_ecdf, aes(x=x, y=y)) + geom_step(direction="hv",size=1.3) +
  geom_line(data=df_gren, aes(x=x,y=y), color="red",size=1.3) +
                  scale_x_continuous(expand=c(0,0),lim=c(0,1))+
                  scale_y_continuous(expand=c(0,0))+
                  xlab("p-value") +
                  ylab("Distribution")

## ----eval=FALSE---------------------------------------------------------------
# ggsave(filename="ecdf_grenander_plot.pdf", width=7,height=7)

library("IHW")
library("IHWpaper")

bottomly <- analyze_dataset("bottomly")

ihw_res <- ihw(bottomly$pvalue, bottomly$baseMean, 0.1, nbins=13, 
               nfolds_internal=4L, nsplits_internal=5L)

breaks <- IHW:::stratification_breaks(ihw_res)

get_alpha_df <- function(alpha, pvalue, filter_statistic, filter_thresholds,...){
  print(paste0("alpha:",alpha))
  x <- ihw(pvalue, filter_statistic, alpha,...)
  print("IHW finished")
  ws <- weights(x, levels_only=TRUE)
  group_levels <- levels(groups_factor(x))
  folds  <- factor(1:x@nfolds)
  df <- expand.grid(stratum=1:nlevels(groups_factor(x)),
                    fold=folds)
  df$group <- group_levels[df$stratum]
  df$weight <- mapply(function(x,y) ws[x,y], df$stratum, df$fold)
  df$alpha <- alpha
  df$rejections <-rejections(x)
  df$bh_rejections <- sum(p.adjust(pvalue, method="BH") <= alpha, na.rm=T)
  for (filter_t in filter_thresholds){
    filt_pvalue <- pvalue[filter_statistic <= filter_t]
    df[paste0("threshold:", filter_t)] <- sum(p.adjust(filt_pvalue, method="BH") <= alpha, na.rm=T)
  }
  df
}

alpha_df <- bind_rows(lapply(seq(0.05,0.1,length=5), get_alpha_df, 
                             bottomly$pvalue, bottomly$baseMean, c(100,1000), nbins=13,
                             nsplits_internal=5))

res <- list(alpha_df = alpha_df,
            breaks   = breaks,
            break_min = min(bottomly$baseMean),
            ihw_res  = ihw_res
            )

saveRDS(res, file="result_files/RNAseq_benchmark.Rds")

#' helper function to create nice legends
#'
#' @param gg ggplot2 object
#' @param last_vals, data frame with columns 
#'    label, colour, last_vals (i.e. place label with colour at y-coordinate last_vals)
#' @param xmin Numeric, x axis position at which labels should be placed
#' @param fontsize Integer, fontsize
#'
#' @return Another ggplot2 object
#'
#  @details
#'      This replaces the default legend of a ggplot2 object. In particular,
#'    given a ggplot2 object ,it removes the existing legend and then places
#'    new labels based on the annotation data frame `last_vals` (see parameter description)
#'    at a given x-coordinate of the original plot.
#'
#'    This function can be attributed to and is described in more detail in 
#'    the following blog post:
#'    http://www.r-bloggers.com/coloring-and-drawing-outside-the-lines-in-ggplot/
#'
#' @examples
#'   library("ggplot2")
#'   labels  <- c("A","B","C")
#'   mypoints <- rbind(data.frame(y=1:3, x=1, label=as.factor(labels)),
#'                      data.frame(y=2:4, x=2, label=as.factor(labels)))
#'   mycolours <- c("#F8766D","#00BA38","#619CFF")
#'   gg <- ggplot(mypoints,aes(x=x,y=y,color=label)) + 
#'                geom_line(size=2) + 
#'                scale_color_manual(values=mycolours) +
#'                xlim(c(0,2.2))
#'   gg
#'   annotation_df <- data.frame(colour=mycolours, last_vals=2:4, label=labels)
#'   pretty_legend(gg, annotation_df, 2.1)
#'
#' @export
#' @importFrom grid gpar textGrob
#' @importFrom ggplot2 annotation_custom ggplot_build theme ggplot_gtable
#' @importFrom cowplot ggdraw

pretty_legend <- function(gg,  last_vals, xmin, fontsize=13){
  #tmp <- ggplot_build(gg)
  #label_name <- tmp$plot$labels$colour
  #label <- levels(droplevels(tmp$plot$data[[label_name]]))

  #df <- tmp$data[[1]]
  #last_vals2 <- group_by(df, colour) %>% summarize(last_vals = y[which.max(x)])
  #last_vals$last_vals <- last_vals$last_vals + offset
  #last_vals$label <- label

  last_vals$colour <- as.character(last_vals$colour)

  gg <- gg + theme(legend.position="none")

  for (i in 1:nrow(last_vals)) {
    gg <- gg + annotation_custom(grob=textGrob(last_vals$label[i], hjust=0,
                                               gp=gpar(fontsize=fontsize, 
                                                       col=last_vals$colour[i])),
                                 xmin=xmin,
                                 xmax=xmin,
                                 ymin=last_vals$last_vals[i],
                                 ymax=last_vals$last_vals[i])
  }
  gg
  gb <- ggplot_build(gg)
  gt <- ggplot_gtable(gb)

  gt$layout$clip[gt$layout$name=="panel"] <- "off"
  gt <- ggdraw(gt)
  gt
}

#!/usr/bin/env Rscript

# implement the below mainly for size-investing strategy illustration 
library("IHWpaper")
library("BiocParallel")
register(MulticoreParam(workers=10))

taus <- signif(10^seq(-4,-1, length=20),5)

methods_list <- list()

tau_wrap_ihwc <- function(tau){
  ihwc_method <- function(unadj_p, filterstat, alpha){
    obj <- ihw(unadj_p, filterstat, alpha, nbins=20, nfolds=5, lambdas=Inf,
               distrib_estimator="grenander", lp_solver="lpsymphony",
               censoring=TRUE, censoring_level=tau, null_proportion = FALSE)
    obj
  }
  
  
  attr(ihwc_method, "testing covariate") <- "continuous"
  attr(ihwc_method, "fdr_pars") <- tau
  attr(ihwc_method, "fdr_method") <- "IHWc"
  
  ihwc_method
}

tau_wrap_ihwc_storey <- function(tau){
  ihwc_storey_method <- function(unadj_p, filterstat, alpha){
    obj <- ihw(unadj_p, filterstat, alpha, nbins=20, nfolds=5, lambdas=Inf,
               distrib_estimator="grenander", lp_solver="lpsymphony",
               censoring=TRUE, censoring_level=tau, null_proportion = TRUE,
               null_proportion_level = 0.5)
    obj
  }
  
  attr(ihwc_storey_method, "testing covariate") <- "continuous"
  attr(ihwc_storey_method, "fdr_pars") <- tau
  attr(ihwc_storey_method, "fdr_method") <- "IHWc_Storey"
  ihwc_storey_method
}
  
for (i in 1:length(taus)){
  tau <- taus[i]
  methods_list <- c(methods_list, tau_wrap_ihwc(tau), tau_wrap_ihwc_storey(tau))
}




methods_list <- c(methods_list, ihw_5fold, ihw_storey_5fold, bh)

methods_list <- lapply(methods_list, continuous_wrap)

alphas <- .1
nreps <- 200# number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000

pi0s <- c(0.7,0.9)
xi_max <- 2.5

sim_funs <- lapply(pi0s, function(pi0) wasserman_normal_sim_fun(20000,pi0,0 , 2.5))

eval_table <- run_evals(sim_funs, methods_list, nreps, alphas, BiocParallel=TRUE)

saveRDS(eval_table, file="ihwc_wasserman_normal_sim.Rds")

# implement LSL and TST pi0 estimators which we need in order to benchmark the GBH method


#' TST (Two-Step) pi0 estimator
#' @param pvalue Numeric vector of unadjusted p-values.
#' @param alpha Nominal level for applying the TST procedure
#'
#' @return estimated proportion of null hypotheses (pi0)
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      tst_pi0_est(sim_df$pvalue, .1)
#'
#' @export
tst_pi0_est <- function(pvalue, alpha){
    nrjs <- sum(p.adjust(pvalue, method="BH") <= alpha/(1+alpha))
    n <- length(pvalue)
    (n-nrjs)/n
}

#' LSL (Least-Slope) pi0 estimator
#' @param pvalue Numeric vector of unadjusted p-values.
#'
#' @return estimated proportion of null hypotheses (pi0)
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      lsl_pi0_est(sim_df$pvalue)
#'
#' @export
lsl_pi0_est <- function(pvalue){
  n <- length(pvalue)
  ls <- (n:1)/(1-sort(pvalue))
  ls_diff <- ls[-c(1,2)] - ls[-c(1,n)]
  index <- min(which(ls_diff > 0))+2
  if (index == Inf) {
    pi0 <- 1
  } else {
    pi0 <- min(1, (1+floor(ls[index]))/n)
  }
  pi0
}

## ----warning=F, message=F-----------------------------------------------------
library("IHW")
library("dplyr")
library("ggplot2")
library("grid")
library("tidyr")
library("cowplot")
library("RColorBrewer")
library("scales")
library("IHWpaper")

## -----------------------------------------------------------------------------
pretty_colors <- scales::hue_pal(h = c(0, 360) + 15, c = 100, l = 65, h.start = 0,direction = 1)(5)
pretty_names <- c("IHW", "BH", "Indep. Filt. \n 10 kb", "Indep. Filt. \n 200 kb", "Indep. Filt. \n 1 Mb")

## -----------------------------------------------------------------------------

rnaseq_file <- system.file("real_data_examples/result_files", "RNAseq_benchmark.Rds", package = "IHWpaper")
rnaseq_data <- readRDS(file=rnaseq_file)
panel_a_data <- group_by(rnaseq_data$alpha_df, alpha) %>% summarize(BH = max(bh_rejections), IHW=max(rejections)) %>% 
                     gather(method, rejections, BH, IHW) %>%
                     mutate(method = factor(as.character(method), levels=pretty_names))

## -----------------------------------------------------------------------------
last_vals_a <- group_by(panel_a_data, method) %>% 
               summarize(last_vals = max(rejections)) %>%
               mutate(label = method,
                   colour = pretty_colors[match(label, pretty_names)])


panel_a <- ggplot(panel_a_data, aes(x=alpha,y=rejections,col=method)) +  
                geom_line(size=1.2) +
                xlab(expression(bold(paste("Nominal ",alpha)))) +
                ylab("Discoveries") +
                scale_color_manual(values=pretty_colors)+
                scale_x_continuous(expand=c(0,0)) +
                theme(plot.margin = unit(c(1, 7.5, 2, 1), "lines"))+
                theme(axis.title = element_text(face="bold" ))


panel_a <- pretty_legend(panel_a, last_vals_a, 0.102)
panel_a

## -----------------------------------------------------------------------------
breaks <- rnaseq_data$breaks
break_min <- rnaseq_data$break_min

breaks_left <- c(break_min,breaks[-length(breaks)])

step_df <- mutate(rnaseq_data$alpha_df, baseMean_left = breaks_left[stratum], baseMean_right = breaks[stratum],
                 baseMean_ratio = baseMean_right/baseMean_left , 
                 baseMean_left = baseMean_left * baseMean_ratio^.2,
                 baseMean_right = baseMean_right *baseMean_ratio^(-.2))

stratum_fun <- function(df){
  stratum <- df$stratum
  weight <- df$weight
  stratum_left <- stratum[stratum != length(stratum)]
  weight_left  <- weight[stratum_left]
  baseMean_left <- df$baseMean_right[stratum_left]
  stratum_right <- stratum[stratum != 1]
  weight_right <- weight[stratum_right]
  baseMean_right <- df$baseMean_left[stratum_right]
  data.frame(stratum_left= stratum_left, weight_left= weight_left, 
             stratum_right = stratum_right, weight_right = weight_right,
             baseMean_left = baseMean_left, baseMean_right = baseMean_right)
}

connect_df <- filter(step_df, alpha==0.1) %>% group_by(fold) %>% 
                  do(stratum_fun(.)) %>%
                  mutate(dashed = factor(ifelse(abs(weight_left - weight_right) > 10^(-4) , TRUE, FALSE),
                         levels=c(FALSE,TRUE)))


panel_b <- ggplot(filter(step_df, alpha==0.1), 
                       aes(x=baseMean_left, 
                           xend=baseMean_right, 
                           y=weight, yend=weight, col=fold)) +
                geom_segment(size=0.8)+ 
                geom_segment(data= connect_df, aes(x=baseMean_left, xend=baseMean_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                             size=0.8)+
                scale_x_log10(breaks=c(1,10,100,1000,10000))+
                xlab("Mean of normalized counts")+
                ylab("Weight")+
                theme(legend.position=c(0.8,0.4)) +
                theme(plot.margin = unit(c(1, 1, 2, 1), "lines")) +
                guides(linetype=FALSE)+
                theme(axis.title = element_text(face="bold" ))


panel_b

## -----------------------------------------------------------------------------
proteomics_file <- system.file("real_data_examples/result_files", "proteomics_benchmark.Rds", package = "IHWpaper")
proteomics_data <- readRDS(file=proteomics_file)
panel_c_data <- group_by(proteomics_data$alpha_df, alpha) %>% summarize(BH = max(bh_rejections), IHW=max(rejections)) %>% 
                     gather(method, rejections, BH, IHW) %>%
                     mutate(method = factor(as.character(method), levels=pretty_names))

## -----------------------------------------------------------------------------
last_vals_c <- group_by(panel_c_data, method) %>% 
               summarize(last_vals = max(rejections)) %>%
               mutate(label = method,
                   colour = pretty_colors[match(label, pretty_names)])


panel_c <- ggplot(panel_c_data, aes(x=alpha,y=rejections,col=method)) +  
                geom_line(size=1.2) +
                xlab(expression(bold(paste("Nominal ",alpha)))) +
                ylab("Discoveries") +
                scale_color_manual(values=pretty_colors)+
                scale_x_continuous(expand=c(0,0))+
                theme(plot.margin = unit(c(1, 7.5, 2, 1), "lines"))+
                theme(axis.title = element_text(face="bold" ))


panel_c <- pretty_legend(panel_c, last_vals_c, 0.102)
panel_c

## -----------------------------------------------------------------------------
breaks <- proteomics_data$breaks
break_min <- proteomics_data$break_min

breaks_left <- c(break_min,breaks[-length(breaks)])

step_df <- mutate(filter(proteomics_data$alpha_df , alpha==0.1), break_left = breaks_left[stratum],
                 break_right = breaks[stratum],
                 break_ratio = break_right/break_left , 
                 break_left =break_left * break_ratio^.1,
                 break_right = break_right *break_ratio^(-.1))

stratum_fun <- function(df){
  stratum <- df$stratum
  weight <- df$weight
  stratum_left <- stratum[stratum != length(stratum)]
  weight_left  <- weight[stratum_left]
  break_left <- df$break_right[stratum_left]
  stratum_right <- stratum[stratum != 1]
  weight_right <- weight[stratum_right]
  break_right <- df$break_left[stratum_right]
  data.frame(stratum_left= stratum_left, weight_left= weight_left, 
             stratum_right = stratum_right, weight_right = weight_right,
             break_left = break_left, break_right = break_right)
}

connecting_df <- step_df %>% group_by(fold) %>% 
                  do(stratum_fun(.)) %>%
                  mutate(dashed = factor(ifelse(abs(weight_left - weight_right) > 10^(-5) , TRUE, FALSE),
                         levels=c(FALSE,TRUE)))

panel_d <- ggplot(step_df, aes(x=break_left, xend=break_right,y=weight, yend=weight, col=fold)) +
                geom_segment(size=0.8)+                
                geom_segment(data= connecting_df, aes(x=break_left, xend=break_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                             size=0.8)+
                scale_x_log10(breaks=c(1, 10,100,400)) +
                xlab("Number of peptides quantified")+
                ylab("Weight")+
                theme(legend.position=c(0.8,0.4)) +
                theme(plot.margin = unit(c(1, 1, 2, 1), "lines"))+
                guides(linetype=FALSE)+
                theme(axis.title = element_text(face="bold" ))


panel_d

## -----------------------------------------------------------------------------
hqtl_file <- system.file("real_data_examples/result_files", "hQTL_benchmark.Rds", package = "IHWpaper")
hqtl_data <- readRDS(file=hqtl_file)
hqtl_summary <- group_by(hqtl_data$alpha_df, alpha) %>%  gather(method, rejections, 6:10) %>%
                select(alpha, method, rejections)

# will use below later to convert to nicer names for our plot
# see http://stackoverflow.com/questions/7547597/dictionary-style-replace-multiple-items-in-r
map <- setNames(pretty_names,
               c("rejections","bh_rejections","threshold:10000","threshold:2e+05", "threshold:1e+06"))

## -----------------------------------------------------------------------------

hqtl_summary <- mutate(hqtl_summary, method = map[method], 
                       method= factor(method, levels = pretty_names))

last_vals_e <- group_by(hqtl_summary, method) %>% 
               summarize(last_vals = max(rejections))  %>%
               mutate(last_vals = last_vals + c(0,0, 250, 0, -350), # offset to make it look nice
                      label = method,
                      colour = pretty_colors[match(label, pretty_names)])


panel_e <- ggplot(hqtl_summary, aes(x=alpha,y=rejections,col=method)) +  
                geom_line(size=1.2) +
                xlab(expression(bold(paste("Nominal ",alpha)))) +
                ylab("Discoveries") +
                scale_x_continuous(expand=c(0,0))+
                scale_color_manual(values=pretty_colors)+
                theme(plot.margin = unit(c(1, 7.5, 2, 1), "lines"))+
                theme(axis.title = element_text(face="bold" ))



panel_e <- pretty_legend(panel_e, last_vals_e, 0.102)
panel_e 

## -----------------------------------------------------------------------------
breaks <-   hqtl_data$breaks
breaks <- breaks[-1]
break_min <- hqtl_data$break_min
breaks_left <- c(break_min,breaks[-length(breaks)])
step_df <- mutate(filter(hqtl_data$alpha_df,alpha==0.1), break_left = breaks_left[stratum],
                 break_right = breaks[stratum],
                 break_ratio = break_right/break_left , 
                 break_left =break_left * break_ratio^.2,
                 break_right = break_right *break_ratio^(-.2))

stratum_fun <- function(df){
  stratum <- df$stratum
  weight <- df$weight
  stratum_left <- stratum[stratum != length(stratum)]
  weight_left  <- weight[stratum_left]
  break_left <- df$break_right[stratum_left]
  stratum_right <- stratum[stratum != 1]
  weight_right <- weight[stratum_right]
  break_right <- df$break_left[stratum_right]
  data.frame(stratum_left= stratum_left, weight_left= weight_left, 
             stratum_right = stratum_right, weight_right = weight_right,
             break_left = break_left, break_right = break_right)
}

connecting_df <- step_df %>% group_by(fold) %>% 
                  do(stratum_fun(.)) %>%
                  mutate(dashed = factor(ifelse(abs(weight_left - weight_right) > 2 , TRUE, FALSE),
                         levels=c(FALSE,TRUE)))

panel_f <- ggplot(step_df, aes(x=break_left, xend=break_right,y=weight, yend=weight, col=fold)) +
                geom_segment(size=0.8)+                
                geom_segment(data= connecting_df, aes(x=break_left, xend=break_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                             size=0.8)+
                scale_x_log10(breaks=c(10^4, 10^5,10^6,10^7), 
                              labels = trans_format("log10", math_format(10^.x))) +
                xlab("Genomic distance (bp)")+
                ylab("Weight")+
                theme(legend.position=c(0.8,0.4)) +
                theme(plot.margin = unit(c(1, 1, 2, 1), "lines"))+
                theme(axis.title = element_text(face="bold" ))+
                guides(linetype=FALSE)

panel_f


## ----fig.width=12, fig.height=10----------------------------------------------
full_fig <- plot_grid(panel_a, 
                      panel_c, 
                      panel_e, panel_f,
                      labels= c("a)", "b)", "c)",
                              "d)"),
                      nrow=2)
full_fig

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=full_fig, file="data_examples.pdf", width=12, height=10)

## ----fig.width=12, fig.height=5-----------------------------------------------
suppl_fig <- plot_grid(panel_b,
                       panel_d,
                       labels= c("a)", "b)"),
                       nrow=1)
suppl_fig

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=suppl_fig, file="data_examples_suppl.pdf", width=12, height=5)

#!/usr/bin/env Rscript


library("IHWpaper")


register(MulticoreParam(workers=5, verbose=TRUE))

#----------------- General benchmark settings -------------------------------#
alphas <- seq(0.01, .1, length=10)
nreps <- 4000 # number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000

sim_funs <- list(null_sim_fun(ms))

#------------- Methods to be benchmarked ------------------------------------#

continuous_methods_list <- list(ihw_5fold_reg)


fdr_methods <- lapply(continuous_methods_list, continuous_wrap)


###############################################################################
eval_table <- run_evals(sim_funs, fdr_methods, nreps, alphas, BiocParallel=TRUE)

saveRDS(eval_table, file="result_files/ihw_null_simulation_benchmark_E3.Rds")

#' IHW wrappers
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param filterstat   Factor to which different hypotheses belong
#' @param alpha    Significance level at which to apply method
#'
#' @return ihwResult multiple testing object
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      obj <- ihw_5fold(sim_df$pvalue, sim_df$filterstat, .1)
#'      sum(rejected_hypotheses(obj))
#'
#' @details
#'     These are closures, which apply IHW with custom
#'   prespecified parameters. These correspond to interesting
#'   settings, for which it is convenient to be able to immediately
#'   call the corresponding functions, rather than having to specify
#'   parameters each time. Thus they make it easier to benchmark.
#'   All of these wrappers are defined in 2 lines of code, 
#'   so the settings pertaining
#'   to each one can be inspected by typing the functions name into the
#'   console.
#'
#'
#' @import IHW
#' @export
#' @describeIn ihw_naive IHW naive
ihw_naive <- function(unadj_p, filterstat, alpha){
 	obj <- ihw(unadj_p, filterstat, alpha, nbins=20, nfolds=1, lambdas=Inf,
 		distrib_estimator="ECDF", lp_solver="gurobi")
 	obj
}

attr(ihw_naive, "testing covariate") <- "continuous"
attr(ihw_naive, "fdr_method")        <- "IHW naive"


#' @describeIn ihw_naive  IHW (E2) with 5 folds
#' @export
ihw_ecdf_5fold <- function(unadj_p, filterstat, alpha){
	obj <- ihw(unadj_p, filterstat, alpha, nbins=20, nfolds=5, lambdas=Inf,
 		distrib_estimator="ECDF", lp_solver="gurobi")
 	obj
}

attr(ihw_ecdf_5fold, "testing covariate") <- "continuous"
attr(ihw_ecdf_5fold, "fdr_method")        <- "IHW ECDF"


#' @describeIn ihw_naive  IHW (E1-E2) with 5 folds
#' @export
ihw_5fold <- function(unadj_p, filterstat, alpha){
 	obj <- ihw(unadj_p, filterstat, alpha, nbins=20, nfolds=5, lambdas=Inf,
 		distrib_estimator="grenander", lp_solver="lpsymphony")
 	obj
}

attr(ihw_5fold, "testing covariate") <- "continuous"
attr(ihw_5fold, "fdr_method")        <- "IHW"

#' @describeIn ihw_naive  IHW (E1-E2-E3) with 5 folds
#' @export
ihw_5fold_reg <- function(unadj_p, filterstat, alpha){
  obj <- ihw(unadj_p, filterstat, alpha, nbins=20, nfolds=5,
             distrib_estimator="grenander", lp_solver="lpsymphony")
  obj
}

attr(ihw_5fold_reg, "testing covariate") <- "continuous"
attr(ihw_5fold_reg, "fdr_method")        <- "IHW E3"



#--------------- IHW-Bonferroni----------------------------------------

#' @describeIn ihw_naive  IHW-Bonferroni (E1-E2-E3) with 5 folds
#' @export
ihw_bonf_5fold_reg <- function(unadj_p, filterstat, alpha){
  obj <- ihw(unadj_p, filterstat, alpha, nbins=20, nfolds=5,
             distrib_estimator="grenander", lp_solver="lpsymphony",
             adjustment_type="bonferroni")
  obj
}

attr(ihw_bonf_5fold_reg, "testing covariate") <- "continuous"
attr(ihw_bonf_5fold_reg, "fdr_method")        <- "IHW-Bonferroni E3"


#------------------ IHW-Storey ------------------------------------------
#' @describeIn ihw_naive  IHW (E1-E2) with 5 folds and Storey's pi0 estimator
#' @export
ihw_storey_5fold <- function(unadj_p, filterstat, alpha){
    obj <- ihw(unadj_p, filterstat, alpha, nbins=20, nfolds=5, lambdas=Inf,
        distrib_estimator="grenander", lp_solver="lpsymphony",
        null_proportion=TRUE, null_proportion_level = 0.5)
    obj
}

attr(ihw_storey_5fold, "testing covariate") <- "continuous"
attr(ihw_storey_5fold, "fdr_method")        <- "IHW-Storey"

#!/usr/bin/env Rscript

library("IHWpaper")

args <- commandArgs(trailingOnly=TRUE)
idx <- as.integer(args[1])

if (length(args)==0) {
  stop("At least one argument must be supplied (input file).\n", call.=FALSE)
}

register(MulticoreParam(workers=12))

#----------------- General benchmark settings -------------------------------#
alphas <- 0.1
nreps <- 500  #number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000

xi_maxs<- seq(3, 6, length=10)
xi_maxs <- xi_maxs[idx]

sim_funs <- lapply(xi_maxs, function(x) wasserman_normal_sim_fun(20000,0.9,1, x))



#------------- Methods to be benchmarked ------------------------------------#
continuous_methods_list <- list(ihw_bonf_5fold_reg, bonf)

fdr_methods <- lapply(continuous_methods_list, continuous_wrap)


#-----------------------------------------------------------------------------
eval_table <- run_evals(sim_funs, fdr_methods, nreps, alphas, BiocParallel=T)
eval_table$xi_max = sapply(strsplit(eval_table$sim_pars,"xi_max:"),
                function(x) as.numeric(x[2]))

file_name <- file.path("result_files","ihw_bonf_wasserman_normal",
                        paste0("par_setting_",idx,".Rds"))
saveRDS(eval_table, file=file_name)

# this file includes all methods which operate in a stratified fashion,
# i.e. as input they expect the raw p--values and a corresponding factor.

#' gbh: Grouped Benjamini Hochberg
#'
#'
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param groups   Factor to which different hypotheses belong
#' @param alpha    Significance level at which to apply method
#' @param method   What pi0 estimator should be used (available "TST","LSL")
#' @param pi0_global GBH requires also a pi0 estimate for the marginal p-value distribution. Can either apply pi0 estimation method to
#'    all p-values (pi0_global="global") or use a weigted averarage (pi0_global="weighted_average") of the pi0 estimates within each stratum.
#'    This is not explicitly stated in the paper, but based on a reproduction of their paper figures it seems to be the weighted_average.
#'
#' @return GBH multiple testing object
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      sim_df$group <- groups_by_filter(sim_df$filterstat, 20)
#'      obj <- tst_gbh(sim_df$pvalue, sim_df$group, .1)
#'      sum(rejected_hypotheses(obj))
#'
#' @references  Hu, James X., Hongyu Zhao, and Harrison H. Zhou. "False discovery rate control with groups." 
#'         Journal of the American Statistical Association 105.491 (2010).
#' @export
gbh <- function(unadj_p, groups, alpha, method="TST", pi0_global="weighted_average"){

  # special care has to be taken for TST GBH, uses alpha/(1+alpha) instead of alpha

  groups <- as.factor(groups)
  pv_list <- split(unadj_p, groups)

  if (method == "TST"){
    pi0_fun <- function(pv) tst_pi0_est(pv, alpha) # as described in GBH paper for this case
  } else if (method == "LSL") {
    pi0_fun <- lsl_pi0_est
  }

  m        <- length(unadj_p)
  m_groups <- sapply(pv_list, length)
  pi0_groups <- sapply(pv_list, pi0_fun)

  # in this case we reject no hypothesis
  if (all(pi0_groups ==1 )){
    pi0 <- 1
    adj_p <- rep(1,m)
    weighted_pvals <- unadj_p
  # do actual work
  } else {
    # get pi0 estimate (unstratified)
    if (pi0_global=="weighted_average"){
      pi0 <- sum(m_groups*pi0_groups)/m #average pi0 across all strata
    } else if (pi0_global=="global"){
      pi0 <- pi0_fun(unadj_p)
    }

    # helper functions
    my_mult <- function(a,b) ifelse(b==Inf, Inf, a*b)
    my_bh_adjust <- function(p, adjust_factor){      #standard step-up procedure
        i <- length(p):1L
        o <- order(p, decreasing = TRUE)
        ro <- order(o)
        pmin(1, cummin( my_mult(p[o], length(p)/i*adjust_factor))[ro])
    }

    weighted_pvals <- unsplit( mapply(function(pi0_g, pv) my_mult(pi0_g/(1-pi0_g), pv), pi0_groups, pv_list,  SIMPLIFY=FALSE), groups)

    adjust_factor <- if (method == "TST"){
                         (1-pi0)*(1+alpha) # to make sure that TST GBH is applied at alpha/(1+alpha)
                      } else if (method=="LSL") {
                         (1-pi0)
                      }

    adj_p <- my_bh_adjust(weighted_pvals, adjust_factor)
  }

  obj <- list(weighted_pvals=weighted_pvals, adj_p = adj_p,
              pi0_groups = pi0_groups, pi0=pi0,
              method=paste(method,"GBH"), alpha=alpha)
  class(obj) <- "GBH"
  obj
}
attr(gbh, "testing covariate") <- "stratified" # i.e. covariates can be considered by stratifying based on them
attr(gbh, "fdr_method")        <- "GBH"

#' tst_gbh: wrapper for gbh with method="TST"
#' lsl_gbh: wrapper for gbh with method="LSL"
#'

#' @describeIn gbh Wrapper of GBH with TST pi0 estimator
#' @param ... Additional arguments passed from tst_gbh/lsl_gbh to gbh
#' @export
tst_gbh <- function(unadj_p, groups, alpha, ...) gbh(unadj_p, groups, alpha, method="TST", ...)
attr(tst_gbh, "testing covariate") <- "stratified" # i.e. covariates can be considered by stratifying based on them
attr(tst_gbh, "fdr_method")        <- "TST GBH"

#' @describeIn gbh Wrapper of GBH with LSL pi0 estimator
#' @export
lsl_gbh <- function(unadj_p, groups, alpha, ...) gbh(unadj_p, groups, alpha, method="LSL", ...)
attr(lsl_gbh, "testing covariate") <- "stratified" # i.e. covariates can be considered by stratifying based on them
attr(lsl_gbh, "fdr_method")        <- "LSL GBH"

#
rejected_hypotheses.GBH <- function(object, alpha= object$alpha){
  object$adj_p <= alpha
}

setOldClass("GBH")
setMethod("rejected_hypotheses", signature("GBH"), rejected_hypotheses.GBH)

#' stratified_bh: Stratified Benjamini Hochberg
#'
#'
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param groups   Factor to which different hypotheses belong
#' @param alpha    Significance level at which to apply method
#'
#' @return SBH multiple testing object
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      sim_df$group <- groups_by_filter(sim_df$filterstat, 20)
#'      obj <- stratified_bh(sim_df$pvalue, sim_df$group, .1)
#'      sum(rejected_hypotheses(obj))
#'
#' @references Sun, Lei, et al. "Stratified false discovery control for large-scale hypothesis testing with application to genome-wide
#'    association studies." Genetic epidemiology 30.6 (2006): 519-530.
#' @references Yoo, Yun J., et al. "Were genome-wide linkage studies a waste of time? Exploiting candidate regions within genome-wide
#'    association studies." Genetic epidemiology 34.2 (2010): 107-118.
#' @export
stratified_bh <- function(unadj_p, groups, alpha){
    groups <- as.factor(groups)
    pv_list <- split(unadj_p, groups)

    m        <- length(unadj_p)
    m_groups <- sapply(pv_list, length)

    adj_pv_list <- lapply(pv_list, function(pv) p.adjust(pv, method="BH"))
    adj_p <- unsplit(adj_pv_list, groups)

    obj <- list(adj_p = adj_p, alpha=alpha)
    class(obj) <- "SBH"
    obj
}

attr(stratified_bh, "testing covariate") <- "stratified" # i.e. covariates can be considered by stratifying based on them
attr(stratified_bh, "fdr_method")        <- "SBH"

rejected_hypotheses.SBH <- function(object, alpha= object$alpha){
    object$adj_p <= alpha
}

setOldClass("SBH")
setMethod("rejected_hypotheses", signature("SBH"), rejected_hypotheses.SBH)


#' clfdr: Cai's local fdr based method
#'
#'
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param groups   Factor to which different hypotheses belong
#' @param alpha    Significance level at which to apply method
#' @param lfdr_estimation  Method used to estimate the loca fdr, defaults to "fdrtool"
#'
#' @return Clfdr multiple testing object
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      sim_df$group <- groups_by_filter(sim_df$filterstat, 20)
#'      obj <- clfdr(sim_df$pvalue, sim_df$group, .1)
#'      sum(rejected_hypotheses(obj))
#'
#' @references Cai, T. Tony, and Wenguang Sun. "Simultaneous testing of grouped hypotheses: Finding needles in multiple haystacks." 
#'           Journal of the American Statistical Association 104.488 (2009).
#' @export
clfdr <- function(unadj_p, groups, alpha, lfdr_estimation="fdrtool"){

  # estimate local fdr within each stratum first

  lfdr_res <- lfdr_fit(unadj_p, groups, lfdr_estimation=lfdr_estimation)
  lfdrs <- lfdr_res$lfdr

  # now use the rejection rule described in Cai's paper

  # Remark:
  # When sorting lfdrs, we break ties by pvalues so that in the end within each stratum
  # we get monotonic adjusted p-values as a function of the p-values
  # This is mainly needed for grenander based lfdrs, with most other
  # lfdr estimation methods lfdr ties are not a problem usually

  o <- order(lfdrs, unadj_p)
  lfdrs_sorted <- lfdrs[o]
  fdr_estimate <- cumsum(lfdrs_sorted)/(1:length(unadj_p))
  adj_p <- rev(cummin(rev(fdr_estimate)))
  adj_p <- adj_p[order(o)]


  obj <- list(adj_p = adj_p, alpha=alpha, lfdr_estimation=lfdr_estimation)
  class(obj) <- "Clfdr"
  obj
}

attr(clfdr, "testing covariate") <- "stratified" # i.e. covariates can be considered by stratifying based on them
attr(clfdr, "fdr_method")        <- "Clfdr"

rejected_hypotheses.Clfdr <- function(object, alpha= object$alpha){
    object$adj_p <= alpha
}

setOldClass("Clfdr")
setMethod("rejected_hypotheses", signature("Clfdr"), rejected_hypotheses.Clfdr)



# helper function for cai
#' @importFrom fdrtool fdrtool
lfdr_fit <- function(unadj_p, group, lfdr_estimation="fdrtool"){

  pvals_list <- split(unadj_p, group)

  if (lfdr_estimation == "fdrtool"){
      lfdr_fun <- function(pv) fdrtool(pv, statistic="pvalue",plot=FALSE,verbose=FALSE)$lfdr

  } else if (lfdr_estimation == "locfdr"){
        if (!requireNamespace("locfdr", quietly=TRUE)){
            stop("locfdr package required for this function to work.")
        }
        lfdr_fun <- function(pv) locfdr::locfdr(qnorm(pv), nulltype=0, plot=0)$fdr
  } else {
    stop("This lfdr estimation method is not available.")
  }

  lfdr_list <- lapply(pvals_list, lfdr_fun)
  lfdrs <- unsplit(lfdr_list, group)

  fit_obj <- data.frame(pvalue=unadj_p, lfdr=lfdrs, group=group)
  fit_obj
}

#!/usr/bin/env Rscript

# implement the below mainly for size-investing strategy illustration 
library("IHWpaper")

register(BatchJobsParam())

#----------------- General benchmark settings -------------------------------#
alphas <- .1#c(0.1, 0.01)
nreps <- 500  #number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000

xi_maxs<- seq(3, 6, length=10)

sim_funs <- lapply(xi_maxs, function(x) wasserman_normal_sim_fun(20000,0.9,1, x))



#------------- Methods to be benchmarked ------------------------------------#
continuous_methods_list <- list(ihw_5fold_reg)

fdr_methods <- lapply(continuous_methods_list, continuous_wrap)


#-----------------------------------------------------------------------------
eval_table <- run_evals(sim_funs, fdr_methods, nreps, alphas, BiocParallel=T)
eval_table$xi_max = sapply(strsplit(eval_table$sim_pars,"xi_max:"),
                function(x) as.numeric(x[2]))

saveRDS(eval_table, file="result_files/ihw_wasserman_normal_simulation_benchmark_E3.Rds")

################################################################################
# Note: This is the only example in the paper which is not reproducible yet,
# since many of the files are too large to include. We will provide a solution
# at a later time point, but include the code so all the steps can at least
# be followed.
################################################################################

##########################################################
# Step 1: Get the hQTL p-values using matrix eQTL
##########################################################

# redo judith's analysis but with only one chromosome
library("DESeq2")
library("preprocessCore")
library("MatrixEQTL")
library("peer")
library("genefilter")
library("dplyr")

## set the project folder - it has to contain the object fileAnnoDF.rda 
projectFolder='/g/huber/users/ignatiadis/judith_hqtl/'

## load the fileAnnotationObject
load(paste(projectFolder,'fileAnnoDF.rda',sep=''))

## define the folder for the results
resultDir=paste(projectFolder,'/results/',sep='')
if(!file.exists(resultDir))system(paste('mkdir',resultDir))
plotFolder = paste(resultDir, 'plots/',sep='')
if(!file.exists(plotFolder))system(paste('mkdir',plotFolder))

# load the covariates
covariates_file_used = fileAnnoDF$FileLocation[fileAnnoDF$Filename=='covariates_file_used']
load(covariates_file_used)


# pick smallest chromosome...
snpchr <- 21
mod    <- 'H3K27AC'

cat('processing',mod,'...\n')

## load the peak annotations for the respective mark
peak_location_file_name = fileAnnoDF$FileLocation[fileAnnoDF$Filename=='peak_location_file_name'&fileAnnoDF$Mark==mod]
cat('reading peaks position file',mod,'...\n')
peakpos_all = read.table(peak_location_file_name, header = TRUE, stringsAsFactors = FALSE);
peakpos_all$chr=gsub('chr','',peakpos_all$chr)

## load the hpeaks signals for the respective mark
hpeaksfileName = fileAnnoDF$FileLocation[fileAnnoDF$Filename=='hpeaksfileName'&fileAnnoDF$Mark==mod]
cat('reading peaks signal file',mod,'...\n')
load(hpeaksfileName)
hpeaksMat = as.matrix(hpeaks)

cat('processing chromosome',snpchr,'...\n')

## define your output file
QTLresultFile = paste(resultDir, 'cisQTLs_',mod,'_chr',snpchr,'.txt',sep='')
logFile = paste(QTLresultFile,'.log',sep='')


snps_location_file_name = fileAnnoDF$FileLocation[fileAnnoDF$Filename=='snps_location_file_name'&fileAnnoDF$Chr==snpchr]
SNP_file_name_used = fileAnnoDF$FileLocation[fileAnnoDF$Filename=='SNP_file_name_used'&fileAnnoDF$Chr==snpchr]

snpspos = read.table(snps_location_file_name, header = TRUE, stringsAsFactors = FALSE);

snpspos = read.table(snps_location_file_name, header = TRUE, stringsAsFactors = FALSE);
snpspos=snpspos[,1:3]

## use only the peaks of the chromosome in question
peakpos=peakpos_all[peakpos_all$chr%in%snpchr,]

## load the SNP genotype information file
load(SNP_file_name_used)

## match columns of SNPs, covariates and peaks (there is one individual too many in the hpeaks)
snps$ColumnSubsample(snps$columnNames%in%colnames(hpeaksMat))
cvrt2<-cvrt
cvrt2$ColumnSubsample(cvrt2$columnNames%in%snps$columnNames)
cvrt2$ColumnSubsample(match(snps$columnNames,cvrt2$columnNames))

hpeaksMatT = hpeaksMat[rownames(hpeaksMat)%in%peakpos$id,]

## redefine the hpeaks, for a given chromosome, this speeds up the QTL calling
hpeaks2 = SlicedData$new();
hpeaks2$fileDelimiter = " "; # the TAB character
hpeaks2$fileOmitCharacters = "NA"; # denote missing values;
hpeaks2$fileSkipRows = 1; # one row of column labels
hpeaks2$fileSkipColumns = 1; # one column of row labels
hpeaks2$fileSliceSize = 2000; # read file in pieces of 2,000 rows
hpeaks2$CreateFromMatrix(hpeaksMatT[match(peakpos$id,rownames(hpeaksMatT)),match(snps$columnNames,colnames(hpeaksMatT))]);
hpeaks2$ResliceCombined()


## Main function (matrix eQTL)
me = Matrix_eQTL_main(
  gene = hpeaks2, 
  snps = snps, 
  cvrt = cvrt2,
  output_file_name = QTLresultFile,
  pvOutputThreshold  = 1,
  useModel = modelLINEAR,  
  errorCovariance = errorCovariance, 
  verbose = TRUE, 
  output_file_name.cis = NULL,
  pvOutputThreshold.cis = 0,#pvOutputThreshold,
  snpspos = snpspos, 
  genepos = peakpos[,1:4],
  cisDist = 0,
  pvalue.hist = 402)

saveRDS(me, file="chrom21H3K27AC") #save intermediate result


tmp <- readRDS("chrom21H3K27AC")
qtls <- tmp$all$eqtls
qtls$beta <- NULL
qtls$statistic <- NULL
qtls$FDR <- NULL
snpspos <- select(snpspos, snp, pos) %>% rename(snps = snp, snp_pos=pos)
qtls <- left_join(qtls, snpspos)

peakpos <- select(peakpos, id, start, end) %>% rename(gene=id, peak_start=start, peak_end=end)
peakpos <- mutate(peakpos, gene=as.factor(gene))

qtls <- left_join(qtls, peakpos)
# calculate distances
qtls <- mutate(qtls, dist = pmin(abs(peak_start-snp_pos), abs(peak_end-snp_pos)))
saveRDS(qtls, file="qtls_chrom_21.Rds")

##########################################################
# Step 2: Apply IHW and compare to BH/Indep. Filtering
##########################################################

library("IHW")


qtls <- readRDS(file = "qtls_chrom_21.Rds")
print("qtls loaded into memory")
  
## up to 300k in 10 bins
my_breaks <- c(-1, 
                 seq(from=10000,to=290000, by=10000) , 
                 seq(from=300000, to=0.9*10^6, by=100000),
                 seq(from=10^6, to=50*10^6, by=10^7))
myf <- cut(qtls$dist, my_breaks)
  
alphas <- seq(0.05,0.1,length=5)
filter_thresholds <- c(10^4, 2*10^5, 10^6)
dfs <- list()


for (i in seq_along(alphas)){
  alpha <- alphas[i]
  print(paste0("alpha:",alpha))
  x <- ddhw(qtls$pvalue, myf, alpha, lambdas=Inf,quiet=F)
  print("DDHW finished")
  ws <- weights(x, levels_only=TRUE)
  group_levels <- levels(groups_factor(x))
  folds  <- factor(1:x@nfolds)
  df <- expand.grid(stratum=1:nlevels(groups_factor(x)),
                    fold=folds)
  df$group <- group_levels[df$stratum]
  df$weight <- mapply(function(x,y) ws[x,y], df$stratum, df$fold)
  df$alpha <- alpha
  df$rejections <-rejections(x)
  df$bh_rejections <- sum(p.adjust(qtls$pvalue, method="BH") <= alpha, na.rm=T)
  for (filter_t in filter_thresholds){
    filter_f <- tail(which( my_breaks <= filter_t),1)-1
    filt_pvalue <- qtls$pvalue[as.numeric(myf) <= filter_f]
    df[paste0("threshold:", filter_t)] <- sum(p.adjust(filt_pvalue, method="BH") <= alpha, na.rm=T)
  }
  dfs[[i]] <- df
}

res <- list(alpha_df = bind_rows(dfs),
            breaks   = my_breaks,
            break_min = 5000)

saveRDS(res, file = paste0(projectFolder, "hQTL_benchmark.Rds"))

## ----warning=F, message=F-----------------------------------------------------
library("ggplot2")
library("grid")
library("dplyr")
library("cowplot")
library("IHWpaper")
theme_set(theme_cowplot())

## -----------------------------------------------------------------------------
methods_pretty <- c("BH", "Clfdr", "Greedy Indep. Filt.", "IHW", "IHW naive", "FDRreg", "LSL GBH", "SBH", "TST GBH")
colors <- scales::hue_pal(h = c(0, 360) + 15, c = 100, l = 65, h.start = 0,direction = 1)(10)

conservative_methods <- c("BH", "Clfdr", "IHW", "FDRreg", "LSL GBH")
conservative_idx <- match(conservative_methods, methods_pretty)

anticonservative_methods <- c("Greedy Indep. Filt.", "IHW naive", "SBH", "TST GBH")
anticonservative_idx     <- match(anticonservative_methods, methods_pretty)

## -----------------------------------------------------------------------------
null_grb_file <- system.file("simulation_benchmarks/result_files",
                        "ihw_null_simulation_benchmark_grb.Rds", package = "IHWpaper")
null_e3_file <- system.file("simulation_benchmarks/result_files",
                        "ihw_null_simulation_benchmark_E3.Rds", package = "IHWpaper")
null_file <- system.file("simulation_benchmarks/result_files",
                        "ihw_null_simulation_benchmark.Rds", package = "IHWpaper")
null_df <- rbind(readRDS(null_grb_file),
                 readRDS(null_e3_file),
                 readRDS(null_file)) %>% 
                 filter(fdr_method != "IHW") %>% # just show IHW with E1-E3 
                 mutate(fdr_method = ifelse(fdr_method=="IHW E3", "IHW", fdr_method),  
                           fdr_method = sapply(strsplit(fdr_method," 20"), "[",1),
                           fdr_method = factor(fdr_method, levels= methods_pretty)) 



## -----------------------------------------------------------------------------
panel_a_df <-  filter(null_df, fdr_method %in% anticonservative_methods)
last_vals_a <- group_by(panel_a_df, fdr_method) %>% summarize(last_vals = max(FDR)) %>%
               mutate(last_vals = last_vals + c(0, 0,0.05, -0.03), 
                    label = fdr_method,
                    colour = colors[anticonservative_idx])

panel_a <- ggplot(panel_a_df, aes(x=alpha, y=FDR, col=fdr_method)) +
                         geom_line(size=1.2) +
                         geom_abline(linetype="dashed") + 
                         xlab(expression(bold(paste("Nominal ",alpha)))) + 
                         scale_x_continuous(limits= c(0.01,0.1), breaks=seq(0.01,0.09,length=5)) +
                         ylim(0,0.9) +
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[anticonservative_idx])+
                         theme(axis.title = element_text(face="bold") )


panel_a <- pretty_legend(panel_a, last_vals_a, 0.102)
panel_a

## -----------------------------------------------------------------------------
panel_b_df <- filter(null_df, fdr_method %in% conservative_methods)

last_vals_b <- group_by(panel_b_df, fdr_method) %>% summarize(last_vals = max(FDR)) %>% 
             mutate(last_vals = last_vals +  c(0.005,0.005,-0.005, 0 ,-0.005 ), 
                    label = fdr_method,
                    colour = colors[conservative_idx])


panel_b <- ggplot(panel_b_df, aes(x=alpha, y=FDR, col=fdr_method)) +
                         geom_abline(linetype="dashed") + 
                         geom_line(size=1.2) +
                         xlab(expression(bold(paste("Nominal ",alpha)))) + 
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[conservative_idx])+
                         theme(axis.title = element_text(face="bold") )


panel_b <- pretty_legend(panel_b, last_vals_b, 0.102 )
panel_b

## ----fig.width=11, fig.height=5.5, eval=FALSE---------------------------------
# panel_ab <- plot_grid(panel_a, panel_b, labels=c("a)","b)"), vjust=4.5)
# 
# 
# panel_ab <- ggdraw(panel_ab) +
#           geom_rect(aes(xmin=0,xmax=1,ymin=0,ymax=0.95),
#                             color="black",alpha=0.0) +
#           draw_label("Nulls only", x = 1, y = 1,
#             vjust = 1, hjust = 1, size = 15, fontface = 'bold') +
#           theme(plot.margin=unit(c(.2,.2,.2,.2),"cm"))
# 
# panel_ab
# 
# #ggsave(panel_ab, "null_all.pdf",width=11,height=5.5)
# 

## -----------------------------------------------------------------------------
effsize_grb_file <- system.file("simulation_benchmarks/result_files",
                        "ihw_du_ttest_inform_simulation_benchmark_grb.Rds", package = "IHWpaper")
effsize_e3_file <- system.file("simulation_benchmarks/result_files",
                        "ihw_du_ttest_inform_simulation_benchmark_E3.Rds", package = "IHWpaper")
effsize_file <- system.file("simulation_benchmarks/result_files",
                         "ihw_du_ttest_inform_simulation_benchmark.Rds", package = "IHWpaper")
effsize_df <- rbind(readRDS(effsize_grb_file),
                    readRDS(effsize_file),
                    readRDS(effsize_e3_file)) %>%
              filter(fdr_method != "IHW") %>% # just show IHW with E1-E3 
              mutate(fdr_method = ifelse(fdr_method=="IHW E3", "IHW", fdr_method),  
                           fdr_method = sapply(strsplit(fdr_method," 20"), "[",1),
                           fdr_method = factor(fdr_method, levels= methods_pretty)) 

## -----------------------------------------------------------------------------
panel_c_df <- filter(effsize_df, fdr_method %in% conservative_methods)

last_vals_c <- group_by(panel_c_df, fdr_method) %>% summarize(last_vals =  FDR[which.max(eff_size)]) %>%
               mutate(last_vals = last_vals + c(0,0.005,-0.005, 0 ,-0.01 ), 
                      label = fdr_method,
                      colour = colors[conservative_idx])

panel_c <- ggplot(panel_c_df, aes(x=eff_size, y=FDR, col=fdr_method)) +
                         geom_hline(yintercept=0.1, linetype="dashed") + 
                         geom_line(size=1.2) +
                         xlab("Effect size") + 
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[conservative_idx])+
                         theme(axis.title = element_text(face="bold") )


panel_c <- pretty_legend(panel_c, last_vals_c, 2.52 )
panel_c

## -----------------------------------------------------------------------------
panel_d_df <- filter(effsize_df, fdr_method %in% conservative_methods)

last_vals_d <- group_by(panel_d_df, fdr_method) %>% summarize(last_vals = power[which.max(eff_size)]) %>%
               mutate(last_vals = last_vals + c(0,-0.015,-0.035, 0.035 ,+0.005 ), 
                      label = fdr_method,
                      colour = colors[conservative_idx])


panel_d <- ggplot(panel_c_df, aes(x=eff_size, y=power, col=fdr_method)) +
                         geom_line(size=1.2) +
                         xlab("Effect size") + 
                         ylab("Power")+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[conservative_idx])+
                         theme(axis.title = element_text(face="bold") )

panel_d <- pretty_legend(panel_d, last_vals_d, 2.52 )
panel_d

## ----fig.width=11, fig.height=5.5, eval=FALSE---------------------------------
# panel_cd <- plot_grid(panel_c, panel_d, labels=c("c)","d)"), vjust=4.5)
# 
# #ggsave(panel_cd, "t_test_full.pdf",width=11,height=5.5)
# panel_cd <- ggdraw(panel_cd) +
#           geom_rect(aes(xmin=0,xmax=1,ymin=0,ymax=0.95),
#                             color="black",alpha=0.0) +
#           draw_label("effect size", x = 1, y = 1,
#             vjust = 1, hjust = 1, size = 15, fontface = 'bold') +
#           theme(plot.margin=unit(c(.2,.2,.2,.2),"cm"))
# 
# panel_cd

## -----------------------------------------------------------------------------
sizeinvesting_grb_file <- system.file("simulation_benchmarks/result_files",
                        "ihw_wasserman_normal_simulation_benchmark_grb.Rds", package = "IHWpaper")
sizeinvesting_e3_file <-  system.file("simulation_benchmarks/result_files",
                        "ihw_wasserman_normal_simulation_benchmark_E3.Rds", package = "IHWpaper")
sizeinvesting_file <- system.file("simulation_benchmarks/result_files",
                         "ihw_wasserman_normal_simulation_benchmark.Rds", package = "IHWpaper")
sizeinvesting_df <- bind_rows(lapply(c(sizeinvesting_file,
                                       sizeinvesting_e3_file,
                                       sizeinvesting_grb_file), readRDS)) %>%
                    filter(fdr_method != "IHW") %>% # just show IHW with E1-E3 
                    # make names prettier and make sure we use same factor for everything
                    mutate(fdr_method = ifelse(fdr_method=="IHW E3", "IHW", fdr_method),  
                           fdr_method = sapply(strsplit(fdr_method," 20"), "[",1),
                           fdr_method = factor(fdr_method, levels= methods_pretty)) %>% 
                    # add log2 relative to BH
                    group_by(xi_max) %>% 
                    mutate(normalized = log2(power/max(power*(fdr_method=="BH"))))


## -----------------------------------------------------------------------------
panel_e_df <- filter(sizeinvesting_df, fdr_method %in% conservative_methods)

last_vals_e <- group_by(panel_e_df, fdr_method) %>% summarize(last_vals = FDR[which.max(xi_max)]) %>%
               mutate(last_vals = last_vals + c(0.0009,0,-0.0009, 0 ,0 ), 
                      label = fdr_method,
                      colour = colors[conservative_idx])

panel_e <- ggplot(panel_e_df, aes(x=xi_max, y=FDR, col=fdr_method)) +
                         geom_hline(yintercept=0.1, linetype="dashed") + 
                         geom_line(size=1.2) +
                         xlab(expression(bold(xi[max])))+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[conservative_idx])+
                         theme(axis.title = element_text(face="bold") )


panel_e <- pretty_legend(panel_e, last_vals_e, 6.02 )
panel_e

## -----------------------------------------------------------------------------
panel_f_df <- filter(sizeinvesting_df, fdr_method %in% conservative_methods)

last_vals_f <- group_by(panel_f_df, fdr_method) %>% summarize(last_vals = normalized[which.max(xi_max)]) %>%
               mutate(last_vals = last_vals +  c(0, 0, 0, +0.008 ,-0.002 ), 
                      label = fdr_method,
                      colour = colors[conservative_idx])

panel_f <- ggplot(panel_f_df, aes(x=xi_max, y=normalized, col=fdr_method)) +
                         geom_line(size=1.2) +
                         ylab(expression(bold(log[2](Power/Power[BH]))))+
                         xlab(expression(bold(xi[max])))+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[conservative_idx])+
                         theme(axis.title = element_text(face="bold") )


panel_f <- pretty_legend(panel_f, last_vals_f, 6.02 )
panel_f

## ----fig.width=11, fig.height=5.5, eval=FALSE---------------------------------
# panel_ef <- plot_grid(panel_e, panel_f, labels=c("e)","f)"), vjust=4.5)
# 
# #plot_grid(panel_c, panel_d)
# #ggsave("t_test_full.pdf",width=11,height=5.5)
# panel_ef <- ggdraw(panel_ef) +
#           geom_rect(aes(xmin=0,xmax=1,ymin=0,ymax=0.95),
#                             color="black",alpha=0.0) +
#           draw_label("size investing", x = 1, y = 1,
#             vjust = 1, hjust = 1, size = 15, fontface = 'bold') +
#           theme(plot.margin=unit(c(.2,.2,.2,.2),"cm"))
# 
# panel_ef

## ----fig.width=12, fig.height=16, eval=FALSE----------------------------------
# main_sim_fig <- plot_grid(panel_ab,panel_cd, panel_ef, nrow=3)
# main_sim_fig

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=main_sim_fig, file="main_simulations.pdf", width=12, height=16)

## ----fig.width=12, fig.height=16, eval=FALSE----------------------------------
# main_sim_fig <- plot_grid(panel_a,panel_b,
#                           panel_c,panel_d,
#                           panel_e, panel_f,
#                           nrow=3,
#                           labels= c("a)", "b)", "c)",
#                               "d)","e)","f)"))
# 
# main_sim_fig

## ----eval=FALSE---------------------------------------------------------------
# ggsave(plot=main_sim_fig, file="main_simulations.pdf", width=12, height=16)

## -----------------------------------------------------------------------------
# Supplementary Effect Size Simulation

## Supplementary panel a)


## -----------------------------------------------------------------------------
sup_panel_a_df <- filter(effsize_df, fdr_method %in% anticonservative_methods)

sup_last_vals_a <- group_by(sup_panel_a_df, fdr_method) %>%
                   summarize(last_vals =  FDR[which.max(eff_size)]) %>%
                   mutate(last_vals = last_vals + c(-0.001 ,+0.011,0, -0.003 ), 
                      label = fdr_method,
                      colour = colors[anticonservative_idx])

sup_panel_a <- ggplot(sup_panel_a_df, aes(x=eff_size, y=FDR, col=fdr_method)) +
                         geom_hline(yintercept=0.1, linetype="dashed") + 
                         geom_line(size=1.2) +
                         xlab("Effect size") + 
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[anticonservative_idx])+
                         theme(axis.title = element_text(face="bold") )


sup_panel_a <- pretty_legend(sup_panel_a, sup_last_vals_a, 2.52 )
sup_panel_a

## -----------------------------------------------------------------------------
sup_panel_b_df <- filter(effsize_df, fdr_method %in% anticonservative_methods)

sup_last_vals_b <- group_by(sup_panel_b_df, fdr_method) %>%
                   summarize(last_vals = power[which.max(eff_size)]) %>%
                   mutate(last_vals = last_vals + c(+0.015,+0.03,-0.03, -0.015 ), 
                      label = fdr_method,
                      colour = colors[anticonservative_idx])


sup_panel_b <- ggplot(sup_panel_b_df, aes(x=eff_size, y=power, col=fdr_method)) +
                         geom_line(size=1.2) +
                         xlab("Effect size") + 
                         ylab("Power")+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[anticonservative_idx])+
                         theme(axis.title = element_text(face="bold") )


sup_panel_b <- pretty_legend(sup_panel_b, sup_last_vals_b, 2.52 )
sup_panel_b

## ----fig.width=11, fig.height=5.5, eval=FALSE---------------------------------
# sup_panel_ab<- plot_grid(sup_panel_a, sup_panel_b, labels=c("a)","b)"), vjust=4.5)
# 
# sup_panel_ab <- ggdraw(sup_panel_ab) +
#           geom_rect(aes(xmin=0,xmax=1,ymin=0,ymax=0.95),
#                             color="black",alpha=0.0) +
#           draw_label("effect size", x = 1, y = 1,
#             vjust = 1, hjust = 1, size = 15, fontface = 'bold') +
#           theme(plot.margin=unit(c(.2,.2,.2,.2),"cm"))
# 
# sup_panel_ab

## -----------------------------------------------------------------------------
sup_panel_c_df <- filter(sizeinvesting_df, fdr_method %in% anticonservative_methods)

sup_last_vals_c <- group_by(sup_panel_c_df, fdr_method) %>% 
                   summarize(last_vals = FDR[which.max(xi_max)]) %>%
                   mutate(last_vals = last_vals +  c(0.00005,0, 0.001,-0.001), 
                      label = fdr_method,
                      colour = colors[anticonservative_idx])

sup_panel_c <- ggplot(sup_panel_c_df, aes(x=xi_max, y=FDR, col=fdr_method)) +
                         geom_hline(yintercept=0.1, linetype="dashed") + 
                         geom_line(size=1.2) +
                         xlim(3,6)+
                         xlab(expression(bold(xi[max])))+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[anticonservative_idx])+
                         theme(axis.title = element_text(face="bold") )


sup_panel_c <- pretty_legend(sup_panel_c, sup_last_vals_c, 6.02 )
sup_panel_c

## -----------------------------------------------------------------------------
sup_panel_d_df <- filter(sizeinvesting_df, fdr_method %in% anticonservative_methods)

sup_last_vals_d <- group_by(sup_panel_d_df, fdr_method) %>% 
                  summarize(last_vals = normalized[which.max(xi_max)]) %>%
                  mutate(last_vals = last_vals + c(0.00,0.0, +0.005, -0.005), 
                      label = fdr_method,
                      colour = colors[anticonservative_idx])

sup_panel_d <- ggplot(sup_panel_d_df, aes(x=xi_max, y=normalized, col=fdr_method)) +
                         geom_line(size=1.2) +
                         ylab(expression(bold(log[2](Power/Power[BH]))))+
                         xlab(expression(bold(xi[max])))+
                         xlim(3,6)+
                         ylim(-0.1,+0.3)+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors[anticonservative_idx])+
                         theme(axis.title = element_text(face="bold") )


sup_panel_d <- pretty_legend(sup_panel_d, sup_last_vals_d, 6.02 )
sup_panel_d

## ----fig.width=11, fig.height=5.5, eval=FALSE---------------------------------
# sup_panel_cd <- plot_grid(sup_panel_c, sup_panel_d, labels=c("c)","d)"), vjust=4.5)
# 
# #plot_grid(panel_c, panel_d)
# #ggsave("t_test_full.pdf",width=11,height=5.5)
# sup_panel_cd <- ggdraw(sup_panel_cd) +
#           geom_rect(aes(xmin=0,xmax=1,ymin=0,ymax=0.95),
#                             color="black",alpha=0.0) +
#           draw_label("size investing", x = 1, y = 1,
#             vjust = 1, hjust = 1, size = 15, fontface = 'bold') +
#           theme(plot.margin=unit(c(.2,.2,.2,.2),"cm"))
# 
# sup_panel_cd

## ----fig.width=12, fig.height=12, eval=FALSE----------------------------------
# sup_sim_fig <- plot_grid(sup_panel_ab,sup_panel_cd, nrow=2)
# sup_sim_fig

## ----eval=FALSE---------------------------------------------------------------
# cowplot::ggsave(plot=sup_sim_fig, file="suppl_simulations.pdf", width=12, height=12)

## ----fig.width=12, fig.height=12, eval=FALSE----------------------------------
# sup_sim_fig <- plot_grid(sup_panel_a,sup_panel_b,
#                           sup_panel_c,sup_panel_d,
#                           nrow=2,
#                           labels= c("a)", "b)", "c)",
#                               "d)"))
#   sup_sim_fig

## ----eval=FALSE---------------------------------------------------------------
# cowplot::ggsave(plot=sup_sim_fig, file="suppl_simulations.pdf", width=12, height=12)

#' bh: Wrapper for Benjamini Hochberg
#'
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param alpha    Significance level at which to apply method
#'
#' @return BH multiple testing object
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      obj <- bh(sim_df$pvalue, .1)
#'      sum(rejected_hypotheses(obj))
#'
#' @export
#' @importFrom stats p.adjust
#' @import methods
bh <- function(unadj_p, alpha){
  	adj_p <- p.adjust(unadj_p, method="BH")
  	obj <- list(adj_p = adj_p, alpha = alpha)
  	class(obj) <- "BH"
	obj
}
attr(bh, "testing covariate") <- "simple" #i.e. covariate not considered
attr(bh, "fdr_method")        <- "BH"     

rejected_hypotheses.BH <- function(object, alpha= object$alpha){
	object$adj_p <= alpha
}

setOldClass("BH")
setMethod("rejected_hypotheses", signature("BH"), rejected_hypotheses.BH)


#' storey_qvalue: Wrapper for Storey's qvalue package
#'
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param alpha    Significance level at which to apply method
#'
#' @return StoreyQValue multiple testing object
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      obj <- storey_qvalue(sim_df$pvalue, .1)
#'      sum(rejected_hypotheses(obj))
#'
#' @export
#' @importFrom qvalue qvalue
storey_qvalue <- function(unadj_p, alpha){
	qval_res <- qvalue(unadj_p, alpha)
	obj <- list(adj_p = qval_res$qvalues, pi0=qval_res$pi0, alpha=alpha)
	class(obj) <- "StoreyQValue"
	obj
}
attr(storey_qvalue, "testing covariate") <- "simple" #i.e. covariate not considered
attr(storey_qvalue, "fdr_method")        <- "qvalue"     

rejected_hypotheses.StoreyQValue <- function(object, alpha= object$alpha){
	object$adj_p <= alpha
}

setOldClass("StoreyQValue")
setMethod("rejected_hypotheses", signature("StoreyQValue"), rejected_hypotheses.StoreyQValue)


#' bonf: Wrapper for Bonferroni
#'
#' @param unadj_p  Numeric vector of unadjusted p-values.
#' @param alpha    Significance level at which to apply method
#'
#' @return Bonferroni multiple testing object
#'
#' @examples
#'      sim_df <- du_ttest_sim(20000,0.95, 1.5)
#'      obj <- bonf(sim_df$pvalue, .1)
#'      sum(rejected_hypotheses(obj))
#'
#' @export
bonf <- function(unadj_p, alpha){
    adj_p <- p.adjust(unadj_p, method="bonferroni")
    obj <- list(adj_p = adj_p, alpha = alpha)
    class(obj) <- "Bonferroni"
    obj
}
attr(bonf, "testing covariate") <- "simple" #i.e. covariate not considered
attr(bonf, "fdr_method")        <- "Bonferroni"

rejected_hypotheses.Bonferroni <- function(object, alpha= object$alpha){
    object$adj_p <= alpha
}

setOldClass("Bonferroni")
setMethod("rejected_hypotheses", signature("Bonferroni"), rejected_hypotheses.Bonferroni)

## ----warning=F, message=F-----------------------------------------------------
library("ggplot2")
library("dplyr")
library("tidyr")
library("gridExtra")
library("cowplot")
library("wesanderson")

## ----warning=F----------------------------------------------------------------
falt1 <- function(t){
    1-pnorm(qnorm(1-t)-mu1)
  }

  lfdr1 <- function(t){
    pi10/(pi10 + (1-pi10)*falt1_density(t))
  }
  falt1_density <- function(t){
      dnorm(qnorm(1-t)-mu1)/dnorm(qnorm(1-t))
  }

#http://stackoverflow.com/questions/10081479/solving-for-the-inverse-of-a-function-in-r
inverse = function (f, lower = -100, upper = 100) {
   function (y) uniroot((function (x) f(x) - y), lower = lower, upper = upper)[1]$roo
}

sim_pars <- function(eff_size, pi0){
  distrib <- function(t) pi0*t + (1-pi0)*(1-pnorm(qnorm(1-t)-eff_size))
  alt_density <-   function(t) dnorm(qnorm(1-t)-eff_size)/dnorm(qnorm(1-t))
  density <- function(t) pi0 + (1-pi0)*alt_density(t)
  tdr <- function(t)  1- pi0/density(t)
  inverse_f <- function(y) uniroot((function (x) density(x) - y), lower = 0.001, upper = 0.999)[1]$root
  tdr_density <- function(t) pi0*(inverse_f(pi0/(1-t)+0.001) - inverse_f(pi0/(1-t)-0.001))/0.002
  return(list(pi0=pi0,distrib=distrib, alt_density=alt_density,density=density, tdr=tdr, inverse_f=inverse_f,
            tdr_density=tdr_density  ))
}


## ----warning=F----------------------------------------------------------------
plot_tdr <- function(x,pi0,xthreshold=0.05){
  eff_size <- x
  pars <- sim_pars(x,pi0)
  df <- data.frame(t=seq(0.001,1, length=1000))
  df <- mutate(df, f1 = pars$alt_density(t), f=pars$density(t), tdr = pars$tdr(t))
  plot_pv <- ggplot(df, aes(x=t, y=f)) + 
                     geom_line()  + 
                     ylim(c(0,4)) + 
                     geom_vline(xintercept=xthreshold, col="blue") + 
                     geom_hline(yintercept=pars$pi0,col="red") +
                     #geom_hline(yintercept=pars$density(xthreshold), linetype=2)+
                     ylab("density")+
                     xlab("p-value")+
                     scale_x_continuous(expand = c(0, 0)) 
  
  plot_pv_vs_tdr <- ggplot(df, aes(x=t, y= tdr)) + 
                    geom_line() +
                    ylab("tdr")+
                    xlab("p-value")+
                    scale_x_continuous(expand = c(0, 0)) 
  
  # now also generate empirical histogram plots
  a = sim_pars(eff_size,pi0)
  m=100000
  H <- rbinom(m, 1, 1-pi0)
  X <- rnorm(m) + eff_size*H
  PV <- 1 - pnorm(X)
  TDR <- a$tdr(PV)
  
  sim_df <- data.frame(pvalue=PV, tdr=TDR)
  
  hist_pv <- ggplot(sim_df, aes(x=pvalue))
  grid.arrange(plot_pv, plot_pv_vs_tdr, ncol=1)
  
  pv_hist <- ggplot(sim_df, aes(x=pvalue)) + geom_histogram(aes(y = ..density..),binwidth=0.036, colour = "darkgreen", fill = "white") + xlab("p-value")
  tdr_hist <- ggplot(sim_df, aes(x=tdr)) + geom_histogram(aes(y = ..density..),binwidth=0.036, colour = "darkgreen", fill = "white") + xlab("tdr")
  list(plot_pv=plot_pv,  plot_pv_vs_tdr=plot_pv_vs_tdr, pv_hist=pv_hist, tdr_hist=tdr_hist)
}

## ----fig.keep="none", warning=F-----------------------------------------------
myplots <- c(plot_tdr(3.5, 0.6), plot_tdr(3.5,0.85), plot_tdr(1.5,0.6))
myplots <- myplots[c(1,5,9) + rep(0:3,each=3)]
myplots <- c(myplots, list(labels = letters[1:12]), list(ncol=3, align="hv"))

## ----warning=F, fig.width=10, fig.height=15-----------------------------------
do.call(plot_grid,myplots)

## ----eval=F-------------------------------------------------------------------
# pdf("pvalue_vs_tdr_explanation.pdf", width=10, height=15)
# do.call(plot_grid,myplots)
# dev.off()

## ----warning=F----------------------------------------------------------------

df <- data.frame(t=seq(0.00001,1, length=1000))
x <- 2.5
pi0 <- 0.8
eff_size <- x
pars <- sim_pars(x,pi0)
df1 <- mutate(df, f1 = pars$alt_density(t), CDF=pars$distrib(t), f=pars$density(t), tdr = pars$tdr(t), test = "1")
  
x <- 1.5
pi0 <- 0.9
eff_size <- x
pars <- sim_pars(x,pi0)
df2 <- mutate(df, f1 = pars$alt_density(t), CDF=pars$distrib(t), f=pars$density(t), tdr = pars$tdr(t), test = "2")

df <- rbind(df1,df2)
  
plot_tdr_inversed1 <- ggplot(df, aes(x=tdr, y= t,color=test)) + 
                    geom_line() +
                    xlab("tdr")+
                    ylab("p-value")+
                    scale_x_continuous(expand = c(0, 0)) +
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',
                                        labels = expression(H , tilde(H)))


plot_density1 <- ggplot(df, aes(x=t, y= f,color=test)) + 
                    geom_line() +
                    xlab("p-value")+
                    ylab("density")+
                    scale_x_continuous(expand = c(0, 0)) +
                    ylim(0,4) +
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',labels = expression(H , tilde(H)))


plot_cdf1 <- ggplot(df, aes(x=t, y= CDF,color=test)) + 
                    geom_line() +
                    xlab("p-value")+
                    ylab("CDF")+
                    scale_x_continuous(expand = c(0, 0)) +
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',labels = expression(H , tilde(H)))


## ----warning=F----------------------------------------------------------------
df <- data.frame(t=seq(0.00001,1, length=1000))
x <- 2.5
pi0 <- 0.8
eff_size <- x
pars <- sim_pars(x,pi0)
df1 <- mutate(df, f1 = pars$alt_density(t), CDF=pars$distrib(t), f=pars$density(t), tdr = pars$tdr(t), test = "1")
  
x <- 2.5
pi0 <- 0.9
eff_size <- x
pars <- sim_pars(x,pi0)
df2 <- mutate(df, f1 = pars$alt_density(t), CDF=pars$distrib(t), f=pars$density(t), tdr = pars$tdr(t), test = "2")
df <- rbind(df1,df2)
  
plot_tdr_inversed <- ggplot(df, aes(x=tdr, y= t,color=test)) + 
                    geom_line() +
                    xlab("tdr")+
                    ylab("p-value")+
                    expand_limits(x = c(0,1),y=0)  +
                    scale_x_continuous(expand=c(0,0),breaks=c(0, 0.25,0.5, 0.75,1),
                                        labels= c("0","0.25","0.5","0.75","1"))   +  
                    scale_y_continuous(expand=c(0,0),breaks=c(0, 0.25,0.5, 0.75,1),
                                       labels= c("0","0.25","0.5","0.75","1"))   +  
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',
                                          labels = expression(H[1] , H[2]))


plot_density <- ggplot(df, aes(x=t, y= f1,color=test)) + 
                    geom_line() +
                    xlab("p-value")+
                    ylab("alt")+
                    scale_x_continuous(expand = c(0, 0)) +
                    ylim(0,4) +
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',
                                        labels = expression(H , tilde(H)))


plot_cdf <- ggplot(df, aes(x=t, y= CDF,color=test)) + 
                    geom_line() +
                    xlab("p-value")+
                    ylab("CDF")+
                    scale_x_continuous(expand = c(0, 0)) +
                      scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',
                                          labels = expression(H , tilde(H)))

## ----fig.width=8, fig.height=6, warning=F-------------------------------------
plotgrid <- plot_grid(plot_cdf1, plot_cdf, plot_tdr_inversed1, plot_tdr_inversed, labels = letters[1:4], ncol=2, align="hv")
plotgrid

## ----eval=F-------------------------------------------------------------------
# pdf("tdr_size_investing.pdf", width=8, height=6)
# plotgrid
# dev.off()

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

ddhf_order <- function(sorted_p, filterorder, alpha) {
    .Call(`_IHWpaper_ddhf_order`, sorted_p, filterorder, alpha)
}

#!/usr/bin/env Rscript

library("IHWpaper")

args <- commandArgs(trailingOnly=TRUE)
idx <- as.integer(args[1])

if (length(args)==0) {
  stop("At least one argument must be supplied (input file).\n", call.=FALSE)
}

register(MulticoreParam(workers=8))

#----------------- General benchmark settings -------------------------------#

alphas <- seq(0.01, .1, length=10)
nreps <- 4000 # number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000

sim_funs <- list(null_sim_fun(ms))


# grab corresponding alpha
alphas <- alphas[idx]


#------------- Methods to be benchmarked ------------------------------------#
continuous_methods_list <- list(ihw_bonf_5fold_reg, bonf)

fdr_methods <- lapply(continuous_methods_list, continuous_wrap)


#-----------------------------------------------------------------------------
eval_table <- run_evals(sim_funs, fdr_methods, nreps, alphas, BiocParallel=TRUE)

file_name <- file.path("result_files","ihw_bonf_null",
                        paste0("par_setting_",idx,".Rds"))

saveRDS(eval_table, file=file_name)

# general functions to make it easy to benchmark FDR methods on given simulations..

#' run_evals: Main function to benchmark FDR methods on given simulations.
#' 
#' @param sim_funs List of simulation settings
#' @param fdr_methods List of FDR controlling methods to be benchmarked
#' @param nreps Integer, number of Monte Carlo replicates for the simulations 
#' @param alphas Numeric, vector of nominal significance levels 
#'	   at which to apply FDR controlling methods
#' @param ... Additional arguments passed to sim_fun_eval
#'
#' @return data.frame which summarizes results of numerical experiment
#'
#' @details
#'    This is the main workhorse function which runs all simulation benchmarks for IHWpaper.
#'    It receives input as described above, and the output is a data.frame with the
#'    following columns:
#'    \itemize{
#'			\item{fdr_method: }{Multiple testing method which was used}
#'          \item{fdr_pars: }{Custom parameters of the multiple testing method}
#'          \item{alpha: }{Nominal significance level at which the benchmark was run}
#'          \item{FDR: }{False Discovery Rate of benchmarked method on simulated dataset}
#'          \item{power: }{Power of benchmarked method on simulated dataset}
#'          \item{rj_ratio: }{Average rejections divided by total number of hypotheses}
#'			\item{FPR: }{False positive rate of benchmarked method on simulated dataset}
#'          \item{FWER: }{Familywise Error Rate of benchmarked method on simulated dataset}
#'          \item{nsuccessful: }{Number of successful evaluations of the method}
#'          \item{sim_method: }{Simulation scenario under which benchmark was run}
#'          \item{m: }{Total number of hypotheses}
#'          \item{sim_pars: }{Custom parameters of the simulation scenario}
#'    }
#'
#' @examples
#'    nreps <- 3 # monte carlo replicates
#'    ms <- 5000 # number of hypothesis tests
#'    eff_sizes <- c(2,3)
#'    sim_funs <- lapply(eff_sizes,
#'				function(x) du_ttest_sim_fun(ms,0.95,x, uninformative_filter=FALSE))
#' 	  continuous_methods_list <- list(bh,
#'                               	  lsl_gbh,
#'  	                          	  clfdr,
#'                                    ddhf)
#'   fdr_methods <- lapply(continuous_methods_list, continuous_wrap)
#'	 eval_table <- run_evals(sim_funs, fdr_methods, nreps, 0.1, BiocParallel=FALSE)
#'
#' @import dplyr
#' @importFrom BiocParallel bplapply
#' @export
run_evals <- function(sim_funs, fdr_methods, nreps, alphas,...){
	bind_rows(lapply(sim_funs, function(x) sim_fun_eval(x, fdr_methods, nreps, alphas, ...)))
}

sim_fun_eval <- function(sim_fun, fdr_methods, nreps, alphas, BiocParallel=TRUE){
	sim_seeds <- 1:nreps
	if (BiocParallel){
		evaluated_sims <- bplapply(sim_seeds, function(x) sim_eval(sim_fun, x, fdr_methods, alphas))
	} else {
		evaluated_sims <- lapply(sim_seeds, function(x) sim_eval(sim_fun, x, fdr_methods, alphas))
	}
	df <- dplyr::bind_rows(evaluated_sims)
	df <- dplyr::summarize(group_by(df, fdr_method, fdr_pars, alpha), FDR = mean(FDP),
		 power= mean(power), rj_ratio = mean(rj_ratio), FPR = mean(FPR), FDR_sd = sd(FDP), 
		 FWER=mean(FWER), nsuccessful = n())
	m  <- attr(sim_fun, "m")
	sim_method <- attr(sim_fun, "sim_method")
	sim_pars <- attr(sim_fun, "sim_pars")
	df <- mutate(df, sim_method = sim_method, m=  m, sim_pars = sim_pars)
	df
}

sim_eval <- function(sim_fun, seed, fdr_methods, alphas, print_dir = NULL){
	#print(paste("@@@@@ seed is ", seed))
	if (!is.null(print_dir)){
		sim_pars <- attr(sim_fun, "sim_pars")
		file_name <- paste0(print_dir, "seed", seed,"_", sim_pars, ".Rds")
		if (file.exists(file_name)){
			df <- readRDS(file_name)
		} else {
			sim <- sim_fun(seed) 
			df <- bind_rows(lapply(fdr_methods, function(fdr_method) sim_fdrmethod_eval(sim, fdr_method, alphas)))
			saveRDS(df, file=file_name)
		}
	} else {
		sim <- sim_fun(seed) 
		df <- bind_rows(lapply(fdr_methods, function(fdr_method) sim_fdrmethod_eval(sim, fdr_method, alphas)))
	}
	df
}

sim_fdrmethod_eval <- function(sim, fdr_method, alphas){
	bind_rows(lapply(alphas, function(a) sim_alpha_eval(sim, fdr_method, a)))
}

sim_alpha_eval <- function(sim, fdr_method, alpha){

	# tryCatch block mainly because many of the local fdr methods will occasionally crash
	df <- tryCatch({

    	df <- calculate_test_stats(sim, fdr_method, alpha)

		if (is.null(attr(fdr_method,"fdr_pars"))){
			fdr_pars <- NA
		} else{
			fdr_pars <- attr(fdr_method, "fdr_pars")
		}	
		df <- mutate(df, alpha= alpha, 
			fdr_pars = fdr_pars,
			fdr_method=attr(fdr_method,"fdr_method"))
		df
		
	}, error = function(e) {
    	 df <- data.frame()
    	 df		
		})
	df
}

calculate_test_stats <- function(sim, fdr_method, alpha){
	fdr_method_result <- fdr_method(sim, alpha)
	rejected <- rejected_hypotheses(fdr_method_result)
	rjs <- sum(rejected)
	false_rjs <- sum(sim$H == 0 & rejected)
	rj_ratio <- rjs/nrow(sim)
	FDP <- ifelse(rjs == 0, 0, false_rjs/rjs)
	power <- ifelse(sum(sim$H) == 0, NA, sum(sim$H == 1 & rejected)/sum(sim$H ==1))
	# in principle I should take special care in case only alternatives, but we are not
	# interested in this scenario...
	FPR <-  sum(sim$H == 0 & rejected)/sum(sim$H == 0)
	FWER <- as.numeric(false_rjs > 0)
	df <- data.frame(rj_ratio=rj_ratio, FDP=FDP, power=power, FPR=FPR, FWER=FWER)
	df
}

#' analyze_dataset: Basically performs preprocessing and then returns analyzed RNASeq dataset (diff. expression)
#'           , i.e. the DESeq2 result whose p-values and baseMean statistics can then be used with IHW
#'
#'
#' @param dataset  Character, name of dataset to be preprocessed, only 3 choices currently available ("airway","bottomly","hammer")
#' @param res      (default TRUE): return result table, rather than DESeq2 object
#'
#' @return Preprocessed dataset
#' @examples bottomly <- analyze_dataset("bottomly")
#'
#' @importFrom Biobase pData rowMax rowMin
#' @importFrom SummarizedExperiment assay colData
#' @importFrom BiocGenerics counts updateObject
#' @importFrom DESeq2 DESeqDataSet DESeq DESeqDataSetFromMatrix results
#' @import genefilter
#' @importFrom utils data
#' @export
analyze_dataset <- function(dataset=c("airway","bottomly","hammer"), res= TRUE) {

    if (dataset=="airway") {
      airway <- NULL
      if (!requireNamespace("airway", quietly = TRUE)){
        stop("airway data package required.")
      }
      data("airway", package="airway",envir=environment())
      dds <- DESeqDataSetFromMatrix(countData = assay(airway),
                                    colData = colData(airway),
                                    design = ~ cell + dex)
      # have to use hack above, because
      # dds <- DESeqDataSet(se = airway, design = ~ cell + dex)
      # throws the following error for some reason:
      # "Error in checkSlotAssignment(object, name, value)
      #  assignment of an object of class "ShallowSimpleListAssays"
      #  is not valid for slot 'assays' in an 
      #  object of class "DESeqDataSet"; is(value, "Assays") is not TRUE
      dds <- DESeq(dds)
      
    } else if (dataset == "bottomly") {
      bottomly.eset <- NULL
      load(system.file("extdata/real_data", "bottomly_eset.RData", package = "IHWpaper"),
        envir= environment())
      countData <- Biobase::exprs(bottomly.eset)
      colData <- pData(bottomly.eset)
      dds <- DESeqDataSetFromMatrix(countData = countData, colData = colData , design = ~strain)
      dds <- DESeq(dds)

    } else if (dataset == "hammer") {
      hammer.eset <- NULL
      load(system.file("extdata/real_data", "hammer_eset.RData", package = "IHWpaper"),
                        envir=environment())
      countData <- Biobase::exprs(hammer.eset)
      colData <- pData(hammer.eset)
      dds <- DESeqDataSetFromMatrix(countData = countData, colData = colData , design = ~protocol)
      dds <- dds[, dds$Time == "2 months"]
      dds <- DESeq(dds)
      
    } else {
      stop("No such dataset currently available!")
    }

  if (res){
    vars <- rowVars(counts(dds,normalized=TRUE))
    resDf <- as.data.frame(results(dds))
    resDf$var <- vars
    resDf$max <- rowMax(counts(dds,normalized=TRUE))
    resDf$min <- rowMin(counts(dds,normalized=TRUE))
    resDf <-subset(resDf, !is.na(resDf$pvalue)) #maybe remove that since IHW should be able to handle NAs anyway
    return (resDf)
  } else {
    return (dds)
  }

}

#!/usr/bin/env Rscript

library("IHWpaper")

args <- commandArgs(trailingOnly=TRUE)
idx <- as.integer(args[1])

if (length(args)==0) {
  stop("At least one argument must be supplied (input file).\n", call.=FALSE)
}

register(MulticoreParam(workers=8))

#----------------- General benchmark settings -------------------------------#
alphas <- 0.1
nreps <- 1000 # number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000
#sim_funs <- list(null_sim_fun(ms))
eff_sizes <- seq(1, 2.5, length=20)


# grab first effect size
eff_sizes <- eff_sizes[idx]

sim_funs <- lapply(eff_sizes, function(x) du_ttest_sim_fun(20000,0.95,x, uninformative_filter=F))

#------------- Methods to be benchmarked ------------------------------------#
continuous_methods_list <- list(ihw_bonf_5fold_reg, bonf)

fdr_methods <- lapply(continuous_methods_list, continuous_wrap)


#-----------------------------------------------------------------------------

eval_table <- run_evals(sim_funs, fdr_methods, nreps, alphas, BiocParallel=TRUE)
eval_table <- mutate(eval_table,
        eff_size = sapply(strsplit(eval_table$sim_pars,"effect size:"),
                function(x) as.numeric(x[2])))
eval_table <- mutate(eval_table, idx=idx)

file_name <- file.path("result_files","ihw_bonf_du_ttest_informative",
                        paste0("par_setting_",idx,".Rds"))
saveRDS(eval_table, file=file_name)

#!/usr/bin/env Rscript

library("IHWpaper")

args <- commandArgs(trailingOnly=TRUE)
idx <- as.integer(args[1])

if (length(args)==0) {
  stop("At least one argument must be supplied (input file).\n", call.=FALSE)
}

register(MulticoreParam(workers=9))

#----------------- General benchmark settings -------------------------------#
alphas <- 0.1
nreps <- 400 # number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000

param_df <- expand.grid(rho=seq(0,0.5,length=5),
                        latent_factors=c(1,10),
                        pi0=c(0.9,0.95,1),
                        xi_max = c(3,4))

# grab parameters for current run
rho <- param_df$rho[idx]
latent_factors <- param_df$latent_factors[idx]
pi0 <- param_df$pi0[idx]
xi_max <- param_df$xi_max[idx]

sim_funs <- list(wasserman_normal_prds_sim_fun(ms, pi0,
                    rho=rho, latent_factors=latent_factors, xi_min=0, xi_max=xi_max))

#------------- Methods to be benchmarked ------------------------------------#
continuous_methods_list <- list(bh,
                                ihw_5fold_reg)

fdr_methods <- lapply(continuous_methods_list, continuous_wrap)


#-----------------------------------------------------------------------------

eval_table <- run_evals(sim_funs, fdr_methods, nreps, alphas, BiocParallel=TRUE)

extract_params <- function(x){
  comma_split <- strsplit(x,", ")[[1]]
  par_split <- lapply(comma_split, function(presplit) strsplit(presplit,":")[[1]])
  df <- do.call(cbind, lapply(par_split, function(tmp) {tmp_df <-data.frame(as.numeric(tmp[2]));
                              names(tmp_df) <- tmp[1]; tmp_df}))
  df
}

eval_table <- eval_table %>%
            do(cbind(.,extract_params(.$sim_pars))) %>%
            mutate(idx=idx)

file_name <- file.path("result_files","ihw_wasserman_normal_prds",
                        paste0("par_setting_",idx,".Rds"))
saveRDS(eval_table, file=file_name)

library("IHWpaper")
library("IHW")

proteomics_file <- system.file("extdata/real_data",
                                "science_signaling.csv", package = "IHWpaper")

proteomics_df <- read.csv(proteomics_file, stringsAsFactors = F)

proteomics_df$pvalue <- rank(proteomics_df$p1, ties.method="first")*proteomics_df$p1/nrow(proteomics_df) 

ihw_res <- ihw(proteomics_df$pvalue,proteomics_df$X..peptides, .1, nbins=4, 
                 nsplits_internal=5, lambdas=seq(0,3,length=20))


get_alpha_df <- function(alpha, pvalue, filter_statistic, filter_thresholds,...){
  print(paste0("alpha:",alpha))
  x <- ihw(pvalue, filter_statistic, alpha,...)
  print("IHW finished")
  ws <- weights(x, levels_only=TRUE)
  group_levels <- levels(groups_factor(x))
  folds  <- factor(1:x@nfolds)
  df <- expand.grid(stratum=1:nlevels(groups_factor(x)),
                    fold=folds)
  df$group <- group_levels[df$stratum]
  df$weight <- mapply(function(x,y) ws[x,y], df$stratum, df$fold)
  df$alpha <- alpha
  df$rejections <-rejections(x)
  df$bh_rejections <- sum(p.adjust(pvalue, method="BH") <= alpha, na.rm=T)
  for (filter_t in filter_thresholds){
    filt_pvalue <- pvalue[filter_statistic <= filter_t]
    df[paste0("threshold:", filter_t)] <- sum(p.adjust(filt_pvalue, method="BH") <= alpha, na.rm=T)
  }
  df
}


alpha_df <- bind_rows(lapply(seq(0.05, 0.1, length = 5), get_alpha_df, proteomics_df$pvalue, 
                            proteomics_df$X..peptides,
                            c(), nbins=4, 
                            nsplits_internal=5, 
                            lambdas=seq(0,3,length=20)))

breaks <- IHW:::stratification_breaks(ihw_res)
break_min <- min(proteomics_df$X..peptides)

res <- list(alpha_df = alpha_df,
            breaks   = breaks,
            break_min = break_min,
            ihw_res  = ihw_res
            )

saveRDS(res, file="result_files/proteomics_benchmark.Rds")

#!/usr/bin/env Rscript

library("IHWpaper")


register(MulticoreParam(workers=5))

#----------------- General benchmark settings -------------------------------#
alphas <- 0.1
nreps <- 1000 # number of times each simulation should be repeated (monte carlo replicates)

#------------- Simulation function ------------------------------------------#
ms <- 20000
#sim_funs <- list(null_sim_fun(ms))
eff_sizes <- seq(1, 2.5, length=20)
sim_funs <- lapply(eff_sizes, function(x) du_ttest_sim_fun(20000,0.95,x, uninformative_filter=F))

#------------- Methods to be benchmarked ------------------------------------#
continuous_methods_list <- list(ihw_5fold_reg)

fdr_methods <- lapply(continuous_methods_list, continuous_wrap)


#-----------------------------------------------------------------------------

eval_table <- run_evals(sim_funs, fdr_methods, nreps, alphas, BiocParallel=TRUE)
eval_table <- mutate(eval_table,
		eff_size = sapply(strsplit(eval_table$sim_pars,"effect size:"),
				function(x) as.numeric(x[2])))

saveRDS(eval_table, file="result_files/ihw_du_ttest_inform_simulation_benchmark_E3.Rds")

## ----warning=FALSE, message=FALSE---------------------------------------------
library("ggplot2")
library("dplyr")
library("tidyr")
library("gridExtra")
#library("LSD")
library("IHW")

## -----------------------------------------------------------------------------
# try function with non-monotonic relation
sim <- function(m =20000){
  x <- 1-runif(m)
  pi0 <- 0.75+0.3*(x-0.5)^2#0.8 #ifelse(x<=.5, 0.5 + 0.6*x, 0.8)
  eff_size <- 2-2.2*abs(x-0.5)^1.3  #was 3.2 #ifelse(x <=.5, 1.5, 1.5-(x-1/2)*4)
  H <- rbinom(m, 1, 1-pi0)
  Z <- rnorm(m)
  Z[H==1] <- rnorm(sum(H), eff_size[H==1])
  pvalue <- 1-pnorm(Z)
  t <- pvalue
  t_bh <- get_bh_threshold(pvalue,0.1)

  alt_ft_bh <- dnorm(-eff_size+ qnorm(1-t_bh))/dnorm(qnorm(1-t_bh))
  tdr_bh <- alt_ft_bh*(1-pi0)/((1-pi0)*alt_ft_bh + pi0)
  t_ddhw <- thresholds(ihw(pvalue, x, alpha= .1, nbins=20,
                           nsplits_internal=10, nfolds = 1), levels_only=FALSE)

  alt_ft_ddhw <- dnorm(-eff_size+ qnorm(1-t_ddhw))/dnorm(qnorm(1-t_ddhw))
  tdr_ddhw <- alt_ft_ddhw*(1-pi0)/((1-pi0)*alt_ft_ddhw + pi0)

  alt_ft <- dnorm(qnorm(1-t)-eff_size)/dnorm(qnorm(1-t))
  tdr <- alt_ft*(1-pi0)/((1-pi0)*alt_ft + pi0)
  return(data.frame(x=x,pi0=pi0, t=t, eff_size=eff_size,H=H,
                    Z=Z, pvalue=pvalue, alt_ft=alt_ft, tdr=tdr,
                    tdr_bh=tdr_bh, alt_ft_bh=alt_ft_bh, t_bh=t_bh,
                    t_ddhw=t_ddhw, tdr_ddhw=tdr_ddhw, alt_ft_ddhw=alt_ft_ddhw))
}

## -----------------------------------------------------------------------------
set.seed(1)
sim_df <- sim(m=80000)

## -----------------------------------------------------------------------------
sim_df_t <- select(sim_df, x, t_bh, t_ddhw ) %>%
            gather(method, t, -x) %>%
            mutate(method=ifelse(method=="t_bh", "BH","IHW"))

ggplot(sim_df_t, aes(x=x, y=t,color=method)) +
                   geom_step() +
                   xlab("covariate") +
                   ylab("p-value threshold")

## -----------------------------------------------------------------------------
sim_df_tdr <- select(sim_df, x, tdr_bh, tdr_ddhw ) %>%
              gather(method, tdr, -x) %>%
              mutate(method=ifelse(method=="tdr_bh", "BH","IHW"))


ggplot(sim_df_tdr, aes(x=x, y=tdr,color=method)) +
                   geom_step() +
                   xlab("covariate") +
                   ylab("tdr threshold")

## -----------------------------------------------------------------------------
#sim_df$group <- groups_by_filter(sim_df$x, 10)
#plot(sim_df$x, sim_df$tdr_bh)

#with(filter(sim_df,-log10(pvalue) > 0.001), heatscatter(-log10(pvalue),x, add.contour=TRUE))
#with(filter(sim_df,tdr>0.2), heatscatter(tdr,x, add.contour=TRUE)) 

#ggplot(filter(sim_df), aes(x=-log10(pvalue), y=x)) + geom_density2d(aes(color = ..level..)) 
#ggplot(filter(sim_df, tdr>0.4), aes(x=tdr, y=x)) + geom_density2d(aes(color = ..level..)) 

---
title: "Grenander Estimator as applied to IHW (vs ECDF)"
author: "Nikos Ignatiadis"
date: "`r doc_date()`"
package: "`r pkg_ver('IHWpaper')`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{"Various: Grenander Estimator as applied to IHW (vs ECDF)"}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
---



This vignette is meant to illustrate how the distribution function of some p-values can be approximated by the ECDF and how the ECDF compares to the Grenander estimator, i.e. the least concave majorant (LCM) of the ECDF. The advantage of the Grenander estimator is that it convexifies the underlying optimization problem of IHW

```{r warning=F, message=F}
library("IHWpaper")
library("fdrtool")
library("ggplot2")
library("cowplot")
theme_set(theme_cowplot())
```

First we generate some p-values based on 100 independent t-tests. And calculate the ECDF and Grenander estimator.
```{r}
sim <- du_ttest_sim(100, 0.5, 2.5 ,seed=100)

sorted_pvalues <- sort(sim$pvalue)
n  <- length(sorted_pvalues)
unique_pvalues <- unique(sorted_pvalues)
ecdf_values <- cumsum(tabulate(match(sorted_pvalues, unique_pvalues)))/n

df_ecdf <- data.frame(x=unique_pvalues,y=ecdf_values)
gren <- IHW:::presorted_grenander(sorted_pvalues)
df_gren <- data.frame(x=gren$x.knots, y=gren$y.knots)
```

Let's plot the ECDF:
```{r}
ggplot(df_ecdf, aes(x=x, y=y)) + geom_step(direction="hv",size=1.3) +
                  scale_x_continuous(expand=c(0,0),lim=c(0,1))+
                  scale_y_continuous(expand=c(0,0))+
                  xlab("p-value") +
                  ylab("Distribution")
```

```{r eval=FALSE}
ggsave(filename="ecdf_plot.pdf", width=7,height=7)
```

Also plot the Grenander estimator:

```{r}
ggplot(df_ecdf, aes(x=x, y=y)) + geom_step(direction="hv",size=1.3) +
  geom_line(data=df_gren, aes(x=x,y=y), color="red",size=1.3) +
                  scale_x_continuous(expand=c(0,0),lim=c(0,1))+
                  scale_y_continuous(expand=c(0,0))+
                  xlab("p-value") +
                  ylab("Distribution")
```

```{r eval=FALSE}
ggsave(filename="ecdf_grenander_plot.pdf", width=7,height=7)
```

---
title: "Real data examples: 1-fold weight function"
author: "Nikos Ignatiadis"
date: "`r doc_date()`"
package: "`r pkg_ver('IHWpaper')`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{"Various: Real data examples: 1-fold weight function"}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
---

In this vignette, we want to estimate the weight~covariate function on the RNASeq and eQTL datasets, without using the k-fold strategy. The below plots are mainly useful for presentations.
 

```{r warning=F, message=F}
library("IHW")
library("dplyr")
library("ggplot2")
library("grid")
library("tidyr")
library("cowplot")
library("IHWpaper")
```

```{r}
red_col <- scales::hue_pal(h = c(0, 360) + 15, c = 100, l = 65, h.start = 0,direction = 1)(1)
```
# DESeq2 Bottomly

Load Bottomly dataset, apply DESeq2, then IHW with 1 fold.
```{r}
bottomly <- analyze_dataset("bottomly")

ihw_res <- ihw(bottomly$pvalue, bottomly$baseMean, 0.1,
               nfolds=1, nbins=13, 
               nfolds_internal=4L, nsplits_internal=5L)
```

 Do the plotting:
```{r}
breaks <- IHW:::stratification_breaks(ihw_res)
break_min = min(bottomly$baseMean)

breaks_left <- c(break_min,breaks[-length(breaks)])

step_df <- data.frame(weight=weights(ihw_res,levels_only=TRUE),
                      stratum = 1:nlevels(groups_factor(ihw_res))) %>%
          mutate(baseMean_left = breaks_left[stratum], 
                 baseMean_right = breaks[stratum],
                 baseMean_ratio = baseMean_right/baseMean_left , 
                 baseMean_left = baseMean_left * baseMean_ratio^.2,
                 baseMean_right = baseMean_right *baseMean_ratio^(-.2))

stratum_fun <- function(df){
  stratum <- df$stratum
  weight <- df$weight
  stratum_left <- stratum[stratum != length(stratum)]
  weight_left  <- weight[stratum_left]
  baseMean_left <- df$baseMean_right[stratum_left]
  stratum_right <- stratum[stratum != 1]
  weight_right <- weight[stratum_right]
  baseMean_right <- df$baseMean_left[stratum_right]
  data.frame(stratum_left= stratum_left, weight_left= weight_left, 
             stratum_right = stratum_right, weight_right = weight_right,
             baseMean_left = baseMean_left, baseMean_right = baseMean_right)
}

connect_df <-  step_df %>% 
               do(stratum_fun(.)) %>%
               mutate(dashed = factor(ifelse(abs(weight_left - weight_right) > 10^(-4) , TRUE, FALSE),
                         levels=c(FALSE,TRUE)))


panel_b <- ggplot(step_df, 
                       aes(x=baseMean_left, 
                           xend=baseMean_right, 
                           y=weight, yend=weight)) +
                geom_segment(size=0.8, color=red_col)+ 
                geom_segment(data= connect_df, aes(x=baseMean_left, xend=baseMean_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                                                size=0.8, color=red_col)+
                scale_x_log10(breaks=c(1,10,100,1000,10000))+
                xlab("Mean of normalized counts")+
                theme(legend.position=c(0.8,0.4)) +
                theme(plot.margin = unit(c(1, 1, 2, 1), "lines")) +
                guides(linetype=FALSE) + 
                theme(axis.title = element_text(face="bold") )

panel_b
```

```{r eval=FALSE}
ggsave(panel_b, filename="bottomly_1fold_weight_function.pdf", width=7, height=5)
```

# hQTL example

Next we load the data for the hQTL example. Here we load the data-frame with the snps, genes and pvalue information. Note that because of memory concerns (the full data-frame is 3 GB) it contains only the p-values below 0.005. However, before doing this reduction we counted the number of hypotheses `m_groups` in each stratum (strata as defined in group column). Thus we can apply `IHW` to the reduced dataset, see also the advanced section of the IHW vignette ("Advanced usage: Working with incomplete p-value lists"). 

```{r}
hqtl_filt <- system.file("extdata/real_data",
                        "hqtl_pvalue_filtered.Rds", package = "IHWpaper")
hqtl_filt <- readRDS(hqtl_filt)
m_groups <- attr(hqtl_filt, "m_groups")

ihw_qtl_res <- ihw(hqtl_filt$pvalue, as.factor(hqtl_filt$group), 0.1,
                   m_groups = m_groups, nfolds=1L, lambda=Inf)
```

```{r}
breaks <- attr(hqtl_filt, "breaks")
breaks <- breaks[-1]
break_min <- 5000
breaks_left <- c(break_min,breaks[-length(breaks)])
step_df_qtl <- data.frame(weight=weights(ihw_qtl_res,levels_only=TRUE),
                    stratum = 1:nlevels(groups_factor(ihw_qtl_res))) %>%
               mutate(break_left = breaks_left[stratum],
                    break_right = breaks[stratum],
                    break_ratio = break_right/break_left , 
                    break_left =break_left * break_ratio^.2,
                    break_right = break_right *break_ratio^(-.2))

stratum_fun <- function(df){
  stratum <- df$stratum
  weight <- df$weight
  stratum_left <- stratum[stratum != length(stratum)]
  weight_left  <- weight[stratum_left]
  break_left <- df$break_right[stratum_left]
  stratum_right <- stratum[stratum != 1]
  weight_right <- weight[stratum_right]
  break_right <- df$break_left[stratum_right]
  data.frame(stratum_left= stratum_left, weight_left= weight_left, 
             stratum_right = stratum_right, weight_right = weight_right,
             break_left = break_left, break_right = break_right)
}

connecting_df_qtl <- step_df_qtl %>% 
                  do(stratum_fun(.)) %>%
                  mutate(dashed = factor(ifelse(abs(weight_left - weight_right) > 5, 
                                      TRUE, FALSE),
                                  levels=c(FALSE,TRUE)))

panel_f <- ggplot(step_df_qtl, aes(x=break_left, xend=break_right,y=weight, yend=weight)) +
                geom_segment(size=0.8, color=red_col)+                
                geom_segment(data= connecting_df_qtl, aes(x=break_left, xend=break_right, 
                                                y=weight_left, yend=weight_right, 
                                                linetype=dashed),
                             size=0.8, color=red_col) +
                scale_x_log10(breaks=c(10^4, 10^5,10^6,10^7)) +
                xlab("Genomic distance (bp)")+
                theme(legend.position=c(0.8,0.4)) +
                theme(plot.margin = unit(c(1, 1, 2, 1), "lines"))+
                guides(linetype=FALSE) + 
                theme(axis.title = element_text(face="bold") )

panel_f
```

```{r eval=FALSE}
ggsave(panel_f, filename="hqtl_1fold_weight_function.pdf", width=7, height=5)
```

---
title: "Weights vs Independent Filtering"
author: "Nikos Ignatiadis"
date: "`r doc_date()`"
package: "`r pkg_ver('IHWpaper')`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{"Various: Weights vs Independent Filtering"}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
---

In this vignette we show that weights can behave very similarly to an independent filtering threshold:

```{r warning=F, message=F}
library("IHW")
library("IHWpaper")
library("ggplot2")
library("dplyr")
library("wesanderson")
```

First we generate the simulated data and then use (data-driven greedy) independent filtering. We convert the binary threshold cut-off into weights.

```{r, warning=F}
sim <- du_ttest_sim(80000, 0.9, 2, seed=1)
ddhf_res <- ddhf(sim$pvalue, sim$filterstat, .1)
ws <- ifelse(sim$filterst <= ddhf_res$cutoff_value, 0, 1)
ws <- ws/sum(ws)*length(sim$pvalue)
```

The induced weight function has total regularization equal to the following:
```{r}
total_regularization_lambda <- max(ws)-min(ws)
total_regularization_lambda
```

We now apply IHW based on the above total regularization penalization parameter. This makes the comparison more directly applicable.

```{r warning=F}
ihw_res <- ihw(sim$pvalue, sim$filterstat, .1, lambdas = total_regularization_lambda, nfolds=1L,  nbins=20)
```

The plot below compares the binary threshold with the IHW threshold, which is a bit smoother:

```{r fig.width=5, fig.height=5, warning=F}
df <- rbind( data.frame(covariate = sim$filterstat, weight= ws, method="filtering"),
             data.frame(covariate = sim$filterstat, weight= weights(ihw_res, levels_only=FALSE), 
                        method=paste0("IHW; \nlambda=",format(total_regularization_lambda,digits=2))))
weights_filter_plot <- ggplot(df, aes(x=covariate, y=weight, col=method)) + geom_step(size=1.65)+
                      scale_colour_manual(values=wes_palette("Cavalcanti1")[c(1,2)]) +
                      theme_classic(16)
weights_filter_plot
```

```{r, eval=FALSE}
pdf("smoothed_threshold.pdf", width=5, height=5)
weights_filter_plot
dev.off()
```

But weights can be even more flexible if we allow the total regularization parameter to vary. Here we use 5fold CV along an equally spaced grid of lambdas to find the best total variation regularization using IHW:

```{r message=F, warning=F}
ihw_res2 <- ihw(sim$pvalue, sim$filterstat, .1, lambdas=seq(0,10,length=20), nfolds=1L, nfolds_internal = 5L, nbins=20, quiet=TRUE)
```

The returned regularization parameter is the following:

```{r message=F, warning=F}
regularization_term(ihw_res2)
```
Now we plot everything:
```{r fig.width=5, fig.height=5, warning=F}
df <- rbind(df,
            data.frame(covariate = sim$filterstat, weight= weights(ihw_res2, levels_only=FALSE),  
                       method=paste0("IHW; \nlambda=",
                                     format(regularization_term(ihw_res2) ,digits=2))))
            
weights_filter_plot <- ggplot(df, aes(x=covariate, y=weight, col=method)) + geom_step(size=1.65)+
                      scale_colour_manual(values=wes_palette("Cavalcanti1")[c(1,2,3)]) +
                      theme_classic(16)

weights_filter_plot
```

Notice that all 3 types of weights still fullfill the necessary budget condition:

```{r, warning=F}
group_by(df, method) %>% summarize(mean_weight = mean(weight))
```

---
title: "IHW-Bonferroni simulations"
author: "Nikos Ignatiadis"
date: "`r doc_date()`"
package: "`r pkg_ver('IHWpaper')`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{"NMeth paper: IHW-Bonferroni simulations"}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
---

In this vignette we want to generate plots for the same simulations shown in simulations_vignette.Rmd, but this time for FWER control. In particular, we applied the IHW-Bonferroni methods and Bonferroni methods using exactly the same settings as in the above simulations.

```{r warning=F, message=F}
library("ggplot2")
library("grid")
library("dplyr")
library("cowplot")
library("IHWpaper")
library("wesanderson")
```

```{r}
colors <- wes_palette("Cavalcanti1")[c(3,5)]
```

# Null simulation
## FWER control
```{r}

null_folder <- system.file("simulation_benchmarks/result_files/ihw_bonf_null",
                        package = "IHWpaper")
null_sim <- bind_rows(lapply(file.path(null_folder,list.files(null_folder)), function(x) readRDS(x))) %>%
            mutate(fdr_method = ifelse(fdr_method == "IHW-Bonferroni E3", "IHW-Bonferroni", fdr_method))

last_vals_a <- group_by(null_sim, fdr_method) %>% summarize(last_vals = max(FDR)) %>%
               mutate(last_vals = last_vals + c(+0.003,-0.003), 
                    label = fdr_method,
                    colour = colors)

panel_a <- ggplot(null_sim, aes(x=alpha, y=FDR, col=fdr_method)) +
                         geom_line(size=1.2) +
                         geom_abline(linetype="dashed") + 
                         xlab(expression(bold(paste("Nominal ",alpha)))) + 
                         ylab("FWER")+
                         scale_x_continuous(limits= c(0.01,0.1), breaks=seq(0.01,0.09,length=5)) +
                         #ylim(0,0.9) +
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors)+
                         theme(axis.title = element_text(face="bold") )

  
panel_a <- pretty_legend(panel_a, last_vals_a, 0.102)
panel_a
```

# Effect size simulation (t-test)
## FWER control
```{r}
ttest_folder <- system.file("simulation_benchmarks/result_files/ihw_bonf_du_ttest_informative",
                     package = "IHWpaper")
ttest_sim <- bind_rows(lapply(file.path(ttest_folder,list.files(ttest_folder)), function(x) readRDS(x))) %>%
            mutate(fdr_method = ifelse(fdr_method == "IHW-Bonferroni E3", "IHW-Bonferroni", fdr_method))

last_vals_b <- group_by(ttest_sim, fdr_method) %>% summarize(last_vals =  FDR[which.max(eff_size)]) %>%
               mutate(last_vals = last_vals, 
                      label = fdr_method,
                      colour = colors)

panel_b <- ggplot(ttest_sim, aes(x=eff_size, y=FDR, col=fdr_method)) +
                         geom_hline(yintercept=0.1, linetype="dashed") + 
                         geom_line(size=1.2) +
                         xlab("Effect size") + 
                          ylab("FWER")+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors) + 
                         theme(axis.title = element_text(face="bold") )

panel_b <- pretty_legend(panel_b, last_vals_b, 2.52 )
panel_b
```

# Power
```{r}
last_vals_c <- group_by(ttest_sim, fdr_method) %>% summarize(last_vals = power[which.max(eff_size)]) %>%
               mutate(last_vals = last_vals, 
                      label = fdr_method,
                      colour = colors)


panel_c <- ggplot(ttest_sim, aes(x=eff_size, y=power, col=fdr_method)) +
                         geom_line(size=1.2) +
                         xlab("Effect size") + 
                         ylab("Power")+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors)+
                         theme(axis.title = element_text(face="bold") )

panel_c <- pretty_legend(panel_c, last_vals_c, 2.52 )
panel_c
```

# Size investing simulation
# FWER control
```{r}
size_investing_folder <- system.file("simulation_benchmarks/result_files/ihw_bonf_wasserman_normal",
                              package = "IHWpaper")
size_investing_sim <- bind_rows(lapply(file.path(size_investing_folder,
                                             list.files(size_investing_folder)), function(x) readRDS(x))) %>%
            mutate(fdr_method = ifelse(fdr_method == "IHW-Bonferroni E3", "IHW-Bonferroni", fdr_method))


last_vals_d <- group_by(size_investing_sim, fdr_method) %>% summarize(last_vals = log10(FDR[which.max(xi_max)])) %>%
               mutate(last_vals = last_vals + c(+2.5,-0.8)*0.08, 
                      label = fdr_method,
                      colour = colors)

panel_d <- ggplot(size_investing_sim, aes(x=xi_max, y=log10(FDR), col=fdr_method)) +
                         geom_line(size=1.2) +
                         xlab(expression(bold(xi[max])))+
                         ylab("log10(FWER)")+
                         geom_hline(yintercept=-1, linetype="dashed") + 
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors) + 
                         theme(axis.title = element_text(face="bold") )

panel_d <- pretty_legend(panel_d, last_vals_d, 6.02 )
panel_d
```

# Power
```{r}
last_vals_e <- group_by(size_investing_sim, fdr_method) %>% summarize(last_vals = power[which.max(xi_max)]) %>%
               mutate(last_vals = last_vals + c(-0.01,+0.01) , 
                      label = fdr_method,
                      colour = colors)

panel_e <- ggplot(size_investing_sim, aes(x=xi_max, y=power, col=fdr_method)) +
                         geom_line(size=1.2) +
                         ylab("Power") +
                         xlab(expression(bold(xi[max])))+
                         theme(plot.margin = unit(c(3, 7.5, .2, .2), "lines"))+
                         scale_color_manual(values=colors) +
                         theme(axis.title = element_text(face="bold") )


panel_e <- pretty_legend(panel_e, last_vals_e, 6.02 )
panel_e
```

# Composite panel:
```{r, fig.width=12, fig.height=16}
fwer_sim_fig <- plot_grid(panel_a, ggdraw(),
                         panel_b, panel_c,
                         panel_d, panel_e, 
                         nrow=3,
                         labels=c("a)", "", "b)", "c)","d)", "e)"))
fwer_sim_fig
```

```{r eval=FALSE}
ggsave(plot=fwer_sim_fig, file="fwer_simulations.pdf", width=12, height=16)
```

---
title: "tdr and pvalue rejection regions"
author: "Nikos Ignatiadis"
date: "`r doc_date()`"
package: "`r pkg_ver('IHWpaper')`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{"Various: tdr and pvalue rejection regions"}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
---

One of the differences between BH and IHW is that BH sets a constant rejection threshold across all hypotheses which does not depend on the covariate. The rejection threshold of IHW on the other hand depends on the covariate. In many situations, this means, that the BH rejection threshold will be non-constant as a function of the tdr, while IHW will approximate a constant tdr threshold. Here we want to explore this using a simple simulation.

```{r warning=FALSE, message=FALSE}
library("ggplot2")
library("dplyr")
library("tidyr")
library("gridExtra")
#library("LSD")
library("IHW")
```

We set up the helper function which generates the simulation, applies BH and IHW and evaluates the tdr at the rejection thresholds.
```{r}
# try function with non-monotonic relation
sim <- function(m =20000){
  x <- 1-runif(m)
  pi0 <- 0.75+0.3*(x-0.5)^2#0.8 #ifelse(x<=.5, 0.5 + 0.6*x, 0.8)
  eff_size <- 2-2.2*abs(x-0.5)^1.3  #was 3.2 #ifelse(x <=.5, 1.5, 1.5-(x-1/2)*4)
  H <- rbinom(m, 1, 1-pi0)
  Z <- rnorm(m)
  Z[H==1] <- rnorm(sum(H), eff_size[H==1])
  pvalue <- 1-pnorm(Z)
  t <- pvalue
  t_bh <- get_bh_threshold(pvalue,0.1)

  alt_ft_bh <- dnorm(-eff_size+ qnorm(1-t_bh))/dnorm(qnorm(1-t_bh))
  tdr_bh <- alt_ft_bh*(1-pi0)/((1-pi0)*alt_ft_bh + pi0)
  t_ddhw <- thresholds(ihw(pvalue, x, alpha= .1, nbins=20,
                           nsplits_internal=10, nfolds = 1), levels_only=FALSE)

  alt_ft_ddhw <- dnorm(-eff_size+ qnorm(1-t_ddhw))/dnorm(qnorm(1-t_ddhw))
  tdr_ddhw <- alt_ft_ddhw*(1-pi0)/((1-pi0)*alt_ft_ddhw + pi0)

  alt_ft <- dnorm(qnorm(1-t)-eff_size)/dnorm(qnorm(1-t))
  tdr <- alt_ft*(1-pi0)/((1-pi0)*alt_ft + pi0)
  return(data.frame(x=x,pi0=pi0, t=t, eff_size=eff_size,H=H,
                    Z=Z, pvalue=pvalue, alt_ft=alt_ft, tdr=tdr,
                    tdr_bh=tdr_bh, alt_ft_bh=alt_ft_bh, t_bh=t_bh,
                    t_ddhw=t_ddhw, tdr_ddhw=tdr_ddhw, alt_ft_ddhw=alt_ft_ddhw))
}
```

Run above simulation:
```{r}
set.seed(1)
sim_df <- sim(m=80000)
```

First plot the rejection thresholds in terms of p-values. Note that BH returns a horizontal line, while IHW does not, because of assignment of non-uniform weights.

```{r}
sim_df_t <- select(sim_df, x, t_bh, t_ddhw ) %>%
            gather(method, t, -x) %>%
            mutate(method=ifelse(method=="t_bh", "BH","IHW"))

ggplot(sim_df_t, aes(x=x, y=t,color=method)) +
                   geom_step() +
                   xlab("covariate") +
                   ylab("p-value threshold")
```

On the other hand, BH shows a highly non-constant rejection threshold in terms of tdr. This is suboptimal. IHW is better at approximating a constant tdr threshold.
```{r}
sim_df_tdr <- select(sim_df, x, tdr_bh, tdr_ddhw ) %>%
              gather(method, tdr, -x) %>%
              mutate(method=ifelse(method=="tdr_bh", "BH","IHW"))


ggplot(sim_df_tdr, aes(x=x, y=tdr,color=method)) +
                   geom_step() +
                   xlab("covariate") +
                   ylab("tdr threshold")
```



```{r}
#sim_df$group <- groups_by_filter(sim_df$x, 10)
#plot(sim_df$x, sim_df$tdr_bh)

#with(filter(sim_df,-log10(pvalue) > 0.001), heatscatter(-log10(pvalue),x, add.contour=TRUE))
#with(filter(sim_df,tdr>0.2), heatscatter(tdr,x, add.contour=TRUE)) 

#ggplot(filter(sim_df), aes(x=-log10(pvalue), y=x)) + geom_density2d(aes(color = ..level..)) 
#ggplot(filter(sim_df, tdr>0.4), aes(x=tdr, y=x)) + geom_density2d(aes(color = ..level..)) 
```

---
title: "Explaining tdr"
author: "Nikos Ignatiadis"
date: "`r doc_date()`"
package: "`r pkg_ver('IHWpaper')`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{"NMeth paper: Explaining tdr"}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
---

# Introduction
In the first part of this vignette, one of the supplemental figures is generated, which clarifies some concepts regarding the tdr. In particular, the tdr at a fixed p-value is illustrated, the tdr as a function of p-values and also tdr(P_i) as a random variable, which in general will not be a test statistic. It's only a test statistic when we know pi0 and the alternative density, and in such a case it really provides higher discriminatory power than the p-values.


```{r warning=F, message=F}
library("ggplot2")
library("dplyr")
library("tidyr")
library("gridExtra")
library("cowplot")
library("wesanderson")
```

Helper functions to generate simulated data and also evaluate tdr and other quantities on them.
```{r warning=F}
falt1 <- function(t){
    1-pnorm(qnorm(1-t)-mu1)
  }

  lfdr1 <- function(t){
    pi10/(pi10 + (1-pi10)*falt1_density(t))
  }
  falt1_density <- function(t){
      dnorm(qnorm(1-t)-mu1)/dnorm(qnorm(1-t))
  }

#http://stackoverflow.com/questions/10081479/solving-for-the-inverse-of-a-function-in-r
inverse = function (f, lower = -100, upper = 100) {
   function (y) uniroot((function (x) f(x) - y), lower = lower, upper = upper)[1]$roo
}

sim_pars <- function(eff_size, pi0){
  distrib <- function(t) pi0*t + (1-pi0)*(1-pnorm(qnorm(1-t)-eff_size))
  alt_density <-   function(t) dnorm(qnorm(1-t)-eff_size)/dnorm(qnorm(1-t))
  density <- function(t) pi0 + (1-pi0)*alt_density(t)
  tdr <- function(t)  1- pi0/density(t)
  inverse_f <- function(y) uniroot((function (x) density(x) - y), lower = 0.001, upper = 0.999)[1]$root
  tdr_density <- function(t) pi0*(inverse_f(pi0/(1-t)+0.001) - inverse_f(pi0/(1-t)-0.001))/0.002
  return(list(pi0=pi0,distrib=distrib, alt_density=alt_density,density=density, tdr=tdr, inverse_f=inverse_f,
            tdr_density=tdr_density  ))
}

```

Helper function to generate plots for different parameter values:
```{r warning=F}
plot_tdr <- function(x,pi0,xthreshold=0.05){
  eff_size <- x
  pars <- sim_pars(x,pi0)
  df <- data.frame(t=seq(0.001,1, length=1000))
  df <- mutate(df, f1 = pars$alt_density(t), f=pars$density(t), tdr = pars$tdr(t))
  plot_pv <- ggplot(df, aes(x=t, y=f)) + 
                     geom_line()  + 
                     ylim(c(0,4)) + 
                     geom_vline(xintercept=xthreshold, col="blue") + 
                     geom_hline(yintercept=pars$pi0,col="red") +
                     #geom_hline(yintercept=pars$density(xthreshold), linetype=2)+
                     ylab("density")+
                     xlab("p-value")+
                     scale_x_continuous(expand = c(0, 0)) 
  
  plot_pv_vs_tdr <- ggplot(df, aes(x=t, y= tdr)) + 
                    geom_line() +
                    ylab("tdr")+
                    xlab("p-value")+
                    scale_x_continuous(expand = c(0, 0)) 
  
  # now also generate empirical histogram plots
  a = sim_pars(eff_size,pi0)
  m=100000
  H <- rbinom(m, 1, 1-pi0)
  X <- rnorm(m) + eff_size*H
  PV <- 1 - pnorm(X)
  TDR <- a$tdr(PV)
  
  sim_df <- data.frame(pvalue=PV, tdr=TDR)
  
  hist_pv <- ggplot(sim_df, aes(x=pvalue))
  grid.arrange(plot_pv, plot_pv_vs_tdr, ncol=1)
  
  pv_hist <- ggplot(sim_df, aes(x=pvalue)) + geom_histogram(aes(y = ..density..),binwidth=0.036, colour = "darkgreen", fill = "white") + xlab("p-value")
  tdr_hist <- ggplot(sim_df, aes(x=tdr)) + geom_histogram(aes(y = ..density..),binwidth=0.036, colour = "darkgreen", fill = "white") + xlab("tdr")
  list(plot_pv=plot_pv,  plot_pv_vs_tdr=plot_pv_vs_tdr, pv_hist=pv_hist, tdr_hist=tdr_hist)
}
```
Generate all plots:
```{r fig.keep="none", warning=F}
myplots <- c(plot_tdr(3.5, 0.6), plot_tdr(3.5,0.85), plot_tdr(1.5,0.6))
myplots <- myplots[c(1,5,9) + rep(0:3,each=3)]
myplots <- c(myplots, list(labels = letters[1:12]), list(ncol=3, align="hv"))
```

Let's put all plots together:
```{r warning=F, fig.width=10, fig.height=15}
do.call(plot_grid,myplots)
```

```{r eval=F}
pdf("pvalue_vs_tdr_explanation.pdf", width=10, height=15)
do.call(plot_grid,myplots)
dev.off()
```


# Size investing and tdr
This part of the vignette generates figures which explain the relationship between tdrs and size investing. In particular it illustrates why fdr estimation methods which assume the conditional alternative densities remain the same, cannot have any power (i.e. differences only due to pi0 estimation cannot support a size investing strategy).

Again first generate the data and the individual plots for a case in which both pi0 changes and the alternative distribution:
```{r warning=F}

df <- data.frame(t=seq(0.00001,1, length=1000))
x <- 2.5
pi0 <- 0.8
eff_size <- x
pars <- sim_pars(x,pi0)
df1 <- mutate(df, f1 = pars$alt_density(t), CDF=pars$distrib(t), f=pars$density(t), tdr = pars$tdr(t), test = "1")
  
x <- 1.5
pi0 <- 0.9
eff_size <- x
pars <- sim_pars(x,pi0)
df2 <- mutate(df, f1 = pars$alt_density(t), CDF=pars$distrib(t), f=pars$density(t), tdr = pars$tdr(t), test = "2")

df <- rbind(df1,df2)
  
plot_tdr_inversed1 <- ggplot(df, aes(x=tdr, y= t,color=test)) + 
                    geom_line() +
                    xlab("tdr")+
                    ylab("p-value")+
                    scale_x_continuous(expand = c(0, 0)) +
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',
                                        labels = expression(H , tilde(H)))


plot_density1 <- ggplot(df, aes(x=t, y= f,color=test)) + 
                    geom_line() +
                    xlab("p-value")+
                    ylab("density")+
                    scale_x_continuous(expand = c(0, 0)) +
                    ylim(0,4) +
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',labels = expression(H , tilde(H)))


plot_cdf1 <- ggplot(df, aes(x=t, y= CDF,color=test)) + 
                    geom_line() +
                    xlab("p-value")+
                    ylab("CDF")+
                    scale_x_continuous(expand = c(0, 0)) +
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',labels = expression(H , tilde(H)))

```

Second we generate an example in which only pi0 differs and the alternative distributions are the same:

```{r warning=F}
df <- data.frame(t=seq(0.00001,1, length=1000))
x <- 2.5
pi0 <- 0.8
eff_size <- x
pars <- sim_pars(x,pi0)
df1 <- mutate(df, f1 = pars$alt_density(t), CDF=pars$distrib(t), f=pars$density(t), tdr = pars$tdr(t), test = "1")
  
x <- 2.5
pi0 <- 0.9
eff_size <- x
pars <- sim_pars(x,pi0)
df2 <- mutate(df, f1 = pars$alt_density(t), CDF=pars$distrib(t), f=pars$density(t), tdr = pars$tdr(t), test = "2")
df <- rbind(df1,df2)
  
plot_tdr_inversed <- ggplot(df, aes(x=tdr, y= t,color=test)) + 
                    geom_line() +
                    xlab("tdr")+
                    ylab("p-value")+
                    expand_limits(x = c(0,1),y=0)  +
                    scale_x_continuous(expand=c(0,0),breaks=c(0, 0.25,0.5, 0.75,1),
                                        labels= c("0","0.25","0.5","0.75","1"))   +  
                    scale_y_continuous(expand=c(0,0),breaks=c(0, 0.25,0.5, 0.75,1),
                                       labels= c("0","0.25","0.5","0.75","1"))   +  
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',
                                          labels = expression(H[1] , H[2]))


plot_density <- ggplot(df, aes(x=t, y= f1,color=test)) + 
                    geom_line() +
                    xlab("p-value")+
                    ylab("alt")+
                    scale_x_continuous(expand = c(0, 0)) +
                    ylim(0,4) +
                    scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',
                                        labels = expression(H , tilde(H)))


plot_cdf <- ggplot(df, aes(x=t, y= CDF,color=test)) + 
                    geom_line() +
                    xlab("p-value")+
                    ylab("CDF")+
                    scale_x_continuous(expand = c(0, 0)) +
                      scale_colour_manual(values =wes_palette("Chevalier1")[c(1,4)], name='',
                                          labels = expression(H , tilde(H)))
```

```{r, fig.width=8, fig.height=6, warning=F}
plotgrid <- plot_grid(plot_cdf1, plot_cdf, plot_tdr_inversed1, plot_tdr_inversed, labels = letters[1:4], ncol=2, align="hv")
plotgrid
```

```{r, eval=F}
pdf("tdr_size_investing.pdf", width=8, height=6)
plotgrid
dev.off()
```

---
title: "BH explanation / visualization"
author: "Nikos Ignatiadis"
date: "`r doc_date()`"
package: "`r pkg_ver('IHWpaper')`"
output: BiocStyle::html_document
vignette: >
  %\VignetteIndexEntry{"Various: BH explanation / visualization"}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
---

Below we just generate the necessary plot to explain how BH works.

```{r}
library("ggplot2")
library("dplyr")
library("wesanderson")
library("grid")
library("gridExtra")
library("IHW")
```

# B.Sc. thesis plot (low $\pi_0$)

Plot as in B.Sc. thesis with very low $\pi_0$. (Using this so it can be clearly demonstrated that the BH threshold is an intermediate threshold between the Bonferroni threshold and the uncorrected one, also such $\pi_0$ allows to show all p-values in the second plot and still observe the interesting behaviour.)

```{r}
simpleSimulation <- function(m,m1,betaA,betaB){
    pvalue <- runif(m)
    H <- rep(0,m)
    alternatives <- sample(1:m,m1)
    
    pvalue[alternatives] <- rbeta(m1,betaA,betaB)
    H[alternatives] <-1
 
    simDf <- data.frame(pvalue = pvalue, group=runif(m), filterstat = runif(m), H=H)
    return(simDf)
}

set.seed(1)
sim <- simpleSimulation(1000, 700, 0.3, 8)
sim$rank <- rank(sim$pvalue)

histogram_plot <- ggplot(sim, aes(x=pvalue)) + 
                    geom_histogram(binwidth=0.1, fill = wes_palette("Chevalier1")[4]) + 
                    xlab("p-value") + 
                    theme_bw()
                        
bh_threshold <- get_bh_threshold(sim$pvalue, .1)

bh_plot <- ggplot(sim, aes(x=rank, y=pvalue)) +
  geom_step(col=wes_palette("Chevalier1")[4]) + 
  ylim(c(0,0.2)) +
  geom_abline(intercept=0, slope= 0.1/1000, col = wes_palette("Chevalier1")[2]) +
  geom_hline(yintercept=bh_threshold, linetype=2) + 
  annotate("text",x=250, y=0.065, label="BH testing") + 
  geom_hline(yintercept = 0.1, linetype=2) + 
  annotate("text",x=250, y=0.11, label="uncorrected testing") + 
  geom_hline(yintercept = 0.1/1000, linetype=2) +
  annotate("text",x=850, y=0.1/1000+0.01, label="Bonferroni testing") + 
  ylab("p-value") + xlab("rank of p-value") +
  theme_bw() + scale_colour_manual(values=wes_palette("Chevalier1")[c(3,4)]) 

```

```{r fig.width=11, fig.height=5}
grid.arrange(histogram_plot, bh_plot, nrow=1)
```

```{r eval=FALSE}
pdf(file="bh_explanation.pdf", width=11, height=5)
grid.arrange(histogram_plot, bh_plot, nrow=1)
dev.off()
```

# Bioc presentation plot (higher $\pi_0$)

For ddhw presentation, remake above plot with higher $\pi_0$.
```{r}
set.seed(1)
sim <- simpleSimulation(10000, 2000, 0.3, 8)
sim$rank <- rank(sim$pvalue)

histogram_plot <- ggplot(sim, aes(x=pvalue)) + 
                    geom_histogram(binwidth=0.1, fill = wes_palette("Chevalier1")[4]) + 
                    xlab("p-value") + 
                    theme_bw(14)
                        

bh_threshold <- get_bh_threshold(sim$pvalue, .1)

bh_plot <- ggplot(sim, aes(x=rank, y=pvalue)) +
  geom_step(col=wes_palette("Chevalier1")[4], size=1.2) + 
  scale_x_continuous(limits=c(0,2000),expand = c(0, 0))+
  scale_y_continuous(limit=c(0,0.06), expand=c(0,0)) +
  geom_abline(intercept=0, slope= 0.1/10000, col = wes_palette("Chevalier1")[2], size=1.2) +
  annotate("text",x=500, y=1.3*bh_threshold, label="BH rejection threshold") + 
  geom_hline(yintercept=bh_threshold, linetype=2, size=1.2) + 
  ylab("p-value") + xlab("rank of p-value") +
  theme_bw() + scale_colour_manual(values=wes_palette("Chevalier1")[c(3,4)])
```
```{r fig.width=11, fig.height=5}
grid.arrange(histogram_plot, bh_plot, nrow=1)
```


```{r eval=FALSE}
pdf(file="bh_explanation_high_pi0.pdf", width=11, height=5)
grid.arrange(histogram_plot, bh_plot, nrow=1)
dev.off()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/analyze_datasets.R
\name{analyze_dataset}
\alias{analyze_dataset}
\title{analyze_dataset: Basically performs preprocessing and then returns analyzed RNASeq dataset (diff. expression)
          , i.e. the DESeq2 result whose p-values and baseMean statistics can then be used with IHW}
\usage{
analyze_dataset(dataset = c("airway", "bottomly", "hammer"), res = TRUE)
}
\arguments{
\item{dataset}{Character, name of dataset to be preprocessed, only 3 choices currently available ("airway","bottomly","hammer")}

\item{res}{(default TRUE): return result table, rather than DESeq2 object}
}
\value{
Preprocessed dataset
}
\description{
analyze_dataset: Basically performs preprocessing and then returns analyzed RNASeq dataset (diff. expression)
          , i.e. the DESeq2 result whose p-values and baseMean statistics can then be used with IHW
}
\examples{
bottomly <- analyze_dataset("bottomly")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/covariate_methods.R
\name{ddhf}
\alias{ddhf}
\title{ddhf: Greedy independent filtering}
\usage{
ddhf(unadj_p, filterstat, alpha)
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{filterstat}{Factor to which different hypotheses belong}

\item{alpha}{Significance level at which to apply method}
}
\value{
DDHF multiple testing object
}
\description{
ddhf: Greedy independent filtering
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     obj <- ddhf(sim_df$pvalue, sim_df$filterstat, .1)
     sum(rejected_hypotheses(obj))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulations.R
\name{null_sim}
\alias{null_sim}
\alias{null_sim_fun}
\title{Null simulation: Generate uniformly distributed p-values and covariates}
\usage{
null_sim(m, seed = NULL)

null_sim_fun(m)
}
\arguments{
\item{m}{Integer, total number of hypotheses}

\item{seed}{Integer, Random seed to be used for simulation 
(default: NULL, i.e. RNG state will be used as is)}
}
\value{
A data frame containing all information about the simulation experiment
}
\description{
Null simulation: Generate uniformly distributed p-values and covariates
}
\section{Functions}{
\itemize{
\item \code{null_sim_fun}: Creates a closure function for a given seed
}}

\examples{
sim_df <- null_sim(20000)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/benchmarking.R
\name{run_evals}
\alias{run_evals}
\title{run_evals: Main function to benchmark FDR methods on given simulations.}
\usage{
run_evals(sim_funs, fdr_methods, nreps, alphas, ...)
}
\arguments{
\item{sim_funs}{List of simulation settings}

\item{fdr_methods}{List of FDR controlling methods to be benchmarked}

\item{nreps}{Integer, number of Monte Carlo replicates for the simulations}

\item{alphas}{Numeric, vector of nominal significance levels 
at which to apply FDR controlling methods}

\item{...}{Additional arguments passed to sim_fun_eval}
}
\value{
data.frame which summarizes results of numerical experiment
}
\description{
run_evals: Main function to benchmark FDR methods on given simulations.
}
\details{
This is the main workhorse function which runs all simulation benchmarks for IHWpaper.
   It receives input as described above, and the output is a data.frame with the
   following columns:
   \itemize{
		\item{fdr_method: }{Multiple testing method which was used}
         \item{fdr_pars: }{Custom parameters of the multiple testing method}
         \item{alpha: }{Nominal significance level at which the benchmark was run}
         \item{FDR: }{False Discovery Rate of benchmarked method on simulated dataset}
         \item{power: }{Power of benchmarked method on simulated dataset}
         \item{rj_ratio: }{Average rejections divided by total number of hypotheses}
		\item{FPR: }{False positive rate of benchmarked method on simulated dataset}
         \item{FWER: }{Familywise Error Rate of benchmarked method on simulated dataset}
         \item{nsuccessful: }{Number of successful evaluations of the method}
         \item{sim_method: }{Simulation scenario under which benchmark was run}
         \item{m: }{Total number of hypotheses}
         \item{sim_pars: }{Custom parameters of the simulation scenario}
   }
}
\examples{
   nreps <- 3 # monte carlo replicates
   ms <- 5000 # number of hypothesis tests
   eff_sizes <- c(2,3)
   sim_funs <- lapply(eff_sizes,
			function(x) du_ttest_sim_fun(ms,0.95,x, uninformative_filter=FALSE))
	  continuous_methods_list <- list(bh,
                              	  lsl_gbh,
 	                          	  clfdr,
                                   ddhf)
  fdr_methods <- lapply(continuous_methods_list, continuous_wrap)
 eval_table <- run_evals(sim_funs, fdr_methods, nreps, 0.1, BiocParallel=FALSE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stratified_methods.R
\name{clfdr}
\alias{clfdr}
\title{clfdr: Cai's local fdr based method}
\usage{
clfdr(unadj_p, groups, alpha, lfdr_estimation = "fdrtool")
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{groups}{Factor to which different hypotheses belong}

\item{alpha}{Significance level at which to apply method}

\item{lfdr_estimation}{Method used to estimate the loca fdr, defaults to "fdrtool"}
}
\value{
Clfdr multiple testing object
}
\description{
clfdr: Cai's local fdr based method
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     sim_df$group <- groups_by_filter(sim_df$filterstat, 20)
     obj <- clfdr(sim_df$pvalue, sim_df$group, .1)
     sum(rejected_hypotheses(obj))

}
\references{
Cai, T. Tony, and Wenguang Sun. "Simultaneous testing of grouped hypotheses: Finding needles in multiple haystacks." 
          Journal of the American Statistical Association 104.488 (2009).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulations.R
\name{wasserman_normal_sim}
\alias{wasserman_normal_sim}
\alias{wasserman_normal_sim_fun}
\title{Normal simulation: Covariate is effect size under alternative}
\usage{
wasserman_normal_sim(m, pi0, xi_min, xi_max, seed = NULL)

wasserman_normal_sim_fun(m, pi0, xi_min, xi_max)
}
\arguments{
\item{m}{Integer, total number of hypotheses}

\item{pi0}{Numeric, proportion of null hypotheses}

\item{xi_min, xi_max}{Numeric, covariates are drawn as uniform on xi_min, xi_max}

\item{seed}{Integer, Random seed to be used for simulation 
(default: NULL, i.e. RNG state will be used as is)}
}
\value{
A data frame containing all information about the simulation experiment
}
\description{
Normal simulation: Covariate is effect size under alternative
}
\section{Functions}{
\itemize{
\item \code{wasserman_normal_sim_fun}: Creates a closure function for a given seed
}}

\examples{
sim_df <- wasserman_normal_sim(20000,0.9, 1, 5)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ddhw_wrappers.R
\name{ihw_naive}
\alias{ihw_naive}
\alias{ihw_ecdf_5fold}
\alias{ihw_5fold}
\alias{ihw_5fold_reg}
\alias{ihw_bonf_5fold_reg}
\alias{ihw_storey_5fold}
\title{IHW wrappers}
\usage{
ihw_naive(unadj_p, filterstat, alpha)

ihw_ecdf_5fold(unadj_p, filterstat, alpha)

ihw_5fold(unadj_p, filterstat, alpha)

ihw_5fold_reg(unadj_p, filterstat, alpha)

ihw_bonf_5fold_reg(unadj_p, filterstat, alpha)

ihw_storey_5fold(unadj_p, filterstat, alpha)
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{filterstat}{Factor to which different hypotheses belong}

\item{alpha}{Significance level at which to apply method}
}
\value{
ihwResult multiple testing object
}
\description{
IHW wrappers
}
\details{
These are closures, which apply IHW with custom
  prespecified parameters. These correspond to interesting
  settings, for which it is convenient to be able to immediately
  call the corresponding functions, rather than having to specify
  parameters each time. Thus they make it easier to benchmark.
  All of these wrappers are defined in 2 lines of code, 
  so the settings pertaining
  to each one can be inspected by typing the functions name into the
  console.
}
\section{Functions}{
\itemize{
\item \code{ihw_naive}: IHW naive

\item \code{ihw_ecdf_5fold}: IHW (E2) with 5 folds

\item \code{ihw_5fold}: IHW (E1-E2) with 5 folds

\item \code{ihw_5fold_reg}: IHW (E1-E2-E3) with 5 folds

\item \code{ihw_bonf_5fold_reg}: IHW-Bonferroni (E1-E2-E3) with 5 folds

\item \code{ihw_storey_5fold}: IHW (E1-E2) with 5 folds and Storey's pi0 estimator
}}

\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     obj <- ihw_5fold(sim_df$pvalue, sim_df$filterstat, .1)
     sum(rejected_hypotheses(obj))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plots.R
\name{pretty_legend}
\alias{pretty_legend}
\title{helper function to create nice legends}
\usage{
pretty_legend(gg, last_vals, xmin, fontsize = 13)
}
\arguments{
\item{gg}{ggplot2 object}

\item{last_vals, }{data frame with columns 
label, colour, last_vals (i.e. place label with colour at y-coordinate last_vals)}

\item{xmin}{Numeric, x axis position at which labels should be placed}

\item{fontsize}{Integer, fontsize}
}
\value{
Another ggplot2 object

     This replaces the default legend of a ggplot2 object. In particular,
   given a ggplot2 object ,it removes the existing legend and then places
   new labels based on the annotation data frame `last_vals` (see parameter description)
   at a given x-coordinate of the original plot.

   This function can be attributed to and is described in more detail in 
   the following blog post:
   http://www.r-bloggers.com/coloring-and-drawing-outside-the-lines-in-ggplot/
}
\description{
helper function to create nice legends
}
\examples{
  library("ggplot2")
  labels  <- c("A","B","C")
  mypoints <- rbind(data.frame(y=1:3, x=1, label=as.factor(labels)),
                     data.frame(y=2:4, x=2, label=as.factor(labels)))
  mycolours <- c("#F8766D","#00BA38","#619CFF")
  gg <- ggplot(mypoints,aes(x=x,y=y,color=label)) + 
               geom_line(size=2) + 
               scale_color_manual(values=mycolours) +
               xlim(c(0,2.2))
  gg
  annotation_df <- data.frame(colour=mycolours, last_vals=2:4, label=labels)
  pretty_legend(gg, annotation_df, 2.1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stratified_methods.R
\name{stratified_bh}
\alias{stratified_bh}
\title{stratified_bh: Stratified Benjamini Hochberg}
\usage{
stratified_bh(unadj_p, groups, alpha)
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{groups}{Factor to which different hypotheses belong}

\item{alpha}{Significance level at which to apply method}
}
\value{
SBH multiple testing object
}
\description{
stratified_bh: Stratified Benjamini Hochberg
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     sim_df$group <- groups_by_filter(sim_df$filterstat, 20)
     obj <- stratified_bh(sim_df$pvalue, sim_df$group, .1)
     sum(rejected_hypotheses(obj))

}
\references{
Sun, Lei, et al. "Stratified false discovery control for large-scale hypothesis testing with application to genome-wide
   association studies." Genetic epidemiology 30.6 (2006): 519-530.

Yoo, Yun J., et al. "Were genome-wide linkage studies a waste of time? Exploiting candidate regions within genome-wide
   association studies." Genetic epidemiology 34.2 (2010): 107-118.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simple_methods.R
\name{storey_qvalue}
\alias{storey_qvalue}
\title{storey_qvalue: Wrapper for Storey's qvalue package}
\usage{
storey_qvalue(unadj_p, alpha)
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{alpha}{Significance level at which to apply method}
}
\value{
StoreyQValue multiple testing object
}
\description{
storey_qvalue: Wrapper for Storey's qvalue package
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     obj <- storey_qvalue(sim_df$pvalue, .1)
     sum(rejected_hypotheses(obj))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/covariate_methods.R
\name{continuous_wrap}
\alias{continuous_wrap}
\title{Benchmarking wrapper: Given a multiple testing method, convert it so that it takes
  a simulation object (see simulation function) and a nominal level alpha
  as inputs}
\usage{
continuous_wrap(mt_method, nbins = 20)
}
\arguments{
\item{mt_method}{Multiple testing method (e.g. a function such as gbh or ddhf)}

\item{nbins}{Integer, number of equally sized bins into which to stratify hypotheses}
}
\value{
A new multiple testing function which has an
          interface of the form f(sim_data_frame, alpha)
}
\description{
Benchmarking wrapper: Given a multiple testing method, convert it so that it takes
  a simulation object (see simulation function) and a nominal level alpha
  as inputs
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     sim_df$group <- groups_by_filter(sim_df$filterstat, 20)
     obj <- tst_gbh(sim_df$pvalue, sim_df$group, .1)
     sum(rejected_hypotheses(obj))

     tst_gbh_continuous <- continuous_wrap(tst_gbh)
     obj2 <- tst_gbh_continuous(sim_df, .1)
     sum(rejected_hypotheses(obj2))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simple_methods.R
\name{bonf}
\alias{bonf}
\title{bonf: Wrapper for Bonferroni}
\usage{
bonf(unadj_p, alpha)
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{alpha}{Significance level at which to apply method}
}
\value{
Bonferroni multiple testing object
}
\description{
bonf: Wrapper for Bonferroni
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     obj <- bonf(sim_df$pvalue, .1)
     sum(rejected_hypotheses(obj))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pi0_estimators.R
\name{tst_pi0_est}
\alias{tst_pi0_est}
\title{TST (Two-Step) pi0 estimator}
\usage{
tst_pi0_est(pvalue, alpha)
}
\arguments{
\item{pvalue}{Numeric vector of unadjusted p-values.}

\item{alpha}{Nominal level for applying the TST procedure}
}
\value{
estimated proportion of null hypotheses (pi0)
}
\description{
TST (Two-Step) pi0 estimator
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     tst_pi0_est(sim_df$pvalue, .1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulations.R
\name{wasserman_normal_prds_sim}
\alias{wasserman_normal_prds_sim}
\alias{wasserman_normal_prds_sim_fun}
\title{Normal PRDS simulation: Covariate is effect size under alternative, there are latent factors
     driving PRDS correlations among hypotheses}
\usage{
wasserman_normal_prds_sim(
  m,
  pi0,
  rho = 0,
  latent_factors = 1,
  xi_min = 0,
  xi_max = 2.5,
  seed = NULL
)

wasserman_normal_prds_sim_fun(
  m,
  pi0,
  rho = 0,
  latent_factors = 1,
  xi_min = 0,
  xi_max = 2.5
)
}
\arguments{
\item{m}{Integer, total number of hypotheses}

\item{pi0}{Numeric, proportion of null hypotheses}

\item{rho}{Numeric, correlation between z-scores of hypotheses driven by same latent factor}

\item{latent_factors}{Integer, number of latent factors driving the correlations}

\item{xi_min, xi_max}{Numeric, covariates are drawn as uniform on xi_min, xi_max}

\item{seed}{Integer, Random seed to be used for simulation 
(default: NULL, i.e. RNG state will be used as is)}
}
\value{
A data frame containing all information about the simulation experiment
}
\description{
Normal PRDS simulation: Covariate is effect size under alternative, there are latent factors
     driving PRDS correlations among hypotheses
}
\section{Functions}{
\itemize{
\item \code{wasserman_normal_prds_sim_fun}: Creates a closure function for a given seed
}}

\examples{
sim_df <- wasserman_normal_prds_sim(20000,0.9, rho=0.1)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simulations.R
\name{du_ttest_sim}
\alias{du_ttest_sim}
\alias{du_ttest_sim_fun}
\title{t-test simulation: Simulate rowwise t-tests}
\usage{
du_ttest_sim(
  m,
  pi0,
  effect_size,
  n_samples = 10,
  uninformative_filter = FALSE,
  seed = NULL
)

du_ttest_sim_fun(
  m,
  pi0,
  effect_size,
  n_samples = 10,
  uninformative_filter = FALSE
)
}
\arguments{
\item{m}{Integer, total number of hypotheses}

\item{pi0}{Numeric, proportion of null hypotheses}

\item{effect_size}{Numeric, the alternative hypotheses will be}

\item{n_samples}{Integer, number of samples for t-test, i.e.
the comparison will be n_samples/2 vs n_samples/2}

\item{uninformative_filter}{Boolean, if TRUE will generate uniformly distributed filter statistic
Otherwise will use the pooled standard deviations}

\item{seed}{Integer, Random seed to be used for simulation 
(default: NULL, i.e. RNG state will be used as is)}
}
\value{
A data frame containing all information about the simulation experiment
}
\description{
t-test simulation: Simulate rowwise t-tests
}
\section{Functions}{
\itemize{
\item \code{du_ttest_sim_fun}: Creates a closure function for a given seed
}}

\examples{
sim_df <- du_ttest_sim(20000,0.95, 1.5)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/simple_methods.R
\name{bh}
\alias{bh}
\title{bh: Wrapper for Benjamini Hochberg}
\usage{
bh(unadj_p, alpha)
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{alpha}{Significance level at which to apply method}
}
\value{
BH multiple testing object
}
\description{
bh: Wrapper for Benjamini Hochberg
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     obj <- bh(sim_df$pvalue, .1)
     sum(rejected_hypotheses(obj))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pi0_estimators.R
\name{lsl_pi0_est}
\alias{lsl_pi0_est}
\title{LSL (Least-Slope) pi0 estimator}
\usage{
lsl_pi0_est(pvalue)
}
\arguments{
\item{pvalue}{Numeric vector of unadjusted p-values.}
}
\value{
estimated proportion of null hypotheses (pi0)
}
\description{
LSL (Least-Slope) pi0 estimator
}
\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     lsl_pi0_est(sim_df$pvalue)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stratified_methods.R
\name{gbh}
\alias{gbh}
\alias{tst_gbh}
\alias{lsl_gbh}
\title{gbh: Grouped Benjamini Hochberg}
\usage{
gbh(unadj_p, groups, alpha, method = "TST", pi0_global = "weighted_average")

tst_gbh(unadj_p, groups, alpha, ...)

lsl_gbh(unadj_p, groups, alpha, ...)
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{groups}{Factor to which different hypotheses belong}

\item{alpha}{Significance level at which to apply method}

\item{method}{What pi0 estimator should be used (available "TST","LSL")}

\item{pi0_global}{GBH requires also a pi0 estimate for the marginal p-value distribution. Can either apply pi0 estimation method to
all p-values (pi0_global="global") or use a weigted averarage (pi0_global="weighted_average") of the pi0 estimates within each stratum.
This is not explicitly stated in the paper, but based on a reproduction of their paper figures it seems to be the weighted_average.}

\item{...}{Additional arguments passed from tst_gbh/lsl_gbh to gbh}
}
\value{
GBH multiple testing object
}
\description{
gbh: Grouped Benjamini Hochberg

tst_gbh: wrapper for gbh with method="TST"
lsl_gbh: wrapper for gbh with method="LSL"
}
\section{Functions}{
\itemize{
\item \code{tst_gbh}: Wrapper of GBH with TST pi0 estimator

\item \code{lsl_gbh}: Wrapper of GBH with LSL pi0 estimator
}}

\examples{
     sim_df <- du_ttest_sim(20000,0.95, 1.5)
     sim_df$group <- groups_by_filter(sim_df$filterstat, 20)
     obj <- tst_gbh(sim_df$pvalue, sim_df$group, .1)
     sum(rejected_hypotheses(obj))

}
\references{
Hu, James X., Hongyu Zhao, and Harrison H. Zhou. "False discovery rate control with groups." 
        Journal of the American Statistical Association 105.491 (2010).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/covariate_methods.R
\name{scott_fdrreg}
\alias{scott_fdrreg}
\title{scott_fdrreg: Wrapper for FDR regression (https://github.com/jgscott/FDRreg)}
\usage{
scott_fdrreg(unadj_p, filterstat, alpha, df = 3, lambda = 0.01)
}
\arguments{
\item{unadj_p}{Numeric vector of unadjusted p-values.}

\item{filterstat}{Factor to which different hypotheses belong}

\item{alpha}{Significance level at which to apply method}

\item{df}{Degrees of freedom for B-slines}

\item{lambda}{Ridge regularization parameter}
}
\value{
FDRreg multiple testing object
}
\description{
scott_fdrreg: Wrapper for FDR regression (https://github.com/jgscott/FDRreg)
}
\references{
James G. Scott, Ryan C. Kelly, Matthew A. Smith, Pengcheng Zhou, and Robert E. Kass. 
        "False discovery rate regression: application to neural synchrony detection in primary visual cortex." 
        Journal of the American Statistical Association (2015).
}
